static char usage[]="\n\
Usage:\n\
\n\
  blend [gen-opt] [par-opt] [ PARFILE.par | PARFILE.bin ] [PCHFILE.pch] \\\n\
    [mol1-opt] { FILE1 | FILE1.mol | FILE1.che }     \\\n\
    [[mol2-opt] { FILE2 | FILE2.mol | FILE2.che }]\n\
\n\
Numeric options are without space in DECIMAL, 0OCTAL or 0xHEX: -v259 = -v0x103\n\
";

static char help[]="\
More help: (g)en-opt  (p)ar-opt+files  mol-(f)iles  (m)ol-opt  e(x)tra mol-opt ";

static char gen_opt[]="\n\
General options:\n\
\n\
 -o FILE[.EXT] batch mode, the output is readable by cook, [default .EXT=.ble]\n"
#ifdef SCR
" -s | -s#  scrolling enabled: buffer = 31 | # kB\n"
#endif
" -v#       verbosity, 0=minimum, then sum of:\n\
           1=list sites and their parameters\n\
           2=list bonded terms\n\
           4=verbose (info on topological analysis, selection of terms, etc.)\n\
           8=list used pair site-site parameter terms\n"
#ifdef POLAR
"           16=self field convergence\n"
#endif
"           256=list all pair site-site parameter terms\n\
           [interactive default = -v0, batch default = -v3]\n\
           NB: at least -v3 is needed to generate a cook-readable output\n\
 -l#       input line buffer (default=256)\n\
 -z#       random number seed (default=time)\n\
 -_#       output precision of force constants (default=6)\n\
 -_-#      as above and fix small charge errors to get a multiple of e\n"
#ifdef DOS
" -g#       graphics on (minimization show by # steps), -g0=off\n"
#endif
#ifdef X11
" -g[#]     graphics on (minimization show by # steps)\n"
" \"-g[#] XGEOM\"\n\
 -g[#]_XGEOM  with X geometry (e.g., \"-g5 400x300-5+5\")\n"
#endif
" -g-#      minimization protocol printed by # steps (default = guess)\n"
;

static char par_opt[]="\n\
Parameter options:\n\
\n\
 PARFILE.par    parameter file (normally defined in molecule), in text format\n\
 PARFILE.bin    its binary image\n\
 -b PARFILE.par create FILE.bin from FILE.par\n\
 -a#            scale all angle force const #% times\n\
 -a-#           set all angle force const to # kcal/mol\n\
 -a0            constrain all angles (steepest descent only)\n\
 -b#            scale all bond force const #% times\n\
 -b-#           set all bond force const to # kcal/mol/A^2\n\
 -b0            constrain all bonds (steepest descent only)\n\
 -i#            calc. max. angle potential energies and warn if > # kcal/mol\n\
 -x[RRR]EEE     Lennard-Jones scaling; R in 1/1000, E in % (default=-x1000100)\n\
 -x-DDD         density scaled x=exp(DDD/1000) times (R: x^-1/3 and E: x)\n\
 PCHFILE.pch    partial charge assignment file\n\
 REAFILE.rea    chemical reaction file\n\
 -f1/-f2/-f3    fabricate bonds/angles/both (if missing in FILE.par)\n"
#ifdef POLAR
"\nPOLAR options:\n\
\n\
 -|#   overrides polar in the par-file force field (also -\\#)\n\
 -^%   polarizability multiplication factor (df.= 100%, also -~%)\n\
 -]%   saturation energy multiplication factor (df.=100%, also -}%)\n\
 -@%   shell (aux charge for polariz.dip.) multipl. f. (df.=100%, output only)\n"
#endif
;

static char mol_opt[]="\n\
Molecule options:\n\
 -c#       chiralities: 0=check 1=calculate unknown 2=calculate all\n\
 -d%       add bond if dist<% equil. (use 110-120), -d-% erase all bonds first\n\
 -e        edit mol-file (not if 2D input)\n\
 -e%       2D input scaling factor (df.=100%), %<0: flat 2D, %>0: waved\n\
 -h | -h#  constraint bond angles with H | light atoms<#a.u. (#<0: don\'t remove\n\
 -j        read constraint file FILE.jet              | overdetermined constr.)\n\
 -k[-]#    keep (freeze) while minimize: 0=none  1=*marked  2=all but missing\n\
           3=auto 1|2 (df.)  -:single always free  4/8=read FILE.keep/.mark\n\
 -m | -m#  minimize energy (# conjg.grad.steps, #<0 +steep.desc.), df.=-m-100\n\
 -n#       export number of molecules N (negative: split mol., abs config)\n\
 -p#       write plb and gol files w. #% of vdW radii, #<0: rev.endian (df.=70)\n\
 -q%       charge multipl. factor in % (df.=100%)\n\
 -r#       read config. option:  0=try what\'s available (default)\n\
            1=random   2=2D from .che   3=3D from .3db   13=3D from .3dt\n\
            4=from .plb (1st frame, see e(x)tra mol-opt) -3,-4:+reverse endian\n\
            6=alpha-helix (5=old vers.)  -r7:phi:psi:omega=peptide chain\n\
 -t#       range for cutoff switch function [#-1,#+1], -t-12345 [12.3,12.3+4.5]\n\
 -u#       print # pairs with max energy  -u-# min energy\n\
 -w#       write (default=do not) SUM: 1=FILE.3db (obsolete; -1=rev.endian)\n\
           2..9=FILE.3dt (ascii, # digits)  40=FILE.atm  80=FILE.cfg (for cook)\n\
 -w##[:#]  10=PDB FILE.pdb [:Hstyle]  20=derive from id  30=auto 10|20\n\
 -y#       SUM: 1=center before  2=after  4=all r>0  8=w.box  16=LJsigma=0 [3]";

static char extra_mol_opt[]="\n\
Special molecule options:\n\
 -[#   (w. -n-1) reorder mol. of # sites (incr. mass)  -[3: TIP3 water = HHO\n\
\n\
 -r4:#     read frame # from .plb (1=1st, -1=last)\n\
 -r4:#:#:#[:FILE] (A E G R) use frames #:#:#=FROM:TO:BY [1:-1:1] and plb-FILE\n\
\n\
 -p  | -p% write playback files (atom radii=70%|% RvdW)\n\
 -p-1|-p-% as above + reverse endian\n\
\n\
 -A        generate FILE.ang of independent internal coordinates\n\
 -C#       ref.atom (dipole,quadrup,vir): -1=Z-centroid -2=CM -3=center [-1]\n\
 -D        generate FILE.msd of mean square displacements\n\
 -E@       essential dynamics, @=atoms: All Heavy Calpha Backbone\n\
 -F#       (-N -E) # of frames in each plb file, #>0:cos, #<0:lin [7]\n\
 -G        eigenvalues of inertia matrix\n\
 -I#       max # of SHAKE iterations (-a0,-b0)"
#ifdef POLAR
"; POLAR: of self-field iterations"
#endif
"\n -J#       (-N -E) accuracy for Jacobi method, sqrt(#)*0.2 for cfg matching\n\
 -M#       (-N -E) amplitude of motion in plb [1]; -N -M-#: ns-based guess\n\
 -N#       normal mode frequencies, #=dr for num.deriv. [1e-5A]\n\
 -P#       (-N -E) # of plb files (most significant eigenval.) for normal mode\n\
           and ess.dyn. visualization; #<0: least significant [0]\n\
 -R#       core size (where U->infty) for the 2nd virial coefficient, from -C\n\
 -T#       temperature [K] for the 2nd virial coefficient and export to .cfg\n\
 -V#       2nd virial coeff: # of sampling points; #<0: +inversion (for dip!)\n\
";

static char mol_files[]="\n\
mol-files:\n\
\n\
FILE.mol   molecule file (obtained by pdb, molcfg, blend...)\n\
FILE.che   molecule in chemical format\n\
FILE       try FILE.mol first, if does not exist then FILE.che\n\
FILE.gol   colors and sizes of atoms (used by show)\n\
FILE.plb   playback file, may contain more frames (preferred format)\n\
FILE.2db   2D configuration, binary\n\
FILE.2dt   2D configuration, text (x,y)\n\
FILE.3db   3D configuration, binary\n\
FILE.3dt   3D configuration, text (x,y,z)\n\
FILE.atm   3D configuration with atom info (for Gaussian etc.)\n\
FILE.pdb   PDB format\n\
";
