struct utf8_s {
  char *U;
  char *utf;
  char *eq;
  unsigned short h;
  char *name;
} utftab[]= {  
{"U+0020"," ","",0x20,"SPACE"},
{"U+0021","!","",0x21,"EXCLAMATION MARK"},
{"U+0022","\"","",0x22,"QUOTATION MARK"},
{"U+0023","#","",0x23,"NUMBER SIGN"},
{"U+0024","$","",0x24,"DOLLAR SIGN"},
{"U+0025","%","",0x25,"PERCENT SIGN"},
{"U+0026","&","",0x26,"AMPERSAND"},
{"U+0027","\'","",0x27,"APOSTROPHE"},
{"U+0028","(","",0x28,"LEFT PARENTHESIS"},
{"U+0029",")","",0x29,"RIGHT PARENTHESIS"},
{"U+002A","*","",0x2a,"ASTERISK"},
{"U+002B","+","",0x2b,"PLUS SIGN"},
{"U+002C",",","",0x2c,"COMMA"},
{"U+002D","-","",0x2d,"HYPHEN-MINUS"},
{"U+002E",".","",0x2e,"FULL STOP"},
{"U+002F","/","",0x2f,"SOLIDUS"},
{"U+0030","0","",0x30,"DIGIT ZERO"},
{"U+0031","1","",0x31,"DIGIT ONE"},
{"U+0032","2","",0x32,"DIGIT TWO"},
{"U+0033","3","",0x33,"DIGIT THREE"},
{"U+0034","4","",0x34,"DIGIT FOUR"},
{"U+0035","5","",0x35,"DIGIT FIVE"},
{"U+0036","6","",0x36,"DIGIT SIX"},
{"U+0037","7","",0x37,"DIGIT SEVEN"},
{"U+0038","8","",0x38,"DIGIT EIGHT"},
{"U+0039","9","",0x39,"DIGIT NINE"},
{"U+003A",":","",0x3a,"COLON"},
{"U+003B",";","",0x3b,"SEMICOLON"},
{"U+003C","<","",0x3c,"LESS-THAN SIGN"},
{"U+003D","=","",0x3d,"EQUALS SIGN"},
{"U+003E",">","",0x3e,"GREATER-THAN SIGN"},
{"U+003F","?","",0x3f,"QUESTION MARK"},
{"U+0040","@","",0x40,"COMMERCIAL AT"},
{"U+0041","A","",0x41,"LATIN CAPITAL LETTER A"},
{"U+0042","B","",0x42,"LATIN CAPITAL LETTER B"},
{"U+0043","C","",0x43,"LATIN CAPITAL LETTER C"},
{"U+0044","D","",0x44,"LATIN CAPITAL LETTER D"},
{"U+0045","E","",0x45,"LATIN CAPITAL LETTER E"},
{"U+0046","F","",0x46,"LATIN CAPITAL LETTER F"},
{"U+0047","G","",0x47,"LATIN CAPITAL LETTER G"},
{"U+0048","H","",0x48,"LATIN CAPITAL LETTER H"},
{"U+0049","I","",0x49,"LATIN CAPITAL LETTER I"},
{"U+004A","J","",0x4a,"LATIN CAPITAL LETTER J"},
{"U+004B","K","",0x4b,"LATIN CAPITAL LETTER K"},
{"U+004C","L","",0x4c,"LATIN CAPITAL LETTER L"},
{"U+004D","M","",0x4d,"LATIN CAPITAL LETTER M"},
{"U+004E","N","",0x4e,"LATIN CAPITAL LETTER N"},
{"U+004F","O","",0x4f,"LATIN CAPITAL LETTER O"},
{"U+0050","P","",0x50,"LATIN CAPITAL LETTER P"},
{"U+0051","Q","",0x51,"LATIN CAPITAL LETTER Q"},
{"U+0052","R","",0x52,"LATIN CAPITAL LETTER R"},
{"U+0053","S","",0x53,"LATIN CAPITAL LETTER S"},
{"U+0054","T","",0x54,"LATIN CAPITAL LETTER T"},
{"U+0055","U","",0x55,"LATIN CAPITAL LETTER U"},
{"U+0056","V","",0x56,"LATIN CAPITAL LETTER V"},
{"U+0057","W","",0x57,"LATIN CAPITAL LETTER W"},
{"U+0058","X","",0x58,"LATIN CAPITAL LETTER X"},
{"U+0059","Y","",0x59,"LATIN CAPITAL LETTER Y"},
{"U+005A","Z","",0x5a,"LATIN CAPITAL LETTER Z"},
{"U+005B","[","",0x5b,"LEFT SQUARE BRACKET"},
{"U+005C","\\","",0x5c,"REVERSE SOLIDUS"},
{"U+005D","]","",0x5d,"RIGHT SQUARE BRACKET"},
{"U+005E","^","",0x5e,"CIRCUMFLEX ACCENT"},
{"U+005F","_","",0x5f,"LOW LINE"},
{"U+0060","`","",0x60,"GRAVE ACCENT"},
{"U+0061","a","",0x61,"LATIN SMALL LETTER A"},
{"U+0062","b","",0x62,"LATIN SMALL LETTER B"},
{"U+0063","c","",0x63,"LATIN SMALL LETTER C"},
{"U+0064","d","",0x64,"LATIN SMALL LETTER D"},
{"U+0065","e","",0x65,"LATIN SMALL LETTER E"},
{"U+0066","f","",0x66,"LATIN SMALL LETTER F"},
{"U+0067","g","",0x67,"LATIN SMALL LETTER G"},
{"U+0068","h","",0x68,"LATIN SMALL LETTER H"},
{"U+0069","i","",0x69,"LATIN SMALL LETTER I"},
{"U+006A","j","",0x6a,"LATIN SMALL LETTER J"},
{"U+006B","k","",0x6b,"LATIN SMALL LETTER K"},
{"U+006C","l","",0x6c,"LATIN SMALL LETTER L"},
{"U+006D","m","",0x6d,"LATIN SMALL LETTER M"},
{"U+006E","n","",0x6e,"LATIN SMALL LETTER N"},
{"U+006F","o","",0x6f,"LATIN SMALL LETTER O"},
{"U+0070","p","",0x70,"LATIN SMALL LETTER P"},
{"U+0071","q","",0x71,"LATIN SMALL LETTER Q"},
{"U+0072","r","",0x72,"LATIN SMALL LETTER R"},
{"U+0073","s","",0x73,"LATIN SMALL LETTER S"},
{"U+0074","t","",0x74,"LATIN SMALL LETTER T"},
{"U+0075","u","",0x75,"LATIN SMALL LETTER U"},
{"U+0076","v","",0x76,"LATIN SMALL LETTER V"},
{"U+0077","w","",0x77,"LATIN SMALL LETTER W"},
{"U+0078","x","",0x78,"LATIN SMALL LETTER X"},
{"U+0079","y","",0x79,"LATIN SMALL LETTER Y"},
{"U+007A","z","",0x7a,"LATIN SMALL LETTER Z"},
{"U+007B","{","",0x7b,"LEFT CURLY BRACKET"},
{"U+007C","|","",0x7c,"VERTICAL LINE"},
{"U+007D","}","",0x7d,"RIGHT CURLY BRACKET"},
{"U+007E","~","",0x7e,"TILDE"},
{"U+00A0"," "," ",0xc2a0,"NO-BREAK SPACE"},
{"U+00A1","¡","!",0xc2a1,"INVERTED EXCLAMATION MARK"},
{"U+00A2","¢","c",0xc2a2,"CENT SIGN"},
{"U+00A3","£","L",0xc2a3,"POUND SIGN"},
{"U+00A4","¤","$",0xc2a4,"CURRENCY SIGN"},
{"U+00A5","¥","Y",0xc2a5,"YEN SIGN"},
{"U+00A6","¦","|",0xc2a6,"BROKEN BAR"},
{"U+00A7","§","S",0xc2a7,"SECTION SIGN"},
{"U+00A8","¨","",0xc2a8,"DIAERESIS"},
{"U+00A9","©","(C)",0xc2a9,"COPYRIGHT SIGN"},
{"U+00AA","ª","a",0xc2aa,"FEMININE ORDINAL INDICATOR"},
{"U+00AB","«","<<",0xc2ab,"LEFT-POINTING DOUBLE ANGLE QUOTATION MARK"},
{"U+00AC","¬","^",0xc2ac,"NOT SIGN"},
{"U+00AD","­","-",0xc2ad,"SOFT HYPHEN"},
{"U+00AE","®","(R)",0xc2ae,"REGISTERED SIGN"},
{"U+00AF","¯","-",0xc2af,"MACRON"},
{"U+00B0","°","o",0xc2b0,"DEGREE SIGN"},
{"U+00B1","±","+-",0xc2b1,"PLUS-MINUS SIGN"},
{"U+00B2","²","2",0xc2b2,"SUPERSCRIPT TWO"},
{"U+00B3","³","3",0xc2b3,"SUPERSCRIPT THREE"},
{"U+00B4","´","\'",0xc2b4,"ACUTE ACCENT"},
{"U+00B5","µ","mu",0xc2b5,"MICRO SIGN"},
{"U+00B6","¶","P",0xc2b6,"PILCROW SIGN"},
{"U+00B7","·",".",0xc2b7,"MIDDLE DOT"},
{"U+00B8","¸","",0xc2b8,"CEDILLA"},
{"U+00B9","¹","1",0xc2b9,"SUPERSCRIPT ONE"},
{"U+00BA","º","o",0xc2ba,"MASCULINE ORDINAL INDICATOR"},
{"U+00BB","»",">>",0xc2bb,"RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK"},
{"U+00BC","¼","14",0xc2bc,"VULGAR FRACTION ONE QUARTER"},
{"U+00BD","½","12",0xc2bd,"VULGAR FRACTION ONE HALF"},
{"U+00BE","¾","34",0xc2be,"VULGAR FRACTION THREE QUARTERS"},
{"U+00BF","¿","?",0xc2bf,"INVERTED QUESTION MARK"},
{"U+00C0","À","A",0xc380,"LATIN CAPITAL LETTER A WITH GRAVE"},
{"U+00C1","Á","A",0xc381,"LATIN CAPITAL LETTER A WITH ACUTE"},
{"U+00C2","Â","A",0xc382,"LATIN CAPITAL LETTER A WITH CIRCUMFLEX"},
{"U+00C3","Ã","A",0xc383,"LATIN CAPITAL LETTER A WITH TILDE"},
{"U+00C4","Ä","A",0xc384,"LATIN CAPITAL LETTER A WITH DIAERESIS"},
{"U+00C5","Å","A",0xc385,"LATIN CAPITAL LETTER A WITH RING ABOVE"},
{"U+00C6","Æ","AE",0xc386,"LATIN CAPITAL LETTER AE"},
{"U+00C7","Ç","C",0xc387,"LATIN CAPITAL LETTER C WITH CEDILLA"},
{"U+00C8","È","E",0xc388,"LATIN CAPITAL LETTER E WITH GRAVE"},
{"U+00C9","É","E",0xc389,"LATIN CAPITAL LETTER E WITH ACUTE"},
{"U+00CA","Ê","E",0xc38a,"LATIN CAPITAL LETTER E WITH CIRCUMFLEX"},
{"U+00CB","Ë","E",0xc38b,"LATIN CAPITAL LETTER E WITH DIAERESIS"},
{"U+00CC","Ì","I",0xc38c,"LATIN CAPITAL LETTER I WITH GRAVE"},
{"U+00CD","Í","I",0xc38d,"LATIN CAPITAL LETTER I WITH ACUTE"},
{"U+00CE","Î","I",0xc38e,"LATIN CAPITAL LETTER I WITH CIRCUMFLEX"},
{"U+00CF","Ï","I",0xc38f,"LATIN CAPITAL LETTER I WITH DIAERESIS"},
{"U+00D0","Ð","D",0xc390,"LATIN CAPITAL LETTER ETH"},
{"U+00D1","Ñ","N",0xc391,"LATIN CAPITAL LETTER N WITH TILDE"},
{"U+00D2","Ò","O",0xc392,"LATIN CAPITAL LETTER O WITH GRAVE"},
{"U+00D3","Ó","O",0xc393,"LATIN CAPITAL LETTER O WITH ACUTE"},
{"U+00D4","Ô","O",0xc394,"LATIN CAPITAL LETTER O WITH CIRCUMFLEX"},
{"U+00D5","Õ","O",0xc395,"LATIN CAPITAL LETTER O WITH TILDE"},
{"U+00D6","Ö","O",0xc396,"LATIN CAPITAL LETTER O WITH DIAERESIS"},
{"U+00D7","×","x",0xc397,"MULTIPLICATION SIGN"},
{"U+00D8","Ø","O",0xc398,"LATIN CAPITAL LETTER O WITH STROKE"},
{"U+00D9","Ù","U",0xc399,"LATIN CAPITAL LETTER U WITH GRAVE"},
{"U+00DA","Ú","U",0xc39a,"LATIN CAPITAL LETTER U WITH ACUTE"},
{"U+00DB","Û","U",0xc39b,"LATIN CAPITAL LETTER U WITH CIRCUMFLEX"},
{"U+00DC","Ü","U",0xc39c,"LATIN CAPITAL LETTER U WITH DIAERESIS"},
{"U+00DD","Ý","Y",0xc39d,"LATIN CAPITAL LETTER Y WITH ACUTE"},
{"U+00DE","Þ","b",0xc39e,"LATIN CAPITAL LETTER THORN"},
{"U+00DF","ß","ss",0xc39f,"LATIN SMALL LETTER SHARP S"},
{"U+00E0","à","a",0xc3a0,"LATIN SMALL LETTER A WITH GRAVE"},
{"U+00E1","á","a",0xc3a1,"LATIN SMALL LETTER A WITH ACUTE"},
{"U+00E2","â","a",0xc3a2,"LATIN SMALL LETTER A WITH CIRCUMFLEX"},
{"U+00E3","ã","a",0xc3a3,"LATIN SMALL LETTER A WITH TILDE"},
{"U+00E4","ä","a",0xc3a4,"LATIN SMALL LETTER A WITH DIAERESIS"},
{"U+00E5","å","a",0xc3a5,"LATIN SMALL LETTER A WITH RING ABOVE"},
{"U+00E6","æ","ae",0xc3a6,"LATIN SMALL LETTER AE"},
{"U+00E7","ç","c",0xc3a7,"LATIN SMALL LETTER C WITH CEDILLA"},
{"U+00E8","è","e",0xc3a8,"LATIN SMALL LETTER E WITH GRAVE"},
{"U+00E9","é","e",0xc3a9,"LATIN SMALL LETTER E WITH ACUTE"},
{"U+00EA","ê","e",0xc3aa,"LATIN SMALL LETTER E WITH CIRCUMFLEX"},
{"U+00EB","ë","e",0xc3ab,"LATIN SMALL LETTER E WITH DIAERESIS"},
{"U+00EC","ì","i",0xc3ac,"LATIN SMALL LETTER I WITH GRAVE"},
{"U+00ED","í","i",0xc3ad,"LATIN SMALL LETTER I WITH ACUTE"},
{"U+00EE","î","i",0xc3ae,"LATIN SMALL LETTER I WITH CIRCUMFLEX"},
{"U+00EF","ï","i",0xc3af,"LATIN SMALL LETTER I WITH DIAERESIS"},
{"U+00F0","ð","o",0xc3b0,"LATIN SMALL LETTER ETH"},
{"U+00F1","ñ","n",0xc3b1,"LATIN SMALL LETTER N WITH TILDE"},
{"U+00F2","ò","o",0xc3b2,"LATIN SMALL LETTER O WITH GRAVE"},
{"U+00F3","ó","o",0xc3b3,"LATIN SMALL LETTER O WITH ACUTE"},
{"U+00F4","ô","o",0xc3b4,"LATIN SMALL LETTER O WITH CIRCUMFLEX"},
{"U+00F5","õ","o",0xc3b5,"LATIN SMALL LETTER O WITH TILDE"},
{"U+00F6","ö","o",0xc3b6,"LATIN SMALL LETTER O WITH DIAERESIS"},
{"U+00F7","÷",":",0xc3b7,"DIVISION SIGN"},
{"U+00F8","ø","o",0xc3b8,"LATIN SMALL LETTER O WITH STROKE"},
{"U+00F9","ù","u",0xc3b9,"LATIN SMALL LETTER U WITH GRAVE"},
{"U+00FA","ú","u",0xc3ba,"LATIN SMALL LETTER U WITH ACUTE"},
{"U+00FB","û","u",0xc3bb,"LATIN SMALL LETTER U WITH CIRCUMFLEX"},
{"U+00FC","ü","u",0xc3bc,"LATIN SMALL LETTER U WITH DIAERESIS"},
{"U+00FD","ý","y",0xc3bd,"LATIN SMALL LETTER Y WITH ACUTE"},
{"U+00FE","þ","b",0xc3be,"LATIN SMALL LETTER THORN"},
{"U+00FF","ÿ","y",0xc3bf,"LATIN SMALL LETTER Y WITH DIAERESIS"},
{"U+0100","Ā","A",0xc480,"LATIN CAPITAL LETTER A WITH MACRON"},
{"U+0101","ā","a",0xc481,"LATIN SMALL LETTER A WITH MACRON"},
{"U+0102","Ă","A",0xc482,"LATIN CAPITAL LETTER A WITH BREVE"},
{"U+0103","ă","a",0xc483,"LATIN SMALL LETTER A WITH BREVE"},
{"U+0104","Ą","A",0xc484,"LATIN CAPITAL LETTER A WITH OGONEK"},
{"U+0105","ą","a",0xc485,"LATIN SMALL LETTER A WITH OGONEK"},
{"U+0106","Ć","C",0xc486,"LATIN CAPITAL LETTER C WITH ACUTE"},
{"U+0107","ć","c",0xc487,"LATIN SMALL LETTER C WITH ACUTE"},
{"U+0108","Ĉ","C",0xc488,"LATIN CAPITAL LETTER C WITH CIRCUMFLEX"},
{"U+0109","ĉ","c",0xc489,"LATIN SMALL LETTER C WITH CIRCUMFLEX"},
{"U+010A","Ċ","C",0xc48a,"LATIN CAPITAL LETTER C WITH DOT ABOVE"},
{"U+010B","ċ","c",0xc48b,"LATIN SMALL LETTER C WITH DOT ABOVE"},
{"U+010C","Č","C",0xc48c,"LATIN CAPITAL LETTER C WITH CARON"},
{"U+010D","č","c",0xc48d,"LATIN SMALL LETTER C WITH CARON"},
{"U+010E","Ď","D",0xc48e,"LATIN CAPITAL LETTER D WITH CARON"},
{"U+010F","ď","d",0xc48f,"LATIN SMALL LETTER D WITH CARON"},
{"U+0110","Đ","D",0xc490,"LATIN CAPITAL LETTER D WITH STROKE"},
{"U+0111","đ","d",0xc491,"LATIN SMALL LETTER D WITH STROKE"},
{"U+0112","Ē","E",0xc492,"LATIN CAPITAL LETTER E WITH MACRON"},
{"U+0113","ē","e",0xc493,"LATIN SMALL LETTER E WITH MACRON"},
{"U+0114","Ĕ","E",0xc494,"LATIN CAPITAL LETTER E WITH BREVE"},
{"U+0115","ĕ","e",0xc495,"LATIN SMALL LETTER E WITH BREVE"},
{"U+0116","Ė","E",0xc496,"LATIN CAPITAL LETTER E WITH DOT ABOVE"},
{"U+0117","ė","e",0xc497,"LATIN SMALL LETTER E WITH DOT ABOVE"},
{"U+0118","Ę","E",0xc498,"LATIN CAPITAL LETTER E WITH OGONEK"},
{"U+0119","ę","e",0xc499,"LATIN SMALL LETTER E WITH OGONEK"},
{"U+011A","Ě","E",0xc49a,"LATIN CAPITAL LETTER E WITH CARON"},
{"U+011B","ě","e",0xc49b,"LATIN SMALL LETTER E WITH CARON"},
{"U+011C","Ĝ","G",0xc49c,"LATIN CAPITAL LETTER G WITH CIRCUMFLEX"},
{"U+011D","ĝ","g",0xc49d,"LATIN SMALL LETTER G WITH CIRCUMFLEX"},
{"U+011E","Ğ","G",0xc49e,"LATIN CAPITAL LETTER G WITH BREVE"},
{"U+011F","ğ","g",0xc49f,"LATIN SMALL LETTER G WITH BREVE"},
{"U+0120","Ġ","G",0xc4a0,"LATIN CAPITAL LETTER G WITH DOT ABOVE"},
{"U+0121","ġ","g",0xc4a1,"LATIN SMALL LETTER G WITH DOT ABOVE"},
{"U+0122","Ģ","G",0xc4a2,"LATIN CAPITAL LETTER G WITH CEDILLA"},
{"U+0123","ģ","g",0xc4a3,"LATIN SMALL LETTER G WITH CEDILLA"},
{"U+0124","Ĥ","H",0xc4a4,"LATIN CAPITAL LETTER H WITH CIRCUMFLEX"},
{"U+0125","ĥ","h",0xc4a5,"LATIN SMALL LETTER H WITH CIRCUMFLEX"},
{"U+0126","Ħ","H",0xc4a6,"LATIN CAPITAL LETTER H WITH STROKE"},
{"U+0127","ħ","h",0xc4a7,"LATIN SMALL LETTER H WITH STROKE"},
{"U+0128","Ĩ","I",0xc4a8,"LATIN CAPITAL LETTER I WITH TILDE"},
{"U+0129","ĩ","i",0xc4a9,"LATIN SMALL LETTER I WITH TILDE"},
{"U+012A","Ī","I",0xc4aa,"LATIN CAPITAL LETTER I WITH MACRON"},
{"U+012B","ī","i",0xc4ab,"LATIN SMALL LETTER I WITH MACRON"},
{"U+012C","Ĭ","I",0xc4ac,"LATIN CAPITAL LETTER I WITH BREVE"},
{"U+012D","ĭ","i",0xc4ad,"LATIN SMALL LETTER I WITH BREVE"},
{"U+012E","Į","I",0xc4ae,"LATIN CAPITAL LETTER I WITH OGONEK"},
{"U+012F","į","i",0xc4af,"LATIN SMALL LETTER I WITH OGONEK"},
{"U+0130","İ","I",0xc4b0,"LATIN CAPITAL LETTER I WITH DOT ABOVE"},
{"U+0131","ı","i",0xc4b1,"LATIN SMALL LETTER DOTLESS I"},
{"U+0132","Ĳ","IJ",0xc4b2,"LATIN CAPITAL LIGATURE IJ"},
{"U+0133","ĳ","ij",0xc4b3,"LATIN SMALL LIGATURE IJ"},
{"U+0134","Ĵ","J",0xc4b4,"LATIN CAPITAL LETTER J WITH CIRCUMFLEX"},
{"U+0135","ĵ","j",0xc4b5,"LATIN SMALL LETTER J WITH CIRCUMFLEX"},
{"U+0136","Ķ","K",0xc4b6,"LATIN CAPITAL LETTER K WITH CEDILLA"},
{"U+0137","ķ","k",0xc4b7,"LATIN SMALL LETTER K WITH CEDILLA"},
{"U+0138","ĸ","k",0xc4b8,"LATIN SMALL LETTER KRA"},
{"U+0139","Ĺ","L",0xc4b9,"LATIN CAPITAL LETTER L WITH ACUTE"},
{"U+013A","ĺ","l",0xc4ba,"LATIN SMALL LETTER L WITH ACUTE"},
{"U+013B","Ļ","L",0xc4bb,"LATIN CAPITAL LETTER L WITH CEDILLA"},
{"U+013C","ļ","l",0xc4bc,"LATIN SMALL LETTER L WITH CEDILLA"},
{"U+013D","Ľ","L",0xc4bd,"LATIN CAPITAL LETTER L WITH CARON"},
{"U+013E","ľ","l",0xc4be,"LATIN SMALL LETTER L WITH CARON"},
{"U+013F","Ŀ","L",0xc4bf,"LATIN CAPITAL LETTER L WITH MIDDLE DOT"},
{"U+0140","ŀ","l",0xc580,"LATIN SMALL LETTER L WITH MIDDLE DOT"},
{"U+0141","Ł","L",0xc581,"LATIN CAPITAL LETTER L WITH STROKE"},
{"U+0142","ł","l",0xc582,"LATIN SMALL LETTER L WITH STROKE"},
{"U+0143","Ń","N",0xc583,"LATIN CAPITAL LETTER N WITH ACUTE"},
{"U+0144","ń","n",0xc584,"LATIN SMALL LETTER N WITH ACUTE"},
{"U+0145","Ņ","N",0xc585,"LATIN CAPITAL LETTER N WITH CEDILLA"},
{"U+0146","ņ","n",0xc586,"LATIN SMALL LETTER N WITH CEDILLA"},
{"U+0147","Ň","N",0xc587,"LATIN CAPITAL LETTER N WITH CARON"},
{"U+0148","ň","n",0xc588,"LATIN SMALL LETTER N WITH CARON"},
{"U+0149","ŉ","n",0xc589,"LATIN SMALL LETTER N PRECEDED BY APOSTROPHE"},
{"U+014A","Ŋ","N",0xc58a,"LATIN CAPITAL LETTER ENG"},
{"U+014B","ŋ","n",0xc58b,"LATIN SMALL LETTER ENG"},
{"U+014C","Ō","O",0xc58c,"LATIN CAPITAL LETTER O WITH MACRON"},
{"U+014D","ō","o",0xc58d,"LATIN SMALL LETTER O WITH MACRON"},
{"U+014E","Ŏ","O",0xc58e,"LATIN CAPITAL LETTER O WITH BREVE"},
{"U+014F","ŏ","o",0xc58f,"LATIN SMALL LETTER O WITH BREVE"},
{"U+0150","Ő","O",0xc590,"LATIN CAPITAL LETTER O WITH DOUBLE ACUTE"},
{"U+0151","ő","o",0xc591,"LATIN SMALL LETTER O WITH DOUBLE ACUTE"},
{"U+0152","Œ","OE",0xc592,"LATIN CAPITAL LIGATURE OE"},
{"U+0153","œ","oe",0xc593,"LATIN SMALL LIGATURE OE"},
{"U+0154","Ŕ","R",0xc594,"LATIN CAPITAL LETTER R WITH ACUTE"},
{"U+0155","ŕ","r",0xc595,"LATIN SMALL LETTER R WITH ACUTE"},
{"U+0156","Ŗ","R",0xc596,"LATIN CAPITAL LETTER R WITH CEDILLA"},
{"U+0157","ŗ","r",0xc597,"LATIN SMALL LETTER R WITH CEDILLA"},
{"U+0158","Ř","R",0xc598,"LATIN CAPITAL LETTER R WITH CARON"},
{"U+0159","ř","r",0xc599,"LATIN SMALL LETTER R WITH CARON"},
{"U+015A","Ś","S",0xc59a,"LATIN CAPITAL LETTER S WITH ACUTE"},
{"U+015B","ś","s",0xc59b,"LATIN SMALL LETTER S WITH ACUTE"},
{"U+015C","Ŝ","S",0xc59c,"LATIN CAPITAL LETTER S WITH CIRCUMFLEX"},
{"U+015D","ŝ","s",0xc59d,"LATIN SMALL LETTER S WITH CIRCUMFLEX"},
{"U+015E","Ş","S",0xc59e,"LATIN CAPITAL LETTER S WITH CEDILLA"},
{"U+015F","ş","s",0xc59f,"LATIN SMALL LETTER S WITH CEDILLA"},
{"U+0160","Š","S",0xc5a0,"LATIN CAPITAL LETTER S WITH CARON"},
{"U+0161","š","s",0xc5a1,"LATIN SMALL LETTER S WITH CARON"},
{"U+0162","Ţ","T",0xc5a2,"LATIN CAPITAL LETTER T WITH CEDILLA"},
{"U+0163","ţ","t",0xc5a3,"LATIN SMALL LETTER T WITH CEDILLA"},
{"U+0164","Ť","T",0xc5a4,"LATIN CAPITAL LETTER T WITH CARON"},
{"U+0165","ť","t",0xc5a5,"LATIN SMALL LETTER T WITH CARON"},
{"U+0166","Ŧ","T",0xc5a6,"LATIN CAPITAL LETTER T WITH STROKE"},
{"U+0167","ŧ","t",0xc5a7,"LATIN SMALL LETTER T WITH STROKE"},
{"U+0168","Ũ","U",0xc5a8,"LATIN CAPITAL LETTER U WITH TILDE"},
{"U+0169","ũ","u",0xc5a9,"LATIN SMALL LETTER U WITH TILDE"},
{"U+016A","Ū","U",0xc5aa,"LATIN CAPITAL LETTER U WITH MACRON"},
{"U+016B","ū","u",0xc5ab,"LATIN SMALL LETTER U WITH MACRON"},
{"U+016C","Ŭ","U",0xc5ac,"LATIN CAPITAL LETTER U WITH BREVE"},
{"U+016D","ŭ","u",0xc5ad,"LATIN SMALL LETTER U WITH BREVE"},
{"U+016E","Ů","U",0xc5ae,"LATIN CAPITAL LETTER U WITH RING ABOVE"},
{"U+016F","ů","u",0xc5af,"LATIN SMALL LETTER U WITH RING ABOVE"},
{"U+0170","Ű","U",0xc5b0,"LATIN CAPITAL LETTER U WITH DOUBLE ACUTE"},
{"U+0171","ű","u",0xc5b1,"LATIN SMALL LETTER U WITH DOUBLE ACUTE"},
{"U+0172","Ų","U",0xc5b2,"LATIN CAPITAL LETTER U WITH OGONEK"},
{"U+0173","ų","u",0xc5b3,"LATIN SMALL LETTER U WITH OGONEK"},
{"U+0174","Ŵ","W",0xc5b4,"LATIN CAPITAL LETTER W WITH CIRCUMFLEX"},
{"U+0175","ŵ","w",0xc5b5,"LATIN SMALL LETTER W WITH CIRCUMFLEX"},
{"U+0176","Ŷ","Y",0xc5b6,"LATIN CAPITAL LETTER Y WITH CIRCUMFLEX"},
{"U+0177","ŷ","y",0xc5b7,"LATIN SMALL LETTER Y WITH CIRCUMFLEX"},
{"U+0178","Ÿ","Y",0xc5b8,"LATIN CAPITAL LETTER Y WITH DIAERESIS"},
{"U+0179","Ź","Z",0xc5b9,"LATIN CAPITAL LETTER Z WITH ACUTE"},
{"U+017A","ź","z",0xc5ba,"LATIN SMALL LETTER Z WITH ACUTE"},
{"U+017B","Ż","Z",0xc5bb,"LATIN CAPITAL LETTER Z WITH DOT ABOVE"},
{"U+017C","ż","z",0xc5bc,"LATIN SMALL LETTER Z WITH DOT ABOVE"},
{"U+017D","Ž","Z",0xc5bd,"LATIN CAPITAL LETTER Z WITH CARON"},
{"U+017E","ž","z",0xc5be,"LATIN SMALL LETTER Z WITH CARON"},
{"U+017F","ſ","s",0xc5bf,"LATIN SMALL LETTER LONG S"},
{"U+0180","ƀ","b",0xc680,"LATIN SMALL LETTER B WITH STROKE"},
{"U+0181","Ɓ","B",0xc681,"LATIN CAPITAL LETTER B WITH HOOK"},
{"U+0182","Ƃ","B",0xc682,"LATIN CAPITAL LETTER B WITH TOPBAR"},
{"U+0183","ƃ","b",0xc683,"LATIN SMALL LETTER B WITH TOPBAR"},
{"U+0184","Ƅ","6",0xc684,"LATIN CAPITAL LETTER TONE SIX"},
{"U+0185","ƅ","6",0xc685,"LATIN SMALL LETTER TONE SIX"},
{"U+0186","Ɔ","O",0xc686,"LATIN CAPITAL LETTER OPEN O"},
{"U+0187","Ƈ","C",0xc687,"LATIN CAPITAL LETTER C WITH HOOK"},
{"U+0188","ƈ","c",0xc688,"LATIN SMALL LETTER C WITH HOOK"},
{"U+0189","Ɖ","D",0xc689,"LATIN CAPITAL LETTER AFRICAN D"},
{"U+018A","Ɗ","D",0xc68a,"LATIN CAPITAL LETTER D WITH HOOK"},
{"U+018B","Ƌ","D",0xc68b,"LATIN CAPITAL LETTER D WITH TOPBAR"},
{"U+018C","ƌ","d",0xc68c,"LATIN SMALL LETTER D WITH TOPBAR"},
{"U+018D","ƍ","d",0xc68d,"LATIN SMALL LETTER TURNED DELTA"},
{"U+018E","Ǝ","E",0xc68e,"LATIN CAPITAL LETTER REVERSED E"},
{"U+018F","Ə","s",0xc68f,"LATIN CAPITAL LETTER SCHWA"},
{"U+0190","Ɛ","E",0xc690,"LATIN CAPITAL LETTER OPEN E"},
{"U+0191","Ƒ","F",0xc691,"LATIN CAPITAL LETTER F WITH HOOK"},
{"U+0192","ƒ","f",0xc692,"LATIN SMALL LETTER F WITH HOOK"},
{"U+0193","Ɠ","G",0xc693,"LATIN CAPITAL LETTER G WITH HOOK"},
{"U+0194","Ɣ","g",0xc694,"LATIN CAPITAL LETTER GAMMA"},
{"U+0195","ƕ","hv",0xc695,"LATIN SMALL LETTER HV"},
{"U+0196","Ɩ","i",0xc696,"LATIN CAPITAL LETTER IOTA"},
{"U+0197","Ɨ","I",0xc697,"LATIN CAPITAL LETTER I WITH STROKE"},
{"U+0198","Ƙ","K",0xc698,"LATIN CAPITAL LETTER K WITH HOOK"},
{"U+0199","ƙ","k",0xc699,"LATIN SMALL LETTER K WITH HOOK"},
{"U+019A","ƚ","l",0xc69a,"LATIN SMALL LETTER L WITH BAR"},
{"U+019B","ƛ","l",0xc69b,"LATIN SMALL LETTER LAMBDA WITH STROKE"},
{"U+019C","Ɯ","M",0xc69c,"LATIN CAPITAL LETTER TURNED M"},
{"U+019D","Ɲ","N",0xc69d,"LATIN CAPITAL LETTER N WITH LEFT HOOK"},
{"U+019E","ƞ","n",0xc69e,"LATIN SMALL LETTER N WITH LONG RIGHT LEG"},
{"U+019F","Ɵ","O",0xc69f,"LATIN CAPITAL LETTER O WITH MIDDLE TILDE"},
{"U+01A0","Ơ","O",0xc6a0,"LATIN CAPITAL LETTER O WITH HORN"},
{"U+01A1","ơ","o",0xc6a1,"LATIN SMALL LETTER O WITH HORN"},
{"U+01A2","Ƣ","OI",0xc6a2,"LATIN CAPITAL LETTER OI"},
{"U+01A3","ƣ","oi",0xc6a3,"LATIN SMALL LETTER OI"},
{"U+01A4","Ƥ","P",0xc6a4,"LATIN CAPITAL LETTER P WITH HOOK"},
{"U+01A5","ƥ","p",0xc6a5,"LATIN SMALL LETTER P WITH HOOK"},
{"U+01A6","Ʀ","yr",0xc6a6,"LATIN LETTER YR"},
{"U+01A7","Ƨ","2",0xc6a7,"LATIN CAPITAL LETTER TONE TWO"},
{"U+01A8","ƨ","2",0xc6a8,"LATIN SMALL LETTER TONE TWO"},
{"U+01A9","Ʃ","S",0xc6a9,"LATIN CAPITAL LETTER ESH"},
{"U+01AA","ƪ","s",0xc6aa,"LATIN LETTER REVERSED ESH LOOP"},
{"U+01AB","ƫ","t",0xc6ab,"LATIN SMALL LETTER T WITH PALATAL HOOK"},
{"U+01AC","Ƭ","T",0xc6ac,"LATIN CAPITAL LETTER T WITH HOOK"},
{"U+01AD","ƭ","t",0xc6ad,"LATIN SMALL LETTER T WITH HOOK"},
{"U+01AE","Ʈ","T",0xc6ae,"LATIN CAPITAL LETTER T WITH RETROFLEX HOOK"},
{"U+01AF","Ư","U",0xc6af,"LATIN CAPITAL LETTER U WITH HORN"},
{"U+01B0","ư","u",0xc6b0,"LATIN SMALL LETTER U WITH HORN"},
{"U+01B1","Ʊ","U",0xc6b1,"LATIN CAPITAL LETTER UPSILON"},
{"U+01B2","Ʋ","V",0xc6b2,"LATIN CAPITAL LETTER V WITH HOOK"},
{"U+01B3","Ƴ","Y",0xc6b3,"LATIN CAPITAL LETTER Y WITH HOOK"},
{"U+01B4","ƴ","y",0xc6b4,"LATIN SMALL LETTER Y WITH HOOK"},
{"U+01B5","Ƶ","Z",0xc6b5,"LATIN CAPITAL LETTER Z WITH STROKE"},
{"U+01B6","ƶ","z",0xc6b6,"LATIN SMALL LETTER Z WITH STROKE"},
{"U+01B7","Ʒ","EZH",0xc6b7,"LATIN CAPITAL LETTER EZH"},
{"U+01B8","Ƹ","EZH",0xc6b8,"LATIN CAPITAL LETTER EZH REVERSED"},
{"U+01B9","ƹ","ezh",0xc6b9,"LATIN SMALL LETTER EZH REVERSED"},
{"U+01BA","ƺ","ezh",0xc6ba,"LATIN SMALL LETTER EZH WITH TAIL"},
{"U+01BB","ƻ","2",0xc6bb,"LATIN LETTER TWO WITH STROKE"},
{"U+01BC","Ƽ","5",0xc6bc,"LATIN CAPITAL LETTER TONE FIVE"},
{"U+01BD","ƽ","5",0xc6bd,"LATIN SMALL LETTER TONE FIVE"},
{"U+01BE","ƾ","`",0xc6be,"LATIN LETTER INVERTED GLOTTAL STOP WITH STROKE"},
{"U+01BF","ƿ","p",0xc6bf,"LATIN LETTER WYNN"},
{"U+01C0","ǀ","|",0xc780,"LATIN LETTER DENTAL CLICK"},
{"U+01C1","ǁ","||",0xc781,"LATIN LETTER LATERAL CLICK"},
{"U+01C2","ǂ","+",0xc782,"LATIN LETTER ALVEOLAR CLICK"},
{"U+01C3","ǃ","!",0xc783,"LATIN LETTER RETROFLEX CLICK"},
{"U+01C4","Ǆ","DZ",0xc784,"LATIN CAPITAL LETTER DZ WITH CARON"},
{"U+01C5","ǅ","Dz",0xc785,"LATIN CAPITAL LETTER D WITH SMALL LETTER Z WITH CARON"},
{"U+01C6","ǆ","dz",0xc786,"LATIN SMALL LETTER DZ WITH CARON"},
{"U+01C7","Ǉ","LJ",0xc787,"LATIN CAPITAL LETTER LJ"},
{"U+01C8","ǈ","Lj",0xc788,"LATIN CAPITAL LETTER L WITH SMALL LETTER J"},
{"U+01C9","ǉ","lj",0xc789,"LATIN SMALL LETTER LJ"},
{"U+01CA","Ǌ","NJ",0xc78a,"LATIN CAPITAL LETTER NJ"},
{"U+01CB","ǋ","Nj",0xc78b,"LATIN CAPITAL LETTER N WITH SMALL LETTER J"},
{"U+01CC","ǌ","nj",0xc78c,"LATIN SMALL LETTER NJ"},
{"U+01CD","Ǎ","A",0xc78d,"LATIN CAPITAL LETTER A WITH CARON"},
{"U+01CE","ǎ","a",0xc78e,"LATIN SMALL LETTER A WITH CARON"},
{"U+01CF","Ǐ","I",0xc78f,"LATIN CAPITAL LETTER I WITH CARON"},
{"U+01D0","ǐ","i",0xc790,"LATIN SMALL LETTER I WITH CARON"},
{"U+01D1","Ǒ","O",0xc791,"LATIN CAPITAL LETTER O WITH CARON"},
{"U+01D2","ǒ","o",0xc792,"LATIN SMALL LETTER O WITH CARON"},
{"U+01D3","Ǔ","U",0xc793,"LATIN CAPITAL LETTER U WITH CARON"},
{"U+01D4","ǔ","u",0xc794,"LATIN SMALL LETTER U WITH CARON"},
{"U+01D5","Ǖ","U",0xc795,"LATIN CAPITAL LETTER U WITH DIAERESIS AND MACRON"},
{"U+01D6","ǖ","u",0xc796,"LATIN SMALL LETTER U WITH DIAERESIS AND MACRON"},
{"U+01D7","Ǘ","U",0xc797,"LATIN CAPITAL LETTER U WITH DIAERESIS AND ACUTE"},
{"U+01D8","ǘ","u",0xc798,"LATIN SMALL LETTER U WITH DIAERESIS AND ACUTE"},
{"U+01D9","Ǚ","U",0xc799,"LATIN CAPITAL LETTER U WITH DIAERESIS AND CARON"},
{"U+01DA","ǚ","u",0xc79a,"LATIN SMALL LETTER U WITH DIAERESIS AND CARON"},
{"U+01DB","Ǜ","U",0xc79b,"LATIN CAPITAL LETTER U WITH DIAERESIS AND GRAVE"},
{"U+01DC","ǜ","u",0xc79c,"LATIN SMALL LETTER U WITH DIAERESIS AND GRAVE"},
{"U+01DD","ǝ","e",0xc79d,"LATIN SMALL LETTER TURNED E"},
{"U+01DE","Ǟ","A",0xc79e,"LATIN CAPITAL LETTER A WITH DIAERESIS AND MACRON"},
{"U+01DF","ǟ","a",0xc79f,"LATIN SMALL LETTER A WITH DIAERESIS AND MACRON"},
{"U+01E0","Ǡ","A",0xc7a0,"LATIN CAPITAL LETTER A WITH DOT ABOVE AND MACRON"},
{"U+01E1","ǡ","a",0xc7a1,"LATIN SMALL LETTER A WITH DOT ABOVE AND MACRON"},
{"U+01E2","Ǣ","AE",0xc7a2,"LATIN CAPITAL LETTER AE WITH MACRON"},
{"U+01E3","ǣ","ae",0xc7a3,"LATIN SMALL LETTER AE WITH MACRON"},
{"U+01E4","Ǥ","G",0xc7a4,"LATIN CAPITAL LETTER G WITH STROKE"},
{"U+01E5","ǥ","g",0xc7a5,"LATIN SMALL LETTER G WITH STROKE"},
{"U+01E6","Ǧ","G",0xc7a6,"LATIN CAPITAL LETTER G WITH CARON"},
{"U+01E7","ǧ","g",0xc7a7,"LATIN SMALL LETTER G WITH CARON"},
{"U+01E8","Ǩ","K",0xc7a8,"LATIN CAPITAL LETTER K WITH CARON"},
{"U+01E9","ǩ","k",0xc7a9,"LATIN SMALL LETTER K WITH CARON"},
{"U+01EA","Ǫ","O",0xc7aa,"LATIN CAPITAL LETTER O WITH OGONEK"},
{"U+01EB","ǫ","o",0xc7ab,"LATIN SMALL LETTER O WITH OGONEK"},
{"U+01EC","Ǭ","O",0xc7ac,"LATIN CAPITAL LETTER O WITH OGONEK AND MACRON"},
{"U+01ED","ǭ","o",0xc7ad,"LATIN SMALL LETTER O WITH OGONEK AND MACRON"},
{"U+01EE","Ǯ","EZH",0xc7ae,"LATIN CAPITAL LETTER EZH WITH CARON"},
{"U+01EF","ǯ","ezh",0xc7af,"LATIN SMALL LETTER EZH WITH CARON"},
{"U+01F0","ǰ","j",0xc7b0,"LATIN SMALL LETTER J WITH CARON"},
{"U+01F1","Ǳ","DZ",0xc7b1,"LATIN CAPITAL LETTER DZ"},
{"U+01F2","ǲ","Dz",0xc7b2,"LATIN CAPITAL LETTER D WITH SMALL LETTER Z"},
{"U+01F3","ǳ","dz",0xc7b3,"LATIN SMALL LETTER DZ"},
{"U+01F4","Ǵ","G",0xc7b4,"LATIN CAPITAL LETTER G WITH ACUTE"},
{"U+01F5","ǵ","g",0xc7b5,"LATIN SMALL LETTER G WITH ACUTE"},
{"U+01F6","Ƕ","H",0xc7b6,"LATIN CAPITAL LETTER HWAIR"},
{"U+01F7","Ƿ","P",0xc7b7,"LATIN CAPITAL LETTER WYNN"},
{"U+01F8","Ǹ","N",0xc7b8,"LATIN CAPITAL LETTER N WITH GRAVE"},
{"U+01F9","ǹ","n",0xc7b9,"LATIN SMALL LETTER N WITH GRAVE"},
{"U+01FA","Ǻ","A",0xc7ba,"LATIN CAPITAL LETTER A WITH RING ABOVE AND ACUTE"},
{"U+01FB","ǻ","a",0xc7bb,"LATIN SMALL LETTER A WITH RING ABOVE AND ACUTE"},
{"U+01FC","Ǽ","AE",0xc7bc,"LATIN CAPITAL LETTER AE WITH ACUTE"},
{"U+01FD","ǽ","ae",0xc7bd,"LATIN SMALL LETTER AE WITH ACUTE"},
{"U+01FE","Ǿ","O",0xc7be,"LATIN CAPITAL LETTER O WITH STROKE AND ACUTE"},
{"U+01FF","ǿ","o",0xc7bf,"LATIN SMALL LETTER O WITH STROKE AND ACUTE"},
{"U+0200","Ȁ","A",0xc880,"LATIN CAPITAL LETTER A WITH DOUBLE GRAVE"},
{"U+0201","ȁ","a",0xc881,"LATIN SMALL LETTER A WITH DOUBLE GRAVE"},
{"U+0202","Ȃ","A",0xc882,"LATIN CAPITAL LETTER A WITH INVERTED BREVE"},
{"U+0203","ȃ","a",0xc883,"LATIN SMALL LETTER A WITH INVERTED BREVE"},
{"U+0204","Ȅ","E",0xc884,"LATIN CAPITAL LETTER E WITH DOUBLE GRAVE"},
{"U+0205","ȅ","e",0xc885,"LATIN SMALL LETTER E WITH DOUBLE GRAVE"},
{"U+0206","Ȇ","E",0xc886,"LATIN CAPITAL LETTER E WITH INVERTED BREVE"},
{"U+0207","ȇ","e",0xc887,"LATIN SMALL LETTER E WITH INVERTED BREVE"},
{"U+0208","Ȉ","I",0xc888,"LATIN CAPITAL LETTER I WITH DOUBLE GRAVE"},
{"U+0209","ȉ","i",0xc889,"LATIN SMALL LETTER I WITH DOUBLE GRAVE"},
{"U+020A","Ȋ","I",0xc88a,"LATIN CAPITAL LETTER I WITH INVERTED BREVE"},
{"U+020B","ȋ","i",0xc88b,"LATIN SMALL LETTER I WITH INVERTED BREVE"},
{"U+020C","Ȍ","O",0xc88c,"LATIN CAPITAL LETTER O WITH DOUBLE GRAVE"},
{"U+020D","ȍ","o",0xc88d,"LATIN SMALL LETTER O WITH DOUBLE GRAVE"},
{"U+020E","Ȏ","O",0xc88e,"LATIN CAPITAL LETTER O WITH INVERTED BREVE"},
{"U+020F","ȏ","o",0xc88f,"LATIN SMALL LETTER O WITH INVERTED BREVE"},
{"U+0210","Ȑ","R",0xc890,"LATIN CAPITAL LETTER R WITH DOUBLE GRAVE"},
{"U+0211","ȑ","r",0xc891,"LATIN SMALL LETTER R WITH DOUBLE GRAVE"},
{"U+0212","Ȓ","R",0xc892,"LATIN CAPITAL LETTER R WITH INVERTED BREVE"},
{"U+0213","ȓ","r",0xc893,"LATIN SMALL LETTER R WITH INVERTED BREVE"},
{"U+0214","Ȕ","U",0xc894,"LATIN CAPITAL LETTER U WITH DOUBLE GRAVE"},
{"U+0215","ȕ","u",0xc895,"LATIN SMALL LETTER U WITH DOUBLE GRAVE"},
{"U+0216","Ȗ","U",0xc896,"LATIN CAPITAL LETTER U WITH INVERTED BREVE"},
{"U+0217","ȗ","u",0xc897,"LATIN SMALL LETTER U WITH INVERTED BREVE"},
{"U+0218","Ș","S",0xc898,"LATIN CAPITAL LETTER S WITH COMMA BELOW"},
{"U+0219","ș","s",0xc899,"LATIN SMALL LETTER S WITH COMMA BELOW"},
{"U+021A","Ț","T",0xc89a,"LATIN CAPITAL LETTER T WITH COMMA BELOW"},
{"U+021B","ț","t",0xc89b,"LATIN SMALL LETTER T WITH COMMA BELOW"},
{"U+021C","Ȝ","Y",0xc89c,"LATIN CAPITAL LETTER YOGH"},
{"U+021D","ȝ","y",0xc89d,"LATIN SMALL LETTER YOGH"},
{"U+021E","Ȟ","H",0xc89e,"LATIN CAPITAL LETTER H WITH CARON"},
{"U+021F","ȟ","h",0xc89f,"LATIN SMALL LETTER H WITH CARON"},
{"U+0220","Ƞ","n",0xc8a0,"LATIN CAPITAL LETTER N WITH LONG RIGHT LEG"},
{"U+0221","ȡ","d",0xc8a1,"LATIN SMALL LETTER D WITH CURL"},
{"U+0222","Ȣ","OU",0xc8a2,"LATIN CAPITAL LETTER OU"},
{"U+0223","ȣ","ou",0xc8a3,"LATIN SMALL LETTER OU"},
{"U+0224","Ȥ","Z",0xc8a4,"LATIN CAPITAL LETTER Z WITH HOOK"},
{"U+0225","ȥ","z",0xc8a5,"LATIN SMALL LETTER Z WITH HOOK"},
{"U+0226","Ȧ","A",0xc8a6,"LATIN CAPITAL LETTER A WITH DOT ABOVE"},
{"U+0227","ȧ","a",0xc8a7,"LATIN SMALL LETTER A WITH DOT ABOVE"},
{"U+0228","Ȩ","E",0xc8a8,"LATIN CAPITAL LETTER E WITH CEDILLA"},
{"U+0229","ȩ","e",0xc8a9,"LATIN SMALL LETTER E WITH CEDILLA"},
{"U+022A","Ȫ","O",0xc8aa,"LATIN CAPITAL LETTER O WITH DIAERESIS AND MACRON"},
{"U+022B","ȫ","o",0xc8ab,"LATIN SMALL LETTER O WITH DIAERESIS AND MACRON"},
{"U+022C","Ȭ","O",0xc8ac,"LATIN CAPITAL LETTER O WITH TILDE AND MACRON"},
{"U+022D","ȭ","o",0xc8ad,"LATIN SMALL LETTER O WITH TILDE AND MACRON"},
{"U+022E","Ȯ","O",0xc8ae,"LATIN CAPITAL LETTER O WITH DOT ABOVE"},
{"U+022F","ȯ","o",0xc8af,"LATIN SMALL LETTER O WITH DOT ABOVE"},
{"U+0230","Ȱ","O",0xc8b0,"LATIN CAPITAL LETTER O WITH DOT ABOVE AND MACRON"},
{"U+0231","ȱ","o",0xc8b1,"LATIN SMALL LETTER O WITH DOT ABOVE AND MACRON"},
{"U+0232","Ȳ","Y",0xc8b2,"LATIN CAPITAL LETTER Y WITH MACRON"},
{"U+0233","ȳ","y",0xc8b3,"LATIN SMALL LETTER Y WITH MACRON"},
{"U+0234","ȴ","l",0xc8b4,"LATIN SMALL LETTER L WITH CURL"},
{"U+0235","ȵ","n",0xc8b5,"LATIN SMALL LETTER N WITH CURL"},
{"U+0236","ȶ","t",0xc8b6,"LATIN SMALL LETTER T WITH CURL"},
{"U+0237","ȷ","j",0xc8b7,"LATIN SMALL LETTER DOTLESS J"},
{"U+0238","ȸ","db",0xc8b8,"LATIN SMALL LETTER DB DIGRAPH"},
{"U+0239","ȹ","qp",0xc8b9,"LATIN SMALL LETTER QP DIGRAPH"},
{"U+023A","Ⱥ","A",0xc8ba,"LATIN CAPITAL LETTER A WITH STROKE"},
{"U+023B","Ȼ","C",0xc8bb,"LATIN CAPITAL LETTER C WITH STROKE"},
{"U+023C","ȼ","c",0xc8bc,"LATIN SMALL LETTER C WITH STROKE"},
{"U+023D","Ƚ","L",0xc8bd,"LATIN CAPITAL LETTER L WITH BAR"},
{"U+023E","Ⱦ","T",0xc8be,"LATIN CAPITAL LETTER T WITH DIAGONAL STROKE"},
{"U+023F","ȿ","s",0xc8bf,"LATIN SMALL LETTER S WITH SWASH TAIL"},
{"U+0240","ɀ","z",0xc980,"LATIN SMALL LETTER Z WITH SWASH TAIL"},
{"U+0241","Ɂ","`",0xc981,"LATIN CAPITAL LETTER GLOTTAL STOP"},
{"U+0242","ɂ","`",0xc982,"LATIN SMALL LETTER GLOTTAL STOP"},
{"U+0243","Ƀ","B",0xc983,"LATIN CAPITAL LETTER B WITH STROKE"},
{"U+0244","Ʉ","U",0xc984,"LATIN CAPITAL LETTER U BAR"},
{"U+0245","Ʌ","V",0xc985,"LATIN CAPITAL LETTER TURNED V"},
{"U+0246","Ɇ","E",0xc986,"LATIN CAPITAL LETTER E WITH STROKE"},
{"U+0247","ɇ","e",0xc987,"LATIN SMALL LETTER E WITH STROKE"},
{"U+0248","Ɉ","J",0xc988,"LATIN CAPITAL LETTER J WITH STROKE"},
{"U+0249","ɉ","j",0xc989,"LATIN SMALL LETTER J WITH STROKE"},
{"U+024A","Ɋ","Q",0xc98a,"LATIN CAPITAL LETTER SMALL Q WITH HOOK TAIL"},
{"U+024B","ɋ","q",0xc98b,"LATIN SMALL LETTER Q WITH HOOK TAIL"},
{"U+024C","Ɍ","R",0xc98c,"LATIN CAPITAL LETTER R WITH STROKE"},
{"U+024D","ɍ","r",0xc98d,"LATIN SMALL LETTER R WITH STROKE"},
{"U+024E","Ɏ","Y",0xc98e,"LATIN CAPITAL LETTER Y WITH STROKE"},
{"U+024F","ɏ","y",0xc98f,"LATIN SMALL LETTER Y WITH STROKE"},
{"U+0250","ɐ","a",0xc990,"LATIN SMALL LETTER TURNED A"},
{"U+0251","ɑ","a",0xc991,"LATIN SMALL LETTER ALPHA"},
{"U+0252","ɒ","a",0xc992,"LATIN SMALL LETTER TURNED ALPHA"},
{"U+0253","ɓ","b",0xc993,"LATIN SMALL LETTER B WITH HOOK"},
{"U+0254","ɔ","o",0xc994,"LATIN SMALL LETTER OPEN O"},
{"U+0255","ɕ","c",0xc995,"LATIN SMALL LETTER C WITH CURL"},
{"U+0256","ɖ","d",0xc996,"LATIN SMALL LETTER D WITH TAIL"},
{"U+0257","ɗ","d",0xc997,"LATIN SMALL LETTER D WITH HOOK"},
{"U+0258","ɘ","e",0xc998,"LATIN SMALL LETTER REVERSED E"},
{"U+0259","ə","s",0xc999,"LATIN SMALL LETTER SCHWA"},
{"U+025A","ɚ","s",0xc99a,"LATIN SMALL LETTER SCHWA WITH HOOK"},
{"U+025B","ɛ","e",0xc99b,"LATIN SMALL LETTER OPEN E"},
{"U+025C","ɜ","e",0xc99c,"LATIN SMALL LETTER REVERSED OPEN E"},
{"U+025D","ɝ","e",0xc99d,"LATIN SMALL LETTER REVERSED OPEN E WITH HOOK"},
{"U+025E","ɞ","e",0xc99e,"LATIN SMALL LETTER CLOSED REVERSED OPEN E"},
{"U+025F","ɟ","j",0xc99f,"LATIN SMALL LETTER DOTLESS J WITH STROKE"},
{"U+0260","ɠ","g",0xc9a0,"LATIN SMALL LETTER G WITH HOOK"},
{"U+0261","ɡ","g",0xc9a1,"LATIN SMALL LETTER SCRIPT G"},
{"U+0262","ɢ","g",0xc9a2,"LATIN LETTER SMALL CAPITAL G"},
{"U+0263","ɣ","g",0xc9a3,"LATIN SMALL LETTER GAMMA"},
{"U+0264","ɤ","g",0xc9a4,"LATIN SMALL LETTER RAMS HORN"},
{"U+0265","ɥ","h",0xc9a5,"LATIN SMALL LETTER TURNED H"},
{"U+0266","ɦ","h",0xc9a6,"LATIN SMALL LETTER H WITH HOOK"},
{"U+0267","ɧ","h",0xc9a7,"LATIN SMALL LETTER HENG WITH HOOK"},
{"U+0268","ɨ","i",0xc9a8,"LATIN SMALL LETTER I WITH STROKE"},
{"U+0269","ɩ","i",0xc9a9,"LATIN SMALL LETTER IOTA"},
{"U+026A","ɪ","I",0xc9aa,"LATIN LETTER SMALL CAPITAL I"},
{"U+026B","ɫ","l",0xc9ab,"LATIN SMALL LETTER L WITH MIDDLE TILDE"},
{"U+026C","ɬ","l",0xc9ac,"LATIN SMALL LETTER L WITH BELT"},
{"U+026D","ɭ","l",0xc9ad,"LATIN SMALL LETTER L WITH RETROFLEX HOOK"},
{"U+026E","ɮ","lezh",0xc9ae,"LATIN SMALL LETTER LEZH"},
{"U+026F","ɯ","m",0xc9af,"LATIN SMALL LETTER TURNED M"},
{"U+0270","ɰ","m",0xc9b0,"LATIN SMALL LETTER TURNED M WITH LONG LEG"},
{"U+0271","ɱ","m",0xc9b1,"LATIN SMALL LETTER M WITH HOOK"},
{"U+0272","ɲ","n",0xc9b2,"LATIN SMALL LETTER N WITH LEFT HOOK"},
{"U+0273","ɳ","n",0xc9b3,"LATIN SMALL LETTER N WITH RETROFLEX HOOK"},
{"U+0274","ɴ","N",0xc9b4,"LATIN LETTER SMALL CAPITAL N"},
{"U+0275","ɵ","o",0xc9b5,"LATIN SMALL LETTER BARRED O"},
{"U+0276","ɶ","OE",0xc9b6,"LATIN LETTER SMALL CAPITAL OE"},
{"U+0277","ɷ","o",0xc9b7,"LATIN SMALL LETTER CLOSED OMEGA"},
{"U+0278","ɸ","p",0xc9b8,"LATIN SMALL LETTER PHI"},
{"U+0279","ɹ","r",0xc9b9,"LATIN SMALL LETTER TURNED R"},
{"U+027A","ɺ","r",0xc9ba,"LATIN SMALL LETTER TURNED R WITH LONG LEG"},
{"U+027B","ɻ","r",0xc9bb,"LATIN SMALL LETTER TURNED R WITH HOOK"},
{"U+027C","ɼ","r",0xc9bc,"LATIN SMALL LETTER R WITH LONG LEG"},
{"U+027D","ɽ","r",0xc9bd,"LATIN SMALL LETTER R WITH TAIL"},
{"U+027E","ɾ","r",0xc9be,"LATIN SMALL LETTER R WITH FISHHOOK"},
{"U+027F","ɿ","r",0xc9bf,"LATIN SMALL LETTER REVERSED R WITH FISHHOOK"},
{"U+0280","ʀ","R",0xca80,"LATIN LETTER SMALL CAPITAL R"},
{"U+0281","ʁ","R",0xca81,"LATIN LETTER SMALL CAPITAL INVERTED R"},
{"U+0282","ʂ","d",0xca82,"LATIN SMALL LETTER S WITH HOOK"},
{"U+0283","ʃ","esh",0xca83,"LATIN SMALL LETTER ESH"},
{"U+0284","ʄ","j",0xca84,"LATIN SMALL LETTER DOTLESS J WITH STROKE AND HOOK"},
{"U+0285","ʅ","esh",0xca85,"LATIN SMALL LETTER SQUAT REVERSED ESH"},
{"U+0286","ʆ","esh",0xca86,"LATIN SMALL LETTER ESH WITH CURL"},
{"U+0287","ʇ","t",0xca87,"LATIN SMALL LETTER TURNED T"},
{"U+0288","ʈ","t",0xca88,"LATIN SMALL LETTER T WITH RETROFLEX HOOK"},
{"U+0289","ʉ","u",0xca89,"LATIN SMALL LETTER U BAR"},
{"U+028A","ʊ","u",0xca8a,"LATIN SMALL LETTER UPSILON"},
{"U+028B","ʋ","v",0xca8b,"LATIN SMALL LETTER V WITH HOOK"},
{"U+028C","ʌ","v",0xca8c,"LATIN SMALL LETTER TURNED V"},
{"U+028D","ʍ","w",0xca8d,"LATIN SMALL LETTER TURNED W"},
{"U+028E","ʎ","y",0xca8e,"LATIN SMALL LETTER TURNED Y"},
{"U+028F","ʏ","Y",0xca8f,"LATIN LETTER SMALL CAPITAL Y"},
{"U+0290","ʐ","z",0xca90,"LATIN SMALL LETTER Z WITH RETROFLEX HOOK"},
{"U+0291","ʑ","z",0xca91,"LATIN SMALL LETTER Z WITH CURL"},
{"U+0292","ʒ","ezh",0xca92,"LATIN SMALL LETTER EZH"},
{"U+0293","ʓ","ezh",0xca93,"LATIN SMALL LETTER EZH WITH CURL"},
{"U+0294","ʔ","`",0xca94,"LATIN LETTER GLOTTAL STOP"},
{"U+0295","ʕ","s",0xca95,"LATIN LETTER PHARYNGEAL VOICED FRICATIVE"},
{"U+0296","ʖ","`",0xca96,"LATIN LETTER INVERTED GLOTTAL STOP"},
{"U+0297","ʗ","C",0xca97,"LATIN LETTER STRETCHED C"},
{"U+0298","ʘ","O",0xca98,"LATIN LETTER BILABIAL CLICK"},
{"U+0299","ʙ","B",0xca99,"LATIN LETTER SMALL CAPITAL B"},
{"U+029A","ʚ","e",0xca9a,"LATIN SMALL LETTER CLOSED OPEN E"},
{"U+029B","ʛ","G",0xca9b,"LATIN LETTER SMALL CAPITAL G WITH HOOK"},
{"U+029C","ʜ","H",0xca9c,"LATIN LETTER SMALL CAPITAL H"},
{"U+029D","ʝ","j",0xca9d,"LATIN SMALL LETTER J WITH CROSSED-TAIL"},
{"U+029E","ʞ","k",0xca9e,"LATIN SMALL LETTER TURNED K"},
{"U+029F","ʟ","L",0xca9f,"LATIN LETTER SMALL CAPITAL L"},
{"U+02A0","ʠ","q",0xcaa0,"LATIN SMALL LETTER Q WITH HOOK"},
{"U+02A1","ʡ","`",0xcaa1,"LATIN LETTER GLOTTAL STOP WITH STROKE"},
{"U+02A2","ʢ","`",0xcaa2,"LATIN LETTER REVERSED GLOTTAL STOP WITH STROKE"},
{"U+02A3","ʣ","dz",0xcaa3,"LATIN SMALL LETTER DZ DIGRAPH"},
{"U+02A4","ʤ","dezh",0xcaa4,"LATIN SMALL LETTER DEZH DIGRAPH"},
{"U+02A5","ʥ","dz",0xcaa5,"LATIN SMALL LETTER DZ DIGRAPH WITH CURL"},
{"U+02A6","ʦ","ts",0xcaa6,"LATIN SMALL LETTER TS DIGRAPH"},
{"U+02A7","ʧ","tesh",0xcaa7,"LATIN SMALL LETTER TESH DIGRAPH"},
{"U+02A8","ʨ","tc",0xcaa8,"LATIN SMALL LETTER TC DIGRAPH WITH CURL"},
{"U+02A9","ʩ","feng",0xcaa9,"LATIN SMALL LETTER FENG DIGRAPH"},
{"U+02AA","ʪ","ls",0xcaaa,"LATIN SMALL LETTER LS DIGRAPH"},
{"U+02AB","ʫ","lz",0xcaab,"LATIN SMALL LETTER LZ DIGRAPH"},
{"U+02AC","ʬ","ww",0xcaac,"LATIN LETTER BILABIAL PERCUSSIVE"},
{"U+02AD","ʭ","dd",0xcaad,"LATIN LETTER BIDENTAL PERCUSSIVE"},
{"U+02AE","ʮ","h",0xcaae,"LATIN SMALL LETTER TURNED H WITH FISHHOOK"},
{"U+02AF","ʯ","h",0xcaaf,"LATIN SMALL LETTER TURNED H WITH FISHHOOK AND TAIL"},
{NULL,NULL,NULL,0,NULL}
};
