/* cc -O2 -o eddata eddata.c -lm
 */
#include "../gen/include.h"

int main(int narg,char **arg)
{
  FILE *in,*out;
  char line[4096],*fn;
  int i,iarg,ifile=0;
  
  if (narg<2) {
    fprintf(stderr,"Edit data file (.def, .get) in the MACSIMUS `get data' format. Call by:\n\
  eddata ID=VALUE [ID=VALUE ...] [-]FILE [[-]FILE ...]\n\
Description:\n\
  Any ID=OLDVALUE field in FILE is replaced by ID=VALUE\n\
  If (the first) FILE contains `=', it must be prefixed by `-'\n\
  VALUE may be generally any string\n\
  No spaces are allowed around `='\n\
  If VALUE is missing (ID=), whole ID=OLDVALUE is removed from FILE\n\
  ID may be qualified (STRUCT.ID) and subscripted (ARRAY[1])\n\
  The old FILEs are backed up as FILE~\n\
Example:\n\
  eddata init=2 T=300 \"rho= tau.P=10\" \"L[0]=1\" sim-[abc].def\n\
See also:\n\
  eqfield repl replace lemon\n");
    exit(0); }

  loop (iarg,1,narg)
     if (arg[iarg][0]=='-' || !strchr(arg[iarg],'=')) { 
       ifile=iarg; break; }
       
  if (!ifile) Error("no file arg");
  if (ifile==1) Error("1st arg must be ID=[VALUE]");
  
  fn=tmpnam(NULL);
  //  fprintf(stderr,"%s\n",fn);

  loop (iarg,ifile,narg) {
    in=fopen(arg[iarg]+(arg[iarg][0]=='-'),"rt");
    out=fopen(fn,"wt");
    if (!in) Error(arg[iarg]);
  
    while (fgets(line,4096,in)) {
      loop (i,1,ifile) {
        char needle[1024],*n,*c,*repl,*exclm;
        
        for (c=arg[i],n=needle;*c;c++,n++) {
          *n=*c;
          if (*c=='=') break; }
        *++n=0;
        repl=strstr(line,needle);
        exclm=strchr(line,'!');
        if (repl && repl!=line)
          if (isalnum(repl[-1]) || strchr("[].",repl[-1]) || (exclm && repl>exclm)) repl=NULL;
        if (repl) {
          char *end=repl,*eq=strchr(arg[i],'=')+1;
  
          while (*end>' ') {
            putchar(*end);
            end++; }
          if (*eq>' ') eq=arg[i];
          printf(" --> %s\n",eq);
          memmove(repl+strlen(eq),end,strlen(end)+1);
          memcpy(repl,eq,strlen(eq)); } }
      fputs(line,out); }
  
    fclose(in);
    fclose(out);

    system(string("mv \'%s\' \'%s~\'",arg[iarg],arg[iarg]));
    system(string("mv %s \'%s\'",fn,arg[iarg])); }
  
  return 0;
}
