/*
reverse endian in words by 4 bytes
good for files of single precision floats or 4 byte integers
*/

#define buflen 2048 /* read/write buffer size in # of floats */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void endian(char *a) /********************************************** endian */
{
char x;
x=a[0]; a[0]=a[3]; a[3]=x;
x=a[1]; a[1]=a[2]; a[2]=x;
}

int main(int narg,char **arg)
{
FILE *in,*out;
long int l=0;
int i,n;
char fn[20];
static char buf[buflen*4];

fprintf(stderr,"reverse endian in words by 4 bytes\n");

if (narg<3) {
  fprintf(stderr,"call by : endian source_file { dest_file | drive: }\n");
  exit(-1); }

in=fopen(arg[1],"rb");
if (in==NULL) {
  fprintf(stderr,"cannot open %s\n",arg[1]);
  exit(-1); }

strcpy(fn,arg[2]);
if (strlen(fn)==2) if (fn[1]==':') strcat(fn,arg[1]);

out=fopen(fn,"wb");
if (in==NULL) {
  fprintf(stderr,"cannot open %s for writing\n",arg[2]);
  exit(-1); }

for (;;) {
  n=fread(buf,4,buflen,in);
  if (n<=0) break;
  for (i=0; i<n; i++) endian(buf+4*i);
  l+=n;
  if (n!=fwrite(buf,4,n,out)) {
    fprintf(stderr,"write error on %s\n",arg[2]);
    exit(-1); }
  if (n<buflen) break; }

fprintf(stderr,"%li 4-byte words reversed\n",l);

return 0;
}
