/* cc -O2 -o field field.c
 */
#include "../gen/include.h"

#define LINE 260000
#define N 10002

int main(int narg,char **arg)
{
  char line[LINE];
  char *tok[N],*minus;
  int iarg;
  int nf,f,t,i;

  if (narg<2) {
    fprintf(stderr,"Select white-separated field(s). Call by:\n\
  field {FIELD|FIELD[-FIELD]|[-]TEXT} [...] < INFILE > OUTFILE\n\
Arguments:\n\
  FIELD = dec.number of the field (fields are numbered from 1)\n\
  FIELD-FIELD = range of fields\n\
  FIELD- = the same as FIELD-BIG\n\
  TEXT = any string not beginning with digit to be unchanged copied to output\n\
  -TEXT = TEXT is any text (may begin with a digit)\n\
FIELDs may appear in any order an may repeat, output is in the order of FIELDS\n\
Example (plot all *.dat files, one by one):\n\
  ls -1 *.dat | field plot 1 | sh\n\
See also:\n\
  cut mergetab selcol tabproc deleol\n");
    exit(0); }

  while (fgets(line,LINE,stdin)) {
    nf=1;
    tok[nf]=strtok(line," \t\r\n");
    
    while (tok[nf++]) {
      if (nf>=N) Error("too many columns");
      tok[nf]=strtok(NULL," \t\r\n"); }
    nf--;
    
    loop (iarg,1,narg) {
      if (iarg>1) printf(" ");
      if (isdigit(arg[iarg][0])) {
        f=t=atoi(arg[iarg]);
        if ( (minus=strchr(arg[iarg],'-')) ) {
          if (minus[1]) t=atoi(minus+1);
          else t=nf; }
        if (t>=nf) t=nf-1;
        if (f<1) f=1;
        loopto (i,f,t) {
          if (i>f) printf(" ");
          printf("%s",tok[i]); } }
      else  
        printf("%s",arg[iarg]+(arg[iarg][0]=='-')); } 
      printf("\n"); }

  return 0;
}
