/* this works (for LJ), uses a dix-loop */

static double linkcell(linklist_t ****list) /******************** linkcell */
{
  double U=0;
  int ith,dix;
  int maxdix=2+(int)((box.cutoff-1e-5)/(box.L[0]/No.cell[0]));
  int forceserial=measure && No.measureserial; /* should never happen */
  pll_global_t *pll_global; /* array [No.cell[0]] */

  max14=0; excrrlimit=Sqr(excrlimit);

  if (No.lcth<1 || No.lcth>No.cell[0]) ERROR(("invalid number of No.lcth"))

  allocarrayzero(pll_global,No.lcth);

  loop (dix,0,maxdix) {
    if (forceserial) {
      /* cannot execute in parallel (leftover - should never happen) */
      loop (ith,0,No.lcth) {
        par1_lc.by=No.lcth;
        par1_lc.dix=dix;
        par1_lc.list=list;
        par1_lc.glob0=pll_global;
        pll_linkcell(No.thread+ith);
      } }
    else
      par1_lc.by=No.lcth;
      par1_lc.dix=dix;
      par1_lc.list=list;
      par1_lc.glob0=pll_global;
      PARALLELIZE(pll_linkcell,No.lcth)
  } /* end of dix loop */

  /* sum up all instances of En.el, En.vir ... */
  if (measure) loop (ith,0,No.lcth) {
#if PRESSURETENSOR&PT_VIR
    loop (dix,0,PT_DIM) En.Pvir[dix]+=pll_global[ith].Pvir[dix];
#endif
    U += pll_global[ith].U;
    En.el += pll_global[ith].Enel;
    En.vir += pll_global[ith].Envir; }

  if (partimes.rspace) loop (ith,0,No.lcth)
    partimes.rspace[ith]+=pll_global[ith].t/(double)CLOCKS_PER_SEC;

  loop (ith,0,No.lcth) Max(max14,pll_global[ith].max14)

  free(pll_global);

  if (No.c) update14();

  return U;
} /* linkcell */
