/*
  2009: point | added
*/  
#define Sqr(X) ((X)*(X))

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <math.h> /* fabs needed */
#include "draw.h"

#if defined(DOS)
/* Turbo C graphics */

#include <graphics.h>
#include <conio.h>
#include <dos.h>

char *pathtodriver;

/* SVGA support from startgra.pas */

static int svgamode=0;

int huge DetectVGA256(void)
{
switch (svgamode) {
  case 0: return 4; /* 1MB videomemory */
  case 2: return 3;
  case 4: return 2;
  case 6: return 0; /* ? */ }
exit(0);
}
/*
 0) 320x200x256
 1) 640x400x256
 2) 640x480x256
 3) 800x600x256
 4) 1024x768x256
 5) 640x350x256
 6) 1280x1024x256
*/

int huge DetectVGA16(void)
{
switch (svgamode) {
  case 1: return 5;
  case 3: return 4; }
exit(0);
}
/*
 0) 320x200x16');
 1) 640x200x16');
 2) 640x350x16');
 3) 640x480x256');
 4) 800x600x16');
 5) 1024x768x16');
*/

static int globmode;

void info(char *s,int i)
{
fprintf(stderr,"%2d : %s",i,s);
if (globmode==-i || globmode-10==i) fprintf(stderr," (default)");
fprintf(stderr,"\n");
}

int startgraph(int mode) /************************************** startgraph */
{
/* returns negative number on error */
int GraphDriver;
int GraphMode;
int GraphRes;

if (svgamode!=0) mode=svgamode;
svgamode=mode;

while (mode<0 || mode>9) {
  fprintf(stderr,"\nSelect [S]VGA video mode:\n");
  globmode=mode;
  info("1024x768x256c",0); /* 1MB videomemory */
  info("1024x768x16c",1);
  info("800x600x256c",2);
  info("800x600x16c",3);
  info("640x480x256c",4);
  info("640x480x16c VGA",5);
  info("320x200x256c",6);
  info("640x200x1c CGA",7);
  info("320x200x256c no driver",8);
  info("autodetect",9);
  mode=getch()-'0';
  if (mode==27-'0') return -27;
  if (mode==13-'0') mode=svgamode>9?svgamode-10:abs(svgamode); /* Enter=default */
/*  if mode>5 then mode:=9; */
  if (mode<0) mode=-9; }
svgamode=mode;

if (svgamode==5 || svgamode==9 || svgamode==8) /* no driver */;
else if (svgamode&1) GraphDriver = installuserdriver("svga16",DetectVGA16);
else GraphDriver = installuserdriver("svga256",DetectVGA256);

if (svgamode==8) {
  struct REGPACK reg;
  reg.r_ax = 0x13;
  intr(0x10,&reg); }
else if (svgamode==7) {
  GraphDriver=CGA;
  GraphMode=CGAHI;
  initgraph(&GraphDriver,&GraphMode,"d:\\pas"); }
else {
  GraphDriver=DETECT;
  initgraph(&GraphDriver,&GraphMode,"");
  GraphRes=graphresult();
  if (pathtodriver==NULL || pathtodriver[0]==0) pathtodriver=getenv("BGI");
  if (GraphRes!=grOk && pathtodriver) {
    GraphDriver=DETECT;
    initgraph(&GraphDriver,&GraphMode,pathtodriver);
    GraphRes=graphresult(); }
  if (GraphRes!=grOk) {
    fprintf(stderr,"InitGraph error:%s\n",grapherrormsg(GraphRes));
    return GraphRes; } }
return svgamode;
}

void draw(REAL x1,REAL y1) /************************************* draw */
{
REAL sx=scaling.x*(x1-scaling.fromx);
REAL sy=scaling.y*(scaling.toy-y1);

if (fabs(sx)<16000.0 && fabs(sy)<16000.0) {
  int ix=(int)(sx+0.5);
  int iy=(int)(sy+0.5);

  if (pen) lineto(ix,iy);
  else moveto(ix,iy); }
else {
  REAL r=sqrt(sx*sx+sy*sy)*(1/16000.0);
  moveto((int)(sx/r),(int)(sy/r)); }
pen=1;
}

#elif defined(X11)

#include "drawx11.c"

#elif defined(EMX)

#include "drawemx.c"

#else /* plain version : dummy */

void closegraph(void) {}
void setcolor(int c) {}
void clearviewport(void) {}
int kbhit(void) { return 0; }
#undef getch
int getch(void) { return 27; }
void delay(unsigned msec) {}
void getimage(int x0,int y0,int x1,int y1,void *buf) {}
void putimage(int x,int y,void *buf,int mode) {}
void outtextxy(int x,int y,char *s) {}
void setlinestyle(int mode,int pattern,int thick) {}
void setfillstyle(int mode,int color) {}
void setwritemode(int mode) {}

void line(int x0,int y0,int x1,int y1) {}
void bar(int x0,int y0,int x1,int y1) {}
void rectangle(int x0,int y0,int x1,int y1) {}
int startgraph(int mode) {}
void putpixel(int x,int y,int c) {}
void draw(REAL x,REAL y) {}

#endif

#ifndef EMX
#define g_lock()
#define g_unlock()
#endif

#if defined(EMX) || defined(X11)
/* Turbo-like outtextxy() */
#include "outtext.c"
#endif

/*** scaled graphics in x,y Cartesian coordinates ***/
/* common for all versions:
     the plain version does nothing just because the pixel
     graphics primitives are void
*/

struct scaling_s scaling;
int pen;

void up(void) /******************************************************** up */
{
  pen=0;
}

static int wx0,wx1=639,wy0,wy1=479; /* VGA 16col as default */

void lwindow(int x0,int x1,int y0,int y1) /************************* window */
/* renamed because of window() in conio.h */
/* normally, x0<x1 and y0<y1: y0 is thus TOP and y1 BOTTOM */
{
  if (x1<=x0) x1=getmaxx();
  if (y1<=y0) y1=getmaxy();
  wx0=x0; wx1=x1;
  wy0=y0; wy1=y1;
}

void scale(REAL x0,REAL x1,REAL y0,REAL y1) /*********************** scale */
{
  scaling.x=(wx1-wx0)/(x1-x0);
  scaling.fromx=x0-wx0/scaling.x;
  scaling.y=(wy1-wy0)/(y1-y0);
  scaling.toy=y1+wy0/scaling.y;
}

int SX(REAL x) /****************************************************** SX */
{
  int i=Int(scaling.x*(x-scaling.fromx)+16383.5)-16383;
#ifndef DOS
  if (i<-32767) i=-32767;
  if (i>32767) i=32767;
#endif
  return i;
}

REAL iSX(int ix)
{
  return ix/scaling.x+scaling.fromx;
}

int SY(REAL y) /***************************************************** SY */
{
  int i=Int(scaling.y*(scaling.toy-y)+16383.5)-16383;
#ifndef DOS
  if (i<-32767) i=-32767;
  if (i>32767) i=32767;
#endif
  return i;
}

REAL iSY(int iy)
{
  return scaling.toy-iy/scaling.y;
}

void lline(REAL x1,REAL y1,REAL x2,REAL y2) /************** lline */
{
  g_lock();
  up(); draw(x1,y1); draw(x2,y2);
  g_unlock();
}

void dot(REAL x1,REAL y1) /************************************** dot */
{
  putpixel(SX(x1),SY(y1),getcolor());
}

/* radius of put pixel area:
   2pix/dot on average; min 0.707 to have 1 pix sure */
REAL pointsize=0.798;
int insidecolor=BLACK; /* for open points */

void point(REAL x1,REAL y1,char type) /******************************* point */
{
  REAL size=pointsize;
  int open=(unsigned)type<128,iopen;
  
  type=tolower(type&127);
  if (strchr("+x",type)) open=0;
  
  if (strchr("+dv^",type)) size*=1.414;
  
  if (size<=0)
    dot(x1,y1);
  else {
    REAL sx=scaling.x*(x1-scaling.fromx);
    REAL sy=scaling.y*(scaling.toy-y1);
  
    if (fabs(sx)<4096.0 && fabs(sy)<4096.0) loopto (iopen,0,open) {
  
      g_lock();
  
      switch (type) {
  
        case 'x': case '*': {
          int
            x0=Int(sx+0.5-size),
            x9=Int(sx+0.5+size),
            y0=Int(sy+0.5-size),
            y9=Int(sy+0.5+size);
    
          line(x0,y0,x9,y9); line(x0,y9,x9,y0); }
          
          if (type=='x') break;
          else size*=1.414;
    
        case '-': case '+': {
          int
            x=Int(sx+0.5),
            y=Int(sy+0.5);
    
          if (strchr("*+-",type)) line(Int(sx+0.5-size),y,Int(sx+0.5+size),y);
          if (strchr("*+|",type)) line(x,Int(sy+0.5-size),x,Int(sy+0.5+size));
          break; }
    
        default: {
          int
            x =Int(sx+1-size),
            x9=Int(sx+1+size),
            y,
            y0=Int(sy+1-size),
            y9=Int(sy+1+size);
          REAL ss=Sqr(size),sv=size/2;
          unsigned col=iopen ? insidecolor : getcolor();
    
          for (; x<x9; x++)
            for (y=y0; y<y9; y++) 
              if (type=='o' && Sqr(x-sx)+Sqr(y-sy)<ss
               || type=='d' && fabs(x-sx)+fabs(y-sy)<size
               || type=='s' && fabs(x-sx)<size && fabs(y-sy)<size
               || type=='^' && y-sy<=sv && 1.7320508*fabs(x-sx)-(y-sy)<size
               || type=='v' && sy-y<=sv && 1.7320508*fabs(x-sx)-(sy-y)<size)
                putpixel(x,y,col);
          break; } }
  
      g_unlock();
      size=size*0.75-1; } }
}

#if 1
/* smartdot is macro now */
#else  /* old version */
void smartdot(REAL x1,REAL y1) /**************************** smartdot */
{
  if (pointsize<=0)
    dot(x1,y1);
  else {
    REAL sx=scaling.x*(x1-scaling.fromx);
    REAL sy=scaling.y*(scaling.toy-y1);
  
    if (fabs(sx)<4096.0 && fabs(sy)<4096.0) {
      int
        x =Int(sx+1-pointsize),
        x9=Int(sx+1+pointsize),
        y,
        y0=Int(sy+1-pointsize),
        y9=Int(sy+1+pointsize);
      REAL ss=Sqr(pointsize);
      unsigned col=getcolor();
      g_lock();
      for (; x<x9; x++)
        for (y=y0; y<y9; y++)
          if (Sqr(x-sx)+Sqr(y-sy)<ss) putpixel(x,y,col);
      g_unlock(); } }
}
#endif


void bigdot(REAL x1,REAL y1) /******************************** bigdot */
{
  int i=SX(x1),j=SY(y1),c=getcolor();
  
  g_lock();
  putpixel(i,j,c);
  putpixel(i+1,j,c); putpixel(i-1,j,c);
  putpixel(i,j+1,c); putpixel(i,j-1,c);
  g_unlock();
}

#ifdef DOS
#undef g_lock()
#undef g_unlock()
#endif
