#include <graph.h>
int gg_col=15,gg_fillcol=15;

int startgraph(int mode) /************************************* startgraph */
{
/* no SVGA supported */
mode=abs(mode); /* no selection */
if (mode==5 || mode==9) { if (!g_mode(G_MODE_VGA_H)) return -1; }
else { if (!g_mode(G_MODE_VGA_L)) return -1; }
return mode;
}

static int ggx,ggy;

void draw(REAL x1,REAL y1) /***************************************** draw */
{
int gx=SX(x1), gy=SY(y1);
if (pen) g_line(ggx,ggy,gx,gy,gg_col);
ggx=gx;
ggy=gy;
pen=1;
}

void closegraph(void)
{
g_mode(G_MODE_OFF);
}

void setcolor(int color)
{
gg_col=color;
}

void clearviewport(void)
{
g_clear(0);
}

void setwritemode(int mode)
{
/* but it does not work... */
g_wmode(mode*G_XOR); /* because G_NORM=0, G_XOR=3 */
}

void setfillstyle(int mode,int color)
{
gg_fillcol=color;
}

void setlinestyle(int mode,int pattern,int thick)
{
/* ignored - all lines solid */
}

struct ggimage_s {
  int xsize,ysize;
  char pixel[1/*var*/]; };

void getimage(int x0,int y0,int x1,int y1,void *buf)
{
struct ggimage_s *s=(struct ggimage_s *)buf;
int x,y,i;
s->xsize=x1-x0;
s->ysize=y1-y0;
g_lock();
i=0;
loopto (x,x0,x1) loopto (y,y0,y1) s->pixel[i++]=getpixel(x,y);
g_unlock();
}

void putimage(int x0,int y0,void *buf,int mode)
{
struct ggimage_s *s=(struct ggimage_s *)buf;
int x,y,x1,y1,i;
x1=x0+s->xsize;
y1=y0+s->ysize;
g_lock();
i=0;
loopto (x,x0,x1) loopto (y,y0,y1) putpixel(x,y,s->pixel[i++]);
g_unlock();
}


static int ggscan=-1;

int kbhit(void)
{
ggscan=_read_kbd(0,0,0);
return ggscan!=-1;
}

int getch(void)
{
int c=ggscan;
ggscan=-1;
if (c!=-1) return c;
return _read_kbd(0,1,0);
}

double fordelay=1;
void delay(unsigned msec)
/* anything to make the compiler happy... */
{
int i;
loop (i,0,msec*10) fordelay=1.4-fordelay*fordelay;
}

void fillellipse(int x,int y,int rx,int ry)
{
if (gg_fillcol==gg_col)
  g_ellipse(x,y,rx,ry,gg_col,1);
else {
  g_ellipse(x,y,rx,ry,gg_col,0);
  g_ellipse(x,y,rx-2,ry-2,gg_fillcol,1); }
}

void circle(int x,int y,int r)
{
g_ellipse(x,y,r,r,gg_col,0);
}
