/* must #define NBUTTONS */

typedef enum { HotKey, Drag, Wheel, Unknown } ButtonType;

extern struct buttons_s {
  int x0,x1,y0,y1; /* area of `button' equivalent to hot key ch */
  char ch; /* equivalent hot key */
  ButtonType type;
  } *buttons, *lastbutton;

extern char *mykeybuf;
extern unsigned mybufpos;

extern struct mymouse_s {
  int x,y;
  enum buttonState left,right,middle; } New,Last;

extern struct butt_s {
  REAL wheel;       /* position in the dragging wheel */
  int from,n;       /* buttons scanned from `from' to `n' */
  int maxn;         /* max # of buttons (size of the buttons[] array) */
  int right;        /* code returned on right mouse button pressed */
  ButtonType type;  /* type of the button */
  int atx,dx,lastx; /* create button position is (atx,aty) */
  int aty,dy;       /* advanced by dx or dy (some functions) */
  } butt;

void drawplus(int nbutt,int buflen,int mous);
void buttnl(void);

#ifdef X11
#define HIDEMOUSE
#define SHOWMOUSE
#else
#define HIDEMOUSE hideMouse();
#define SHOWMOUSE showMouse();
#endif

void showMouse(void);
void hideMouse(void);

void registerclickarea(int x0,int y0,int x1,int y1,char ch);

int extkey(void);
void addmykey(char ch);
void nextevent(void);

int mykey(void);
int mykbhit(void);

void addmykey(char ch);

void registerbutton(int fromx,int tox,char ch);
void createcolbutton(char *s,int dx,int col);
void createbutton(char *s,int dx);
void createpmbutton(char *msg,char *smd,int change);
void createwheel(char *msg);
/*.....void createtoggle(char *s,int dx,int *val,const char *vals,const char *red);*/
void nextmouseevent(void);

void panel(int xsize,int ysize,int col);
void printinfo(int x,int y,char *msg,int bg);

REAL fint(REAL x);
void makegrid(int lbl,REAL density,int xaxis,REAL x0,REAL x1,REAL y0,REAL y1,int at);

#define UP    ('H'|128)
#define DOWN  ('P'|128)
#define LEFT  ('K'|128)
#define CLEFT ('s'|128)
#define CRIGHT ('t'|128)
#define RIGHT ('M'|128)
#define INS   ('R'|128)
#define DEL   ('S'|128)
#define HOME  ('G'|128)
#define END   ('O'|128)
#define PGUP  ('I'|128)
#define PGDN  ('Q'|128)
#define ESC   27
#define ENTER 13
#ifdef DOS
#define ALTF4 ('k'|128)
#endif

#define F1 ('1'|128) 
#define F2 ('2'|128) 
#define F3 ('3'|128) 
#define F4 ('4'|128) 
#define F5 ('5'|128) 
#define F6 ('6'|128) 
#define F7 ('7'|128) 
#define F8 ('8'|128) 
#define F9 ('9'|128) 
#define F10 ('0'|128) 
#define F11 (':'|128) 
#define F12 (';'|128) 
