/* 
  extended replacement of prtscr.c - ppm and ps output
  o s 0 = B/W PS
  O S = B/W PS inverted
  m 5 = PPM
  M = PPM inverted
  PRTSCR is file name, in not defined then prtscr.ps or prtscr.ppm
  DOS - see also prtscr.c
  note: printscreen currently not available for X11
*/

#ifdef DOS
#include "prtscr.c"
#endif

void DumpScr(char mode,char *black)
{
#ifdef DOS
int i,j;

if (strchr("de129np78tl3h",mode)) {
  loop (i,0,getmaxx()) loop (j,0,getmaxy()) {
    int p=getpixel(i,j);
    if (p && strchr(black,p)) putpixel(i,j,BLACK); }
  PrtScr(mode); }
else
#endif

{
int ps=toupper(mode)!='M';
char *prtname=getenv("PRTSCR");
char *fnfmt=(char*)(prtname?prtname:ps?"prtscr%02d.ps":"prtscr%02d.ppm");
static char *fn;
static int nfn;
FILE *f;
int x,mx=getmaxx()+1,y,my=getmaxy()+1,inv,c;
/* both bw[0] and rgb[0][0] must be zero (see inv below) */
static unsigned char bw[16]={  0, 14, 78, 89, 38, 53,113, 153,
			      77, 28,155,178, 77,105,227,253};
static unsigned char rgb[16][3]={
/*black*/ {0,0,0},
/*darkblue*/ {0,0,127},
/*darkgreen*/ {0,127,0},
/*darkcyan*/ {0,127,127},
/*darkred*/ {127,0,0},
/*darkmagenta*/ {127,0,127},
/*chocolate*/ {127,63,0},
/*gray70*/ {150,150,150},
/*gray40*/ {80,80,80},
/*blue*/ {0,0,255},
/*green*/ {0,255,0},
/*cyan*/ {0,255,255},
/*red*/ {255,0,0},
/*magenta*/ {255,0,255},
/*yellow*/ {255,255,0},
/*white*/ {255,255,255}};
          
#ifdef X11
XImage *ximage=XGetImage(display,win,0,0,mx,my,AllPlanes,ZPixmap);
unsigned long xcol;
extern long unsigned *xcoltab;
#endif

if (strchr(fnfmt,'%')) {
  if (!nfn) fn=(char*)malloc(strlen(fnfmt)+5);
  sprintf(fn,fnfmt,nfn++); }
else fn=fnfmt; 
f=fopen(fn,ps?"wt":"wb");

inv=isupper(mode);
#ifdef X11
fprintf(stderr,"dumping %s%s file \"%s\"\n",
	inv?"inverted ":"", ps?"gray PS":"PPM",fn);
#endif
if (!inv ^ !bw[0]) {
  loop (x,0,16) bw[x]^=255;
  loop (x,0,3*16) rgb[0][x]^=255; }

if (ps) fprintf(f,"%%!PS-Adobe-2.0\n\
90 rotate 54 -550 translate %.2f 480 scale\n\
/DS %d string def\n\
%d %d 8 [ %d 0 0 %d 0 %d ]\n\
{ currentfile DS readhexstring pop } image",
                480.0f/my*mx, /* /ASPECT */
                mx,
                mx,my,
                mx,-my,my);
else fprintf(f,"P6\n%d %d\n255\n",mx,my);
loop (y,0,my) loop (x,0,mx) {
#ifdef X11
  xcol=XGetPixel(ximage,x,y);
  loop (c,0,16) if (xcoltab[c]==xcol) break;
  if (c>=16) c=0;
#else
  c=getpixel(x,y);
#endif

  if (ps) fprintf(f,"%c%02x",x%20?' ':'\n',bw[c]); 
  else fwrite(rgb[c],3,1,f); }

if (ps) fputs("\nshowpage\n",f);
fclose(f);
#ifdef X11
if (ximage) XDestroyImage(ximage);
#endif
}
}
