/* C-version of eprtscr.pas
standard VGA (640pix wide) to Epson 9pin, fast
to be #included

===== (c) J.Kolafa 1990 ===== update 1994
hard copy of the screen to the printer LPT1.
All non-black colors will be printed in black. Should be called as:
PrtScr();
available in graphic mode only */

static FILE *lpt1;

static void PrintStr(char *s)
{
fwrite(s,1,strlen(s),lpt1);
}

unsigned int swap(unsigned int w)
{
char x,*c=(char*)&w;
x=c[0]; c[0]=c[1]; c[1]=x;
return w;
}

void PrtScr(void)
{
unsigned int i,j,k,n,b,off;
unsigned char dot[640],mask;
struct image_s {
  unsigned int xsize,ysize;
  struct l_s {
    unsigned int b8[40],b4[40],b2[40],b1[40]; /* getmaxx/16 */
    } l[8];
  } image;
struct viewporttype ViewPort;

if (getmaxx()!=639) return;

lpt1=fopen("lpt1","wb");

getviewsettings(&ViewPort);
setviewport(0,0,639,479,0);

PrintStr("\33@\33A\10"); /* init + spacing 8"/72 */

i=0;
do {

  getimage(0,i,639,i+7,&image);
  memset(dot,0,640);
  mask=128;
  loop (j,0,8) {
    loop (k,0,40) {
      off=16*k;
      b=swap(image.l[j].b1[k] | image.l[j].b2[k] | image.l[j].b4[k] | image.l[j].b8[k]);
      loop (n,0,16) {
        if ((b & 0x8000)!=0) dot[off+n]|=mask;
        b<<=1; } }
    mask>>=1; }

  for (n=639; n>0; n--) if (dot[n]!=0) goto l2;
  n=0;
  l2: n++;

  PrintStr("\33L");
  fwrite(&n,2,1,lpt1);

  fwrite(dot,1,n,lpt1);
  PrintStr("\r\n");
  i+=8;
  } while (i<=479);

PrintStr("\33""2\r\n");  /* 1""/6 CR LF */

setviewport(ViewPort.left,ViewPort.top,ViewPort.right,ViewPort.bottom,ViewPort.clip);
fclose(lpt1);
}
