#include "prec.h"

int GJlineq(int il,int ih, REAL **a, REAL *b, REAL *x)
{

/***
Solves a system of  n  linear eqns  AX=B  by the Gauss-Jordan elimination with a
partial selection of the pivotal element.  The function LinEq returns  -1  in
the case of singularity.
***/

REAL aa,t;
int i,j,k;

/*** Gauss-Jordan elimination ***/
loop (k,il,ih-1) {
  aa=0.0;
  loop (i,k,ih) {
    t=a[i][k];
    if (fabs(t)>fabs(aa)) { aa=t; j=i; } }
  if (aa==0.0) return -1;
  if (j!=k) {
    loop (i,k,ih) {
      t=a[j][i]; a[j][i]=a[k][i]; a[k][i]=t; }
    t=b[j]; b[j]=b[k]; b[k]=t; }
  loop (i,k+1,ih) {
    t=a[i][k]/aa;
    loop (j,k+1,ih) a[i][j]-=t*a[k][j];
    b[i]-=t*b[k]; } }

/*** back substitution ***/
for (i=ih-1; i>=il; i--) {
  if (a[i][i]==0.0) return -1;
  x[i]=b[i]/a[i][i];
  loop (j,il,i) b[j]-=x[i]*a[j][i]; }

return 0;
}
