#if !defined(LONGPRECINCLUDED)

#define LONGPRECINCLUDED

#define REAL long double

#ifdef DOS

#ifdef MATHLL
/* patched library MATHLL.LIB must be linked ! */
/* WARNING: only sqrt,exp,log,fabs,pow are patched
   duplicate _powil is not error */
#include <mathll.h>
#define fabs fabS
#define powi powil
#define log loG
#define exp exP
#define sqrt sqrT
#define pow poW
#endif /* MATHLL */

#else /* !DOS : set of functions as logl,expl assumed */
#define copysign copysignl
#define nextafter nextafterl
#define acos acosl
#define asin asinl
#define atan atanl
#define atan2 atan2l
#define ceil ceill
#define cos cosl
#define cosh coshl
#define exp expl
#define fabs fabsl
#define floor floorl
#define fmod fmodl
#define frexp frexpl
#define hypot hypotl
#define ldexp ldexpl
#define log logl
#define log10 log10l
#define modf modfl
#define pow powl
#define rint rintl
#define sin sinl
#define sinh sinhl
#define sqrt sqrtl
#define tan tanl
#define tanh tanhl
#define trunc truncl
#endif

#define sqr  sqrl
#define cub  cubl
#define pow4 pow4l
#define pow5 pow5l
#define pow6 pow6l
#define powi powil
#define fmax fmaxl
#define fmin fminl
#define frac fracl
#define cbrt cbrtl

#ifdef cubrt
#undef cubrt
//#define cubrt(X) pow((X),(REAL)(1)/3)
// cbrt() = cube root by C99, POSIX.1-2001
#define cubrt(X) cbrtl(X)
#endif

#ifdef Sign
#undef Sign
#define Sign sign
#endif

#define PI_LONG 3.141592653589793238462643L

#ifdef PI
#undef PI
#define PI PI_LONG
#endif

#endif
