/* interface to:
  PRECISION==0 : float version (not tested)
  PRECISION==1 : double version (default if PRECISION is not #defined)
  PRECISION==2 : long double version
                 DOS/TC warning: check longprec.h and #define MATHLL !
  PRECISION>2  : emulated high precision numbers (HIGHPREC=PRECISION)
                 in C++ (see modules highprec.h, highprec.cc)
  (HIGHPREC==2 not available, but it almost does not make sense)
WARNING: this module must be #included after all system header files!
*/

#ifndef PRECINCLUDED
#define PRECINCLUDED

#ifndef PRECISION
#define PRECISION 1
#endif

#if PRECISION<=2
#define Val(X) (double)(X)
#define Int(X) (int)(X)
#endif

#if PRECISION>2
#define HIGHPREC PRECISION
#include "highprec.h"

#elif PRECISION==2
#include "longprec.h"

#elif PRECISION==1
#define REAL double

#elif PRECISION==0
#include "fltprec.h"
#else
#error bad PRECISION
#endif

#endif
