/****************************************************************************/
/* this came from NSK, later used in simolant */
static struct buttons_s {
  struct buttons_s *next;
  int x0,x1,y0,y1;
  unsigned key;
  const char *help;
} *buttonshead = NULL;

void makebutton(int x, int y, unsigned key,const char *text,const char *help)
{
  struct buttons_s *b;
  int l;

  looplist(b,buttonshead) if (key==b->key) goto found;

  b=malloc(sizeof(struct buttons_s));
  if (!b) {
    fprintf(stderr,"no heap for a button\n");
    sleep(1);
    return; }
  b->next=buttonshead; buttonshead=b;
  b->key=key;

 found:
  l=strlen(text)+1;
  b->x0=x;
  b->x1=x+l*xfont.width;
  b->y0=y;
  b->y1=b->y0+xfont.height+6;
  b->help=help;
  //  b->help="TEST";
  setfillstyle(1,WHITE);
  setcolor(BLUE);
  bar(b->x0,b->y0,b->x1,b->y1);
  outtextxy(x+4,y+5,text);

  setlinestyle(0,0,3);
  setcolor(LIGHTGRAY);
  line(b->x0,b->y0,b->x1,b->y0);
  line(b->x0,b->y0,b->x0,b->y1);
  setcolor(DARKGRAY);
  line(b->x1,b->y1,b->x1,b->y0);
  line(b->x1,b->y1,b->x0,b->y1);
  setfillstyle(1,BLACK);
  setcolor(WHITE);
  setlinestyle(0,0,1);
}

static struct buttons_s *getbutton(void) /*********************** getbutton */
{
  struct buttons_s *b;

#ifdef DEBUG
  fprintf(stderr,"getbutton: %d %d\n",dosmouse.x,dosmouse.y);
#endif

  looplist (b,buttonshead)
    if (dosmouse.x>=b->x0 && dosmouse.x<=b->x1 && dosmouse.y>=b->y0 && dosmouse.y<=b->y1) {
      setlinestyle(0,0,3);
      setcolor(DARKGRAY);
      line(b->x0,b->y0,b->x1,b->y0);
      line(b->x0,b->y0,b->x0,b->y1);
      setcolor(LIGHTGRAY);
      line(b->x1,b->y1,b->x1,b->y0);
      line(b->x1,b->y1,b->x0,b->y1);
      XFlush(display);
      usleep(200000);
      line(b->x0,b->y0,b->x1,b->y0);
      line(b->x0,b->y0,b->x0,b->y1);
      setcolor(DARKGRAY);
      line(b->x1,b->y1,b->x1,b->y0);
      line(b->x1,b->y1,b->x0,b->y1);
      setfillstyle(1,BLACK);
      setcolor(WHITE);
      setlinestyle(0,0,1);

#ifdef DEBUG
      fprintf(stderr,"button %d=%c\n",b->key,b->key);
      //      fprintf(stderr,"button %d=%c help=%s\n",b->key,b->key,b->help);
#endif
      return b;
    }

  return NULL;
}

