#include "gui_show.h"

namespace gctrl {

ShowApp::ShowApp (  long wid, char *xml_file ) 
  : GUIApp(wid, xml_file, "Show menu")
{
  b_show_wire = b_show_wire_black = 0;
  b_show_balls = b_show_bsticks = 0;
  b_show_bsticks_black = b_show_sticks = b_show_sticks_black = 0;
  b_play = b_fwd = b_bckwd = b_first =  b_last = 0;
  b_play_bwd = b_swing = b_play_start = 0;
  b_speed_up = b_speed_down = b_freeze = 0;
  b_ballsize_inc =  b_ballsize_dec = 0;
  b_ballratio_inc =  b_ballratio_dec = 0;
  b_trace = b_redraw = b_projections = 0;
  b_frame_fwd = b_frame_bwd = 0;
  b_move = b_unmark = 0;

  builder->get_widget("b_show_wire",        b_show_wire);
  builder->get_widget("b_show_wire_black",  b_show_wire_black);
  builder->get_widget("b_show_sticks",      b_show_sticks);
  builder->get_widget("b_show_sticks_black",b_show_sticks_black);
  builder->get_widget("b_show_bsticks",     b_show_bsticks);
  builder->get_widget("b_show_bsticks_black", b_show_bsticks_black);
  builder->get_widget("b_show_balls",       b_show_balls);
  builder->get_widget("b_ballsize_inc",     b_ballsize_inc);
  builder->get_widget("b_ballsize_dec",     b_ballsize_dec);
  builder->get_widget("b_ballratio_inc",    b_ballratio_inc);
  builder->get_widget("b_ballratio_dec",    b_ballratio_dec);
  builder->get_widget("b_trace",            b_trace);
  builder->get_widget("b_redraw",           b_redraw);
  builder->get_widget("b_fwd",              b_fwd);
  builder->get_widget("b_bckwd",            b_bckwd);
  builder->get_widget("b_first",            b_first);
  builder->get_widget("b_last",             b_last);
  builder->get_widget("b_play",             b_play);
  builder->get_widget("b_play_start",       b_play_start);
  builder->get_widget("b_play_bwd",         b_play_bwd);
  builder->get_widget("b_speed_up",         b_speed_up);
  builder->get_widget("b_speed_down",       b_speed_down);
  builder->get_widget("b_freeze",           b_freeze);
  builder->get_widget("b_projections",      b_projections);
  builder->get_widget("b_swing",            b_swing);
  builder->get_widget("b_frame_fwd",        b_frame_fwd);
  builder->get_widget("b_frame_bwd",        b_frame_bwd);
  builder->get_widget("b_move",             b_move);
  builder->get_widget("b_unmark",           b_unmark);
  builder->get_widget("b_stdrot",           b_stdrot);

  connect_action_clicked( b_show_wire,         38, "wire.png");                      // &
  connect_action_clicked( b_show_wire_black,   94, "wire_black.png");                // ^
  connect_action_clicked( b_show_balls,        37, "spheres.png");                   // %
  connect_action_clicked( b_show_sticks,       64, "sticks_col.png" );               // @
  connect_action_clicked( b_show_sticks_black, 33, "sticks_black.png" );             // !
  connect_action_clicked( b_show_bsticks,      36, "bsticks_col.png" );              // $
  connect_action_clicked( b_show_bsticks_black,35, "bsticks.png" );                  // #
  connect_action_clicked( b_ballsize_inc,      82, "list-add.png");                  // R
  connect_action_clicked( b_ballsize_dec,      114,"list-remove.png");               // r
  connect_action_clicked( b_ballratio_inc,     85, "list-add.png");                  // U
  connect_action_clicked( b_ballratio_dec,     117,"list-remove.png");               // u
  connect_action_clicked( b_fwd,               125,"media-seek-forward.png");        // ,
  connect_action_clicked( b_play,              49, "media-playback-start-color.png");// 1
  connect_action_clicked( b_play_start,        105,"media-playback-from-start.png"); // i
  connect_action_clicked( b_bckwd,             123,"media-seek-backward.png");       // {
  connect_action_clicked( b_first,             44, "media-skip-backward.png");       // }
  connect_action_clicked( b_last,              46, "media-skip-forward.png");        // .
  connect_action_clicked( b_freeze,            48, "media-playback-pause.png");      // .
  connect_action_clicked( b_speed_up,          83, "list-add.png");                  // S
  connect_action_clicked( b_speed_down,        115,"list-remove.png");               // s
  connect_action_clicked( b_frame_fwd,         93 ,"media-skip-one-forward.png");    // ]
  connect_action_clicked( b_frame_bwd,         91 ,"media-skip-one-backward.png");   // [
  connect_action_clicked( b_swing,             119 );  // w
  connect_action_clicked( b_play_bwd,          98 );   // b
  connect_action_clicked( b_trace,             116);   // t
  connect_action_clicked( b_redraw,            32 );   // space
  connect_action_clicked( b_projections,       61 );   // =
  connect_action_clicked( b_move,              109);   // m
  connect_action_clicked( b_unmark,            21 );   // ctrl - u
  connect_action_clicked( b_stdrot,             9 );   // TAB


  // GUIApp's widgets
  if ( b_save ){
    b_save->show();
    connect_action_clicked( b_save,              19 );   // ctrl - s
  }
}


ShowApp::~ShowApp ()
{
  delete_widget( b_show_wire );
  delete_widget( b_show_wire_black );
  delete_widget( b_show_balls );
  delete_widget( b_show_sticks );
  delete_widget( b_show_sticks_black );
  delete_widget( b_show_bsticks );
  delete_widget( b_show_bsticks_black );
  delete_widget( b_play );
  delete_widget( b_fwd );
  delete_widget( b_bckwd );
  delete_widget( b_first );
  delete_widget( b_last );
  delete_widget( b_speed_up );
  delete_widget( b_speed_down );
  delete_widget( b_ballsize_inc );
  delete_widget( b_ballratio_inc );
  delete_widget( b_ballsize_dec );
  delete_widget( b_ballratio_dec );
  delete_widget( b_trace );
  delete_widget( b_redraw );
  delete_widget( b_freeze );
  delete_widget( b_play_bwd );
  delete_widget( b_projections );
  delete_widget( b_swing );
  delete_widget( b_stdrot );
  delete_widget( b_frame_fwd );
  delete_widget( b_frame_bwd );
  delete_widget( b_move );
  delete_widget( b_unmark );
  delete_widget( b_play_start );
}

}; //namespace
