#ifndef _MY_X11_H
#define _MY_X11_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <sstream>
#include <iostream>

namespace x11 {

typedef XWindowAttributes xwindow_attributes;

// checks whether window with given id exists 
// window - X11 window whose child windows are scanned (needed for recursion)
bool check_winid ( Display *display, Window window, unsigned long id );

bool send_event ( long win_id, 
                  const char *display_name,
                  const char *atom_name, 
                  long action,   
                  long data = 0 );

bool get_xwindow_attributes ( unsigned long win_id, 
                              const char *display_name, 
                              xwindow_attributes &attrs  );


}; // namespace x11
#endif // _MY_X11_H
