/* make show

 see also show4dos.c (the last version with DOS support)

 */

#define VERSION "1.1g"

/* MESS to fix: ball use `chessboard' color level improving (dithering),
   bar not
   BUG: D: size scaled down

new: SHOWNAME
   */
/* make -fmakefile.dos show.exe

NOTE: this information may be obsolete, see man/util.ps or
man/manual.htm and section Utilities for more info.

***************** SHOW ****************** (c) J.Kolafa *******************

SHOW is a viewer of configuration and playback files in the MACSIMUS project.
Brief help for command line options is obtained by calling it without
parameters and help for hot keys and mouse by hot key `h'.

This is UNIX/X11 version: graphics runs in a separate window.
Compile with -DX11

PC/DOS version: see show4dos.c (the last version 1.0b - not supported anymore)

Quick start:

  To show a molecule generated by `blend' with proper atom sizes:

  > blend -p [MORE OPTIONS] mol
  > show mol

  If you have forgotten the -p option (cheaper method with
  approximate atom sizes):

  > blend [MORE OPTIONS] mol
  > show mol

  To show movie of 1 molecule generated by `cookfree':

  > blend -o freemol [-p] [MORE OPTIONS] mol
  > cookfree freemol -y [MORE OPTIONS]
  > show mol

  To show movie of the configuration generated by `cook' etc.:

  > blend -o mysys -p [MORE OPTIONS] spec1 spec2
  > cook mysys mysim -y-1 [MORE OPTIONS]
  > molcfg spec1 spec2 mysim
  > show mysim

INTPUT FILES:
=============

MOLNAME.mol
~~~~~~~~~~~
PROSIS molecule file - see `blend.tex' for detailed info.  Example:
----------------- dme.mol ------------------------
dimethoxyethane
! total charge = 0.00

parameter_set = peo
number_of_atoms = 6

atoms
! i  atom-id  a-type charge chir nbonds bound_atoms
  0 head       CH3O  0.1500  0    1  1
  1 O1         O    -0.3000  0    2  0 2
  2 C1         CH2   0.1500  0    2  1 3
  3 C2         CH2   0.1500  0    2  2 4
  4 O2         O    -0.3000  0    2  3 5
  5 tail       CH3O  0.1500  0    1  4
----------------- end of dme.mol --------------------
NOTES:
  The first line contains any text.
  ! in 1st column denotes comment line.
  SHOW.EXE does not require parameter_set.  The contents of columns
    a-type, charge, and chir are irrelevant.
  atom-id is used by SHOW (se below).


MOLNAME.gol
~~~~~~~~~~~
Defines atom radii and colors for ball graphics.  Example:
--------------------- dme.gol --------------------
!sphere#1
! dme.gol
6
GRAY    1.473
RED     1.179
GRAY    1.540
GRAY    1.540
RED     1.179
GRAY    1.473
--------------------- end of dme.gol -----------------
NOTES:
  1st two lines are not used by SHOW, 3rd must contain number_of_atoms.
  permitted radii are 0.01--2.55 with resolution 0.01 (internally they
    are stored as unsigned char in units of 0.01A)
  Available colors: WHITE YELLOW RED GREEN BLUE CYAN/GRAY MAGENTA

PLBNAME.plb
~~~~~~~~~~~
The playback file.  It may contain a header of 2 floats (float=4B real),
where the 1st float is the number_of_atoms (see also option -k).
Then, arbitrary number of configurations follow, each consisting of
number_of_atoms float vectors (x,y,z).
New variable-L version contains -3 is the second item of the header,
and every frame is prepended by a vector with the box size, Lx,Ly,Lz

PLBNAME.pla
~~~~~~~~~~~
Ascii playback files have format:
- optional 1 header line with one number containing number of atoms
  or two numbers corresponding to the plb header
- optional line of Lx Ly Lz
- the configurations in three-column (x y z) format
See utilities asc2plb and plb2asc

PLBNAME.3db
~~~~~~~~~~~
blend configuration file, contains one configuration (frame) in the same
format as playback files, but no header of 2 floats (obsolete)

OUTPUT FILES:
=============
Are always in the form of PLBN0000.ext, PLBN0001.ext, ...
where PLBN denotes first 4 characters of PLBNAME (padded by `-' if
PLBNAME is shorter than 4 characters). Repeating use of dumping
functions use consecutive numbers.
Extensions are:
  .ps  : PostScript: see hotkeys O (gray) C (color)
         note that using the (m)erged file crates `animated' PostScript
         (if viewed in GhostView)
         works in ball and bar modes only, gray PS also on the one-color
         bar mode
  .nff : Neutral File Format: hotkey N, scene description file for `ray',
         the "reasonably intelligent raytracer" by Mark VandeWettering
         (m)erged file just contains more frames to show movement
         works in ball and bar modes only (see Raytracing below)
  .pov : PovRay scene file, hotkey V (see Raytracing below)
  .plb : output playback: hotkey L
         works in ball mode only
  .zb  : z-buffer:  hotkey B, for program stereo making stereograms
         (m)erged file not supported, but using tracing (hotkey t)
         will create a `merged' picture
         works in ball and bar modes only
  .ppm : Portable Pixel Map: hot key P\n\
         (m)erged file not supported, but using tracing (hotkey t)
         will create a `merged' picture
         works in ball and bar modes only (?)

NOTES ON OPTIONS:
~~~~~~~~~~~~~~~~~
-aAN: max rotation angle is 2*PI/AN, initial (PI/8)/AN (default=4)

-b1: show only the backbone.  Meaningful only for proteins created by
     pdb and blend
-b-1 as above and do not show heteroatoms
-b2: show longest chain (general algorithm for a backbone)

-cXYZ (X,Y,Z=digits): center molecule in x,y,z before any transform
      (given by options -x -y -z -l)
      -c111 centers all coordinates

-d#  initial delay between frames [default=50] (?)

-r : is required if the plb-file was created on machines with IEEE
     numbers but opposite endianess (like SGI, SUN)
     (note: -r- turns off)

-r12g34b56 : if a number (not negative) follows -r then this option is
     interpreted as RGB->gray conversion data for PostScript output

-k0 or -k- : if plb-file is without header, not needed for *.3db input

-l#   size of periodic box: will transform all coordinates into periodic
      box [0,L)^3, L=#, see also -c -x -y -z
-l    as above, L taken from hdr[1]

-x# -y# -z#  adds vector (x,y,z) to all coordinates, this is done after
      centering after (if selected by option -c) and before periodic
      boundary condition transform (if selected by option -l)
-x#L -y#L -z#L  as above, (x,y,z) are in units of L (must be given in
      plb file or by -l#)

-W -Y -R -G -B -C -M:
  These recoloring options should be followed by string appearing in
  the atom-id field in the MOLNAME.mol file.  Example:
    -YCYS
  will color all CYSteins Yellow
  Multiple recoloring is scanned from right, e.g.:
    -BC -MCH3E
  will color CH3E as Magenta, other Carbons as Blue
-O: as above to Omit

-f0 or -f- : do not show free (non-bonded) atoms as dots in the bond-showing
  mode.  Default=show dots (internally implemented as a bond to
  the free atom itself, cf. option -i)
  -f2 : use big dots

-w : white background
-w-# : add more white (in %) to the default colors for NFF dump and PS.
  Recommended for NFF and color PS printed on some printers, e.g. ink-jet
  printer, but note that this may depend on software used for printing
  Not recommended for gray PS (already some light gray changed to white)

-g# no longer valid

-g XGEOMETRY
     X11: initial window size and position,
     e.g. -g 300x300+100+100
     (to start given graphical mode, use -I)

-bg XCOLOR
     X11:  background color, e.g. -bg darkblue or -bg #ffffff

-vXY [decomissioned: mouse sensitivity]

-i#  max # of bonds: the size for the table of bonds, the defaiult is
     ns*1.1+10; if necessary to increase, show will warn you
     you may try to decrease -i# in the case of low memory

-j#  (if compiled with #define SHELL)
     Showing shell of water molecules around protein
     #=initial HOH shell width
     see also hotkeys j J

-JXX name of "water"

-m[-]FILE:FRAME  playback file and frame to be matched
     see hot keys m M (changed into ' ")
     -FILE means reversed endian
     default is -mmatch.plb:1

-s#  initial scale in %, default = -s100

-t0  the NFF dump will never have a `floor' (plane of light brown color the
     molecule is laid on) is
-t1  the NFF dump will always a `floor'
     default is floor for one frame NFF dump, no floor for a series of files
     or a merged file

-u0  hot keys r R U will allow arbitrary resizing of bars or balls
     normally (option -u1) there is certain `reasonable' limit good for most
     molecules
-u   use thick bars with balls of the same size is default for modes 3 and 4,
     the same as hotkey D, useful for NFF output

-p#@ recolor atom by color @ if group charge > #% e (charge is in %)
-n#@ recolor atom by @ if group charge < % e
     Example: -n-80Y shows all groups with charge < -0.8e in yellow
-e1  larger group definition
-e0  small group definition
-\#  GOLD: show grid # x # at gold surface (70% vdW)
-\-1 show gold as balls (densely packed)
-\#\ -\-1\ as above, 2 walls
-\#rRADIUS radius for GOLD
-\   box around (default)
-\0  no box

-ISTRING string of hot keys to perform.  To dump data several times, `k'
  must be on.  Quit = uppercase Q.  Example:
    show "-I****zzyyy/y/xxx%rrrrrrrrkNoQ" -s-70 -g 240x240 FILENAME -t0
  dumps a NFF file in a specified orientation and quits show
  (to be used in scripts generating a series of animated pictures)

HOT KEYS:
~~~~~~~~~
h H ?          Help
ESC q Q        quit: wait for beep then type Esc again to quit or any
               key to cont
SPACE          clear screen/redraw
x X y Y z Z    rotate along axes (SHIFT=sign of rotation)
* /            multiply/divide rotation angle by 2
cursors        move up-down-left-right
Home End       move eye from/to screen (central projection only)
^A ^E          synonyms for Home End
=              toggle central projection (default) / parallel projection
+ -            rescale picture (note: quotients of enlarging and shrinking are
               in the golden ratio)
S s            Speed of playback and animation: S increase, s decrease
R r            Radius: enlarge/shrink balls (note: quotients of enlarging
               and shrinking are in the golden ratio)
U u            increase/decrease ball/bar ratio (modes 3 and 4)
d              reset default ball/bar size (dumbell shape of modes 3,4)
D              thick bars (spheres in modes 3,4, of the same size as balls)
i              Initalize: restart playback from file beginning
0              stop playback
1 .. 9         play by specified number of frames/step
, .            rewind to begin/end and freeze
[ ]            freeze and move by 1
{ }            freeze and move by 10%
f              freeze/play toggle
b              forward/Backwards toggle
w              swing mode: automatically cycling forward/backward
c              recenter
t T            trace toggle, bond modes: show previous configurations in blue
               bar and ball modes: smash all figures together; T: erase prev.
g G            Graphics mode toggle
! @ # $ % ^ &  seven graphics modes (=shift 1 2 3 4 5 6 7) directly
k              Keyboard mode toggle (if on [beeps] then redraws picture
               after each key [slow!], if off then accepts several keys
               while drawing)
`NUMBER        ` followed by decimal number will execute the following
               command NUMBER times.  E.g. `12y  will rotate 12 times
               around the y-axis; if keyboard mode is on then all of
               them will be displayed, if off then just the result
               Hint: use `100] to move by 100 frames
M m            Matching algorithm. show must be started with option
               -mPLBFILE:FRAME to define the configuration to be matched with
               Pressing m will rotate and move the current configuration to
               obtain the best match with the -mPLBFILE:FRAME configuration
               Pressing M does the same but more accurately (less error)
n              toggle printing frame number
               (dumped PPM is always without the frame number)

Hot keys A B C N L O P E cause dumps of various data. Must be immediately
followed by one of:
  o O 1        dump only (o)ne file
  s S 9        dump (s)eries of files (until e is pressed)
               BUG: in some cases, dumps by one file more
  m M 0        dump (m)erged file (until e is pressed)

[A              decomissioned]
B              dump z-buffer .zb
C              dump color PostScript .ps
E              dump color EPS .eps
N              dump NFF file .nff for `ray'
L              dump new playback file .plb
O              dump gray PostScript .ps
P              dump PPM file .ppm (P6)
V              dump PovRay scene file .pov

e              end series of files or close merged file
[a              decomissioned]

Example: create color PostScript
               $ (select mode, can use any of ! @ # $ %)
               C (select color PostScript)
               o (select one frame)
Example: create raytraced movie of a rotating molecule
               % (select mode, can use any of ! @ # $ %)
               k (select every key mode)
               N (select NFF)
               s (select series of files)
               `63x (make another 63 frames by rotating around x-axis)
               e (end series)
          BUG: will generate file PLBN0064.nff identical to PLBN0063.nff
          then, use the raytracer like:
            ray -n PLBN0000
            ray -n PLBN0001
            ...
            ray -n PLBN0063
          then, make a movie from PLBN####.ppm using your favorite software

NEW: `K' (toggle) darker NFF color or PovRay alternate color

MOUSE : see online help (hotkey h)

BUGS:
  The z-buffer scaling algorithm is simple and fast, but it sometimes fails.
  Typing SPACE fixes the problem.

============================================================================
Raytracing:
~~~~~~~~~~~
  `show' does not do ray tracing but generates data for two raytracers.

  1/ `ray', the "reasonably intelligent raytracer" by Mark
     VandeWettering, with some improvements.  In the ball or
     bar-and-ball mode, use hot key `N', followed by `o' (one) or `m'
     (merge) or `s' (series).  To render the picture, use
       ray -n FILE#### [MORE OPTIONS]
     where FILE####.nff is the file generated
     use
       ray -h
     to get help
     Example:
       ray -n test0000 -S.5 -vxv
     will calculate test0000.ppm from test0000.nff of half the
     original size (-S.5) with fast but reasonable quality
     antialiasing and show it using xv

     Advantages:
       better `ambient light' (`inside' of molecules)
       easy change of picture aspect ratio
       tailored to this type of scenes
     Disadvantages:
       no textures and special effects
       sometimes cumbersome control
       radiosity calculation not supported

  2/ PovRay, "Persistence Of Vision" raytracer.   In the ball or
     bar-and-ball mode, use hot key `V', followed by `o' (one) or `m'
     (merge) or `s' (series).  To render the picture, use
       ray +IFILE####.pov [MORE OPTIONS]
     where FILE####.pov is the file generated
     File "show.inc" defining colors and textures is needed

     Advantages:
       much richer set of options and special effects, textures,...
       widely used - a sort of standard
     Disadvantages (may be fixed in newer versions):
       (?: perhaps somebody tells me how to overcome these problems...)
       uses nonstandard left-handed coordinate system
       difficult to change picture aspect ratio
       cannot render large molecules (core dump!)
       bad ambient light (`inside' of molecules poorly rendered)
     ?: `radiosity' is supported, but according to my experience it
       does not work and just makes ugly random patches -- perhaps
       will be fixed in future versions...

     Example:
       povray res320.ini +A +Itest0001.pov +D
     will calculate test0001.<what-is-your-default> from test0001.pov
     in size 320x200 with fast but reasonable quality
     antialiasing (+A) displaying picture in progress (+D)

******************************************************************************/

// #define BETTERBALLS /* slightly more precise but slower ball algorithm */
                    /* not needed for large ZBUFDEPTH (X11) */

#define CHARGES     /* recoloring by charges possible: takes space! */
#define GOLFROMMOL  /* does not need gol-file: approximate and takes space! */
#define SHELL       /* allows option -j and hotkeys 'j','J': show waters close
                       to protein BUG: 'j','J' takes effect after next frame
                       is reloaded */
#define DEPTH       /* depth cue */
#define SLICES      /* enable z-slices */

#define SYNC        /* to synchronize 2 show's
                       (see also option -\` and hot key ~) */

#define ASPECT 1

#ifndef GOLD
#  define GOLD (3.29*.7) /* show (golden) surface at height GOLD (70% of vdW) */
#endif /*# GOLD */

#ifndef XIMAGE
#define XIMAGE 1
/* X11 mode:
   0=draw image (in ball/stick modes) directly pixel-by-pixel (slow, shaky)
   1=put image (faster, avoids flickering), ximage copied from window
     (problems with full screen, moving of window screen out of screen)
   2=put image (faster, avoids flickering), ximage created from scratch
     (not fully compatible, fails on newer CygWins)
*/
#endif

#include "ground.h"
#include "alloc.h"

#define ZBUFDEPTH 65535
int SCRLEN,oldSCRLEN=-1;
char *kbdstring=""; /* X11: inital keystroke */
#include "draw.h"
#include "mouselib.h"

#if XIMAGE
XImage *ximage;
extern GC gc;
extern long unsigned *xcoltab;
#endif

#  include "options.h"
#  define x badoption
int optionlist[32] =
/*` a b c d e f  g h i j k l  m n o p  q r   s t  u  v w x y z  { | } ~ ? */
{-1,4,0,0,0,1,-2,7,0,0,0,2,0,-1,0,0,0,50,0,100,0,-1,21,0,0,0,0,-5,1,1,0,x};
/*@ A B C D E F  G H I J K L  M N O P  Q R   S T  U  V W X Y Z  [ \ ] ^ _*/
#  undef x

#  define VEC(R) R[0],R[1],R[2]
/* BRRR: povray uses left-handed coord system ! */
#  define iVEC(R) R[0],R[1],-R[2]

#  define SITEINT short

typedef struct site_s {
#  ifdef CHARGES
  float charge;
#  endif /*# CHARGES */
  unsigned SITEINT c;     /* internal (palette) atom color (for spheres) */
  unsigned SITEINT r;     /* radius in 0.01 A; temporary color info */
  unsigned SITEINT mark;  /* 0=none, 1=H, 2=O (for HB), 4=click-marked */
#  ifdef GOLFROMMOL
  SITEINT molcol;
#  endif /*# GOLFROMMOL */
#  ifdef SHELL
  SITEINT shell; /* 1=water, 2=water Oxygen, 4=to draw */
#    define SHELLTEST(I) if (site[I].shell&4)
#  else /*# SHELL */
#    define SHELLTEST(I) /*empty*/
#  endif /*#!SHELL */
  char *id;
  char *type;
} site_t;

char *shellkey="HOH";
char *parameter_set="DUMMY";


typedef float fvector[3];
typedef double real;
#  include "vector3d.h" /* needed by dihangle.c */
typedef int ivector[2];

#  ifdef SYNC
FILE *fifo;
int follow;
#  endif /*# SYNC */

int bodyframe; /* rotations WRT fixed frame/body frame */

double drot[3][3]={
  {1,0,0},
  {0,1,0},
  {0,0,1} };

fvector rot[3]={
  {1,0,0},
  {0,1,0},
  {0,0,1} };

fvector *cfg; /* [ns] */

/* modes BOND and BOND2:
  xy are screen coordinates, xy0 are the old ones
  (because the old bonds are erased by xor-redrawing)
  similarly bond and bond0
*/
ivector *xy,*xy0; /* [ns] */
#  ifdef GOLD
ivector *xygold,*xygold0;
int slit=8,incube=1,defaultslit=1; /* slit=4 for 1 wall, 8 for 2 walls */
float gold=(3.29*.7); /* show (golden) surface at height GOLD (70% of vdW) */
#  endif /*# GOLD */
site_t *site; /* [ns] */
static fvector center;
static float typicalsize;

int ns; /* number of sites */
int nc,nc0; /* number of bonds (constraints), incl. possible hydrogen bonds */
            /* nc0 refers to bond0 = erase by xor redrawing */
int ncfix;  /* number of bonds (constraints), as read from .mol */
char *donor="H",*acceptor="O";
float hbdist=0,hbdistq; /* NOTE: a hot key to change hbdist is OK, however,
  changing hbdist=0 to hbdist>0 will break the bond allocation algorithm */
int hbcolor;
void hbonds(void);
void readGOL(void);
unsigned char key;

char
  *molname, /* MOLNAME (without extension) */
  *plbname, /* playback file name or format accepting int (without extension) */
  *plbfn;   /* playback file name or format accepting int (with extension) */

static char *Fn(char *ext) /******************************************* Fn */
{
  static char fn[256];

  strcpy(fn,molname);
  strcat(fn,".");
  strcat(fn,ext);

  return fn;
}

#  define DEL 2000
unsigned char *scrbuf;

unsigned del=0;
static struct timeb { int time,millitm; } t0;
void ftime(struct timeb *x){}
void nosound(void){}
void sound(int i)
{
  fprintf(stderr,"(%d) unknown key=",i);
  if (key>=128) fprintf(stderr,"%d dec.\n",key);
  else if (key<32) fprintf(stderr,"^%c\n",key+64);
  else fprintf(stderr,"%c\n",key);
}

char *li;
typedef int bond_t[3]; /* [2]&0xf0 = bond color (unless BOND2), permanent
                             &0x0f = bond color to show (removed if over box) */
bond_t *bond,*bond0; /* nbond,nbond0 : this and last (cf. xy0) */
                     /* warning: bond may reallocate */
int nbond,nbond0;
int bondeqbond0; /* 1 if bond=bond0 (identical array) */
int maxx,maxxn,maxy,maxyn;

int enlarge(bond_t **bond,int from,int to) /*********************** enlarge */
/* change size of *bond
 the new size is returned
 sizes are in sizeof(bond_t)
 NB: realloc may not be compatible with module alloc.h/alloc.c
*/
{
  bond_t *b;
  int n=min(from,to);

  allocarray(b,to);
  copyarray(b,*bond,n);
  free(*bond);
  *bond=b;

//  prt("bond reallocated: %d->%d",from,to);

  return to;
}

#  define NOCOL 8 /* number of ball colors */
int MODE=249; /* # of palette entries, max. 256, recommended 60..249
                 good numbers are COLLEN*NOCOL+1
                 black=0
                 orange=MODE-1
                 for byte-deep diplays minus some for other applications */
int COLLEN; /* length of palette for one ball colors */
int wscale100=100;

/*
  available atom colors
  WARNING: different color code than turbocolor
  don't change the order or names of colors! - see myline2 !!!
*/
struct colortab_s {
  char *col;      unsigned char rgb[4]; char key,turbocolor; char *NFFcol;} colortab[NOCOL+1] = {
/*      col       {r   g b n.a.  }   -@   for .gol NFF:diff refl spec refr ior */
/*0*/ {"WHITE"   ,{255,255,255,0},  'W', WHITE,      "1 0 20 0 0"},
/*1*/ {"YELLOW"  ,{255,255,0,  0},  'Y', YELLOW,     "1 0 21 0 0"},
/*2*/ {"RED"     ,{255,0,  0,  0},  'R', LIGHTRED,   "1 0 22 0 0"},
/*3*/ {"GREEN"   ,{0,  255,0,  0},  'G', LIGHTGREEN, "1 0 23 0 0"},
/*4*/ {"BLUE"    ,{0,  0,  255,0},  'B', LIGHTBLUE,  "1 0 24 0 0"},
/*5*/ {"CYAN"    ,{0,  223,223,0},  'C', LIGHTCYAN,  "1 0 25 0 0"},
/*6*/ {"MAGENTA" ,{255,0,  255,0},  'M',LIGHTMAGENTA,"1 0 26 0 0"},
/*7*/ {"ORANGE"  ,{255,159,0,  0},  'N',BROWN,       "1 0 26 0 0"},
/*8*/ {""        ,{0,0,0,0},        'O',0,NULL} /* omit atom */
};

/* color->gray conversion for postscript hardcopy */
unsigned char *psgray;
float col2gray[3]={0.3,0.59,0.11};

/* Turbo color -> palette color (offset in the palette table) */
/* AVAILABLE COLORS
   0..8 not available
    9=BLUE
   10=GREEN
   11=CYAN
   12=RED
   13=MAGENTA
   14=YELLOW
   15=WHITE;
   */
unsigned char turbo2pal[16];

struct collist_s {
  struct collist_s *next;
  int colno;
  char *pattern;
} *collisthead=NULL;

static char aminoacids[]="GLY ALA VAL LEU ILE PRO SER THR ASP GLU ASN GLN LYS ARG HIS PHE TYR TRP MET CYS";

static unsigned char (*pal)[3]; /* the palette: RGB */

void setmypalette(void) /*************************************** setmypalette */
{
  int c,i,p,ci;
  unsigned char pa;
  float psg;
  int COLOFF;

  if (pal) return; /* palette already set */

  COLOFF=COLLEN/2;

  allocarrayzero(psgray,MODE);
  allocarrayzero(pal,MODE);

  ci=1;
  loop (c,0,NOCOL) {
    turbo2pal[(int)colortab[c].turbocolor]=1+COLLEN*c;
    loop (i,0,COLLEN) {
      psg=0;
      loop (p,0,3) {
        pa=colortab[c].rgb[p]*(i+COLOFF)/(COLOFF+COLLEN-1);
        pal[ci][p]=pa;
        psg+=pa*col2gray[p]; }
      psg=255.0f-(255.0f-psg)*wscale100/100; /* bit more white */
      if (psg>255.0f) psg=255.0f;
      psgray[ci]=psg;
      ci++;
    } }
  /* orange for digits
  pal[MODE-1][0]=255;
  pal[MODE-1][1]=174; */

  psgray[0]=255;

  //  loop (i,0,MODE) printf("%d  %d %d %d\n",i,pal[i][0],pal[i][1],pal[i][2]);
  loop (i,0,MODE) setpal(i,pal[i][0],pal[i][1],pal[i][2],256);
}

unsigned SITEINT *zbuf;

fvector L,Lh; /* box size, if (isL) */
int isL,varL;

fvector shift;
char shiftinL[3];
int isshift;

int pos;        /* frame number: 1st frame=1 (warning - this has changed!) */
int maxpos;     /* = number of frames */
int lastpos=-1; /* last frame */

FILE *dump,*file,*plb;
enum { NONE,PLB,PPM,ZBUF,NFF,ATM,POV,PS,COLORPS,EPS,BONDPS } dumpmode;
/* NFF must be the 1st TEXT output file */
enum { ONE,SERIES,START,CONT } dumpstat;
char *dumpext[]={"???","plb","ppm","zb","nff","atm","pov","ps","ps","eps","ps"};
char *dumpname=NULL;
int dumpindex;
float hdr[2];
float NFFfloor;

float sx,sy,sz,zzeye=4;
#  ifdef SLICES
int slicecolor;
unsigned SITEINT slicez;
#  endif /*# SLICES */
fvector eye;
int sx0,sy0,sz0,central=1;
float zmin,zmax;
#  ifdef DEPTH
float zmind,zmaxd,cue,icue;
#  endif /*# DEPTH */
int kbdmode=0;
int dumpprepared;
int iplb,percent;

void newplb(int advance) /******************************************* newplb */
{
  FILE *f;
  char fn[256];

  iplb+=advance;
  sprintf(fn,plbfn,iplb);
  f=fopen(fn,"rb");
  if (!f) {
    if (advance) { iplb-=advance; return; }
    else ERROR(("open %s",fn)); }
  fprintf(stderr,"showing %s\n",fn);
  plb=f;
}

#  include "showdump.c"

#  ifdef SHELL
#    include "inshell.c"
#  endif /*# SHELL */

#  ifdef CHARGES
#    include "groupc.c"
int negC,posC;
#  endif /*# CHARGES */

int bigpoint;
int palcolor(int turbo)
/*
  convert TURBO color (BLACK=0,..,WHITE=15) into the (closest) palette color,
  to be used in setcolor() for lines (bonds) and text
*/
{
  /* dark colors but BLUE should not occur */
  switch (turbo) {
    case BLACK: return 0; break;
    case WHITE: return COLLEN; break;
    case YELLOW: case BROWN: return COLLEN*2; break;
    case RED: case LIGHTRED: return COLLEN*3; break;
    case GREEN: case LIGHTGREEN: return COLLEN*4; break;
    case BLUE: return COLLEN*9/2; break;
    case LIGHTBLUE: return COLLEN*5; break;
    case LIGHTGRAY: case DARKGRAY:
    case CYAN: case LIGHTCYAN: return COLLEN*6; break;
    case MAGENTA: case LIGHTMAGENTA: return COLLEN*7;  break;
    default: /* ORANGE */ return MODE-1; }
}

void myline(ivector *xy,int i,int j,int col) /********************** myline */
/*
  draw bond i-j with color col (in the palette; DOS: turbo color)
  col=0: do not draw
  xy is a precalculated array of 2D screen coordinates
  bigpoint>0: i=j (point)
*/
{
  if (!col) return;
#  ifdef SHELL
  if (xy[i][0]==-9999 || xy[j][1]==-9999) return;
#  endif /*# SHELL */
  setcolor(col);
  if (bigpoint==0)
    line(xy[i][0],xy[i][1],xy[j][0],xy[j][1]);
  else if (bigpoint==1)
    putpixel(xy[i][0],xy[i][1]+bigpoint,col);
  else {
    line(xy[i][0]-bigpoint,xy[i][1]-bigpoint,xy[i][0]+bigpoint,xy[i][1]+bigpoint);
    line(xy[i][0]-bigpoint,xy[i][1]+bigpoint,xy[i][0]+bigpoint,xy[i][1]-bigpoint); }
}

void myline2(ivector *xy,int i,int j,int bcol) /******************* myline2 */
/*
  bcol=0: draw bond i-j divided into 2 parts using atom colors
  bcol>0: draw bond i-j with color col
  bigpoint>0: i=j (point)
  if colors of i,j are the same, myline is called
  (note that if a bond composed of 2 parts is redrawn by 1 color, it must be done in 2 parts, too)
  NB: bcol is the palette color (DOS: TURBO color)
*/
{
  int col,xx,yy;

#  ifdef SHELL
  if (xy[i][0]==-9999 || xy[j][1]==-9999) return;
#  endif /*# SHELL */

  if (!bcol)
    col=site[i].c+(COLLEN-1);
  else
    col=bcol;

  if (site[i].c==site[j].c)
    myline(xy,i,j,col); /* this is called also if bigpoint set */
  else {
    setcolor(col);

    xx=(xy[i][0]+xy[j][0])/2;
    yy=(xy[i][1]+xy[j][1])/2;

    line(xy[i][0],xy[i][1],xx,yy);
    if (!bcol)
      col=site[j].c+(COLLEN-1);
    setcolor(col);
    line(xx,yy,xy[j][0],xy[j][1]); }
}

/* INFRONT = what to do if there is something to show in front of the screen */
#  define INFRONT return; /* do not show and return */

/* rescale to fix it:
#  define INFRONT { \
    sound(150); delay(100); nosound(); eye[2]*=1.5; zzeye*=1.5; goto again; }
*/

void showsphere(fvector r,float rad,int c) /********************* showsphere */
{
  fvector cr,R;
  unsigned map;
  int x0,x1,y0,y1;
  int sx01=sx0+1;
  int i,j;
  float xx,yy,rr,d,dr,dx,cscale,epsrr,q;
  int h,col,dotcol;

  if (c>=NOCOL*COLLEN || r[0]>99999.0) return;

  if (rad==0) return;
  cr[0]=r[0]-center[0];
  cr[1]=r[1]-center[1];
  cr[2]=r[2]-center[2];
  R[0]=rot[0][0]*cr[0]+rot[0][1]*cr[1]+rot[0][2]*cr[2]+eye[0];
  R[1]=rot[1][0]*cr[0]+rot[1][1]*cr[1]+rot[1][2]*cr[2]+eye[1];
  R[2]=rot[2][0]*cr[0]+rot[2][1]*cr[1]+rot[2][2]*cr[2];

  if (dumpmode==PLB) {
    opendump();
    fwrite(R,sizeof(fvector),1,dump); }

  if (dumpmode==NFF) {
    dumpnffcol(c);
    calcNFFfloor(R[1]-rad);
    fprintf(dump,"s %.4f %.4f %.4f %.4f\n",VEC(R),rad); }

  if (dumpmode==ATM) {
    int ic=(float (*)[3])r-cfg;
    opendump();
    if (ic>=0 && ic<NS) /* BRRRRRRR */
      fprintf(dump,"%c %lf %lf %lf\n",site[ic].type[0],cfg[ic][0],cfg[ic][1],cfg[ic][2]); }

  if (dumpmode==POV) {
    calcNFFfloor(R[1]-rad);
    fprintf(dump,"sphere {<%f,%f,%f>, %.4f texture {%s%s}}\n",
            iVEC(R),rad,colortab[5].rgb[1]<4?"ALT":"SHOW",colortab[c/COLLEN].col); }

  if (central) {
    q=eye[2]-R[2];
    if (q<=0) INFRONT
    q=eye[2]/q;
    rad*=q;
    R[0]*=q; R[1]*=q; }

  rr=rad*rad;
  epsrr=rr*0.999999;

  {
    Min(zmin,R[2])
    Max(zmax,R[2]+rad)
#  ifdef DEPTH
    Min(zmind,R[2])
    Max(zmaxd,R[2]+rad)
#  endif /*# DEPTH */
  }

  cscale=
#  ifdef DEPTH
    (icue+cue*(R[2]-zmind)/(zmaxd-zmind))*
#  endif /*# DEPTH */
                                         (COLLEN*2-1)/rr;
  dotcol=cscale*rr/2;
#  ifdef SLICES
  if (slicecolor)
    slicecolor=(int)(
#    ifdef DEPTH
               (icue+cue*((slicez-sz0)/sz-zmind)/(zmaxd-zmind))*
#    endif /*# DEPTH */
                                                          ((COLLEN*2-1)/2) )+c;
#  endif /*# SLICES */

  if (option('f')<0 && rad*sy>-1.5 /* note that sy<0 */ ) {
    /* dot instead too small a sphere */
    x0=(int)(R[0]*sx)+sx0; if (R[0]*sx<0) x0--;
    y0=(int)(R[1]*sy)+sy0; if (R[1]*sy<0) y0--;
    if (y0>=0 && y0<maxy && x0>=0 && x0<maxx) {
      map=y0*maxxn+x0;
      h=(int)(R[2]*sz)+sz0;
#  ifdef SLICES
      if (!slicez || slicez>h)
#  endif /*# SLICES */
        if (h>zbuf[map]) {
          zbuf[map]=h;
          scrbuf[map]=c+dotcol; } } }
  else {

    y0=(int)((R[1]+rad)*sy)+sy0; y1=(int)((R[1]-rad)*sy)+sy0;

    if (y0<0) y0=0; if (y1>maxy) y1=maxy;

    loopto (j,y0,y1) {
        yy=(j-sy0)/sy-R[1]; yy=yy*yy;
        d=epsrr-yy;
        if (d>0) dx=sqrt(d); else dx=0;
        x0=(int)((R[0]-dx)*sx)+sx01; x1=(int)((R[0]+dx)*sx)+sx0;
        if (x0<0) x0=0; if (x1>maxx) x1=maxx;
        map=j*maxxn+x0;
#  ifdef SLICES
        if (slicez) {
          int hh;

          loopto (i,x0,x1) {
            xx=(i-sx0)/sx-R[0]; xx=xx*xx;
            dr=d-xx; if (dr<0) dr=0;
            h=(int)((sqrt(dr)+R[2])*sz)+sz0;
            if (slicez>h) {
              if (h>zbuf[map]) {
                col=(int)(cscale*dr);
                zbuf[map]=h;
                scrbuf[map] = c+col/2;
                if (col&1) if ((i+j)&1) scrbuf[map]++;
                /* direct: pokeb(0xA000,map,col); */ } }
            else {
              hh=(int)((-sqrt(dr)+R[2])*sz)+sz0;
              if (slicez>hh) {
                zbuf[map]=slicez;
                scrbuf[map]=slicecolor?slicecolor:MODE-1; } }
            map++; } }
        else
#  endif /*# SLICES */
          loopto (i,x0,x1) {
          xx=(i-sx0)/sx-R[0]; xx=xx*xx;
          dr=d-xx; if (dr<0) dr=0;
          h=(int)((sqrt(dr)+R[2])*sz)+sz0;
          if (h>zbuf[map]
#  ifdef BETTERBALLS
              /* more precise but more time consuming */
              || (h==zbuf[map] && ((sqrt(dr)+R[2])*sz)+sz0)>zbuf[map]
#  endif /*# BETTERBALLS */
              ) {
            col=(int)(cscale*dr);
            zbuf[map]=h;
            scrbuf[map] = c+col/2;
            if (col&1) if ((i+j)&1) scrbuf[map]++; }
          map++; }
      }
  }
}

float grad=0.1; /* box thickness */
float gradscale=-1; /* arbitrary scaling of the frame thickness */

void showbar(fvector r0,fvector r1,int c) /************************* showbar */
{
  fvector cr[2],R[2];
  unsigned map;
  int x0,x1,y0,y1;
  int k,i,j,col;
  float xx,yy,rr,DD,q,lp,lm,lR0,lR1,ff,tt,cscale;
  int h;
  float D[3],d[2];
  float dd,ss,rad=grad,scal;

  if (r0[0]>99999.0 || r1[0]>99999.0 || !c) return;

  cr[0][0]=r0[0]-center[0];
  cr[0][1]=r0[1]-center[1];
  cr[0][2]=r0[2]-center[2];
  cr[1][0]=r1[0]-center[0];
  cr[1][1]=r1[1]-center[1];
  cr[1][2]=r1[2]-center[2];

  loop (k,0,2) {
    R[k][0]=rot[0][0]*cr[k][0]+rot[0][1]*cr[k][1]+rot[0][2]*cr[k][2]+eye[0];
    R[k][1]=rot[1][0]*cr[k][0]+rot[1][1]*cr[k][1]+rot[1][2]*cr[k][2]+eye[1];
    R[k][2]=rot[2][0]*cr[k][0]+rot[2][1]*cr[k][1]+rot[2][2]*cr[k][2]; }

  if (dumpmode==NFF) {
    dumpnffcol(c);
    fputc('c',dump);
    loop (k,0,2) {
      fprintf(dump," %.4f %.4f %.4f %.4f",VEC(R[k]),rad);
      calcNFFfloor(R[k][1]-rad); }
    fputc('\n',dump); }

  if (dumpmode==POV) {
    fprintf(dump,"cylinder {");
    loop (k,0,2) {
      fprintf(dump,"<%f,%f,%f>,",iVEC(R[k]));
      calcNFFfloor(R[k][1]-rad); }
    fprintf(dump,"%f open texture{%s%s}}\n",
            rad,colortab[5].rgb[1]<4?"ALT":"SHOW",colortab[c/COLLEN].col); }

  loop (k,0,2) {
    if (central) {
      q=eye[2]-R[k][2];
      if (q<=0) INFRONT
      q=eye[2]/q;
      rad*=sqrt(q);
      R[k][0]*=q; R[k][1]*=q; }

    Min(zmin,R[k][2])
    Max(zmax,R[k][2])
#  ifdef DEPTH
    Min(zmind,R[k][2])
    Max(zmaxd,R[k][2]+rad)
#  endif /*# DEPTH */
  }

  D[0]=R[1][0]-R[0][0];
  D[1]=R[1][1]-R[0][1];
  D[2]=R[1][2]-R[0][2];

  loop (i,0,2) if (D[i]==0) D[i]=rad*0.01;

  DD=Sqr(D[0])+Sqr(D[1]);

  if (D[1]<0) loop (i,0,3) {
    D[i]=-D[i];
    xx=R[0][i],R[0][i]=R[1][i],R[1][i]=xx; }

  d[0]=D[1]; d[1]=-D[0]; /* rot -90 deg = clockwise */

  xx=rad/sqrt(DD);
  d[0]*=xx; d[1]*=xx;
  rr=rad*rad;
  cscale=
#  ifdef DEPTH
    (icue+cue*((R[0][2]+R[1][2])/2-zmind)/(zmaxd-zmind))*
#  endif /*# DEPTH */
                                                         (2*COLLEN-1)/rr;

  y1=(R[0][1]-fabs(d[1]))*sy+sy0; y0=(R[1][1]+fabs(d[1]))*sy+sy0;

  if (y0<0) y0=0; if (y1>maxy) y1=maxy;

  loopto (j,y0,y1) {
    yy=(j-sy0)/sy-R[0][1];
    lp=R[0][0]+d[0]+(yy-d[1])*(D[0]/D[1]);
    lm=R[0][0]-d[0]+(yy+d[1])*(D[0]/D[1]);
    lR0=R[0][0]+     yy*(d[0]/d[1]);
    lR1=R[1][0]+    (yy-D[1])*(d[0]/d[1]);
    if (D[0]>0) ff=fmax(lm,lR0),tt=fmin(lp,lR1);
    else ff=fmax(lm,lR1),tt=fmin(lp,lR0);

    x0=ff*sx+sx0; x1=tt*sx+sx0;
    if (x0<0) x0=0; if (x1>maxx) x1=maxx;
    loopto (i,x0,x1) {
      xx=(i-sx0)/sx-R[0][0];
      scal=D[0]*xx+D[1]*yy;
      dd=rr-(xx*xx+yy*yy-Sqr(scal)/DD);
      if (dd>0) {
        ss=scal/DD;
        h=(int)((R[0][2]*(1-ss)+R[1][2]*ss/*+sqrt(dd)*qq*/)*sz)+sz0;
        map=j*maxxn+i;
        if (h>zbuf[map]) {
          col=(int)(cscale*dd);
          zbuf[map]=h;
          scrbuf[map] = c+col/2;
          if (col&1) if ((i+j)&1) scrbuf[map]++; } }
    }
  }
}

void showbar2(fvector r0,fvector r1,int c0,int c1,int bcol) /***** showbar2 */
{
  fvector r;
  int i;

  if (!bcol) return;

  if (c0==c1)
    showbar(r0,r1,c1);
  else {
    loop (i,0,3) r[i]=(r0[i]+r1[i])/2;
    showbar(r0,r,c0);
    showbar(r,r1,c1); }
}

#  include "mousekey.c"

static int repn;
static unsigned char repc;
static enum mode_e { UNDEF, BAR, BAR2, DUMBELL, DUMBELL2, BALL, BOND, BOND2 } curmode=UNDEF;
static double mouserot;

int mykbhit(int mouse) /******************************************** mykbhit */
{
/*.....fprintf(stderr,"%d\n",tst);*/
  if (repn
#  ifdef SYNC
           || follow
#  endif /*# SYNC */
                    ) return 1;
  else return xkbhit(mouse);
}

unsigned char readkey(void) /************************************** readkey */
{
  unsigned char c;

#  ifdef SYNC
  if (follow) return 'x';
#  endif /*# SYNC */

  if (repn) {
    if (xkbhit(1) && 27==extch()) {
      /* esc interrupts, other ignored */
      repn=0; }
    else
      repn--;
    return repc; }

  if ( (c=extch())=='`' ) {
    repn=0;
    while ( (c=extch())>='0' && c<='9' ) {
      sound(100); delay(333); repn=repn*10+(c-'0'); nosound(); }
    repn--; /* 1st passed directly */
    if (c==27) repn=0;
    repc=c; }

  return c;
}

static char *mygetline(void) /************************************ mygetline */
/***
  gets one line `li' form `file',
  skipping comments (lines beginning with !)
***/
{
  char *c;

  li[0]=0;
  do {
    c=fgets(li,256,file);
    if (!c) return c;
  } while (li[0]=='!');

  return c;
}

void setgmode(enum mode_e mode,int mc) /*************************** setgmode */
/* this code is a DOS legacy and needs cleaning ... */
{
  static int gstarted=0;

  if (curmode!=UNDEF)
    if ((mode<=BALL && curmode<=BALL) || (mode>=BOND && curmode>=BOND)) goto ret;

  if (mode!=BALL) {
    static int pass;

    if (!pass) {
      if (ns<=0) ERROR(("ns=%d illegal",ns))
      allocarray(xy,ns);
      allocarray(xy0,ns);
#  ifdef GOLD
      if (option('|')) {
        int n=(abs(option('|'))+1)*slit+8*incube;

        if (n) {
          allocarray(xygold,n);
          allocarray(xygold0,n); }
        else
          option('|')=0; }
#  endif /*# GOLD */
      pass=1; } }

  if (mode<=BALL) {
    static int pass;

    if (!gstarted) {
      startgraph(MODE);
      addkbdstring(kbdstring); }
    initMouse();
    maxx=getmaxx(); maxxn=maxx+1;
    maxy=getmaxy(); maxyn=maxy+1;

    SCRLEN=maxxn*maxyn;
    if (SCRLEN!=oldSCRLEN) {
      if (zbuf) { free(zbuf); free(scrbuf); }
#  if XIMAGE
      if (ximage) XDestroyImage(ximage);
#  endif /*# XIMAGE */
      pass=0; }

    if (!pass) {
      alloc(zbuf,SCRLEN*sizeof(zbuf[0]));
      alloc(scrbuf,SCRLEN);
#  if XIMAGE
#    if XIMAGE==1
   /*
      read existing (just having created) window
      - probably correct code
      - slow over slow network
      - crashes if the window is shifted out of screen
      - fullscreen problems
   */
      ximage=XGetImage(display,win,0,0,maxxn,maxyn,AllPlanes,ZPixmap);
#    else
      {
        /* create ximage from scratch - probably system-dependent
           cf. jkv.c and testx.c
        */
        unsigned *data;
        Visual *visual=NULL;
        allocarrayzero(data,SCRLEN);
        ximage=XCreateImage(display,visual,24,ZPixmap,0,(char*)data,maxxn,maxyn,32,0);
      }
#    endif /*#!0 */
#  endif /*# XIMAGE */
      pass++; }
    setmypalette(); }

  if (mode>=BOND) {
    if (!gstarted)
      startgraph(-9);
    initMouse();
    maxx=getmaxx(); maxxn=maxx+1;
    maxy=getmaxy(); maxyn=maxy+1;
    setcolor(palcolor(WHITE));
    setlinestyle(0,0,1);
    setfillstyle(0,0); }

  if (mc) showMouseCursor();

  mouserot=2*PI/(maxxn+maxy);

  gstarted=1;

 ret: curmode=mode;
}

void project(ivector xyi,fvector r) /****************************** project */
{
  fvector cr;
  float q,sxq,syq;

  cr[0]=r[0]-center[0];
  cr[1]=r[1]-center[1];
  cr[2]=r[2]-center[2];

  if (central) {
    q=eye[2]+sy*(rot[2][0]*cr[0]+rot[2][1]*cr[1]+rot[2][2]*cr[2]);
    if (q<=0) INFRONT
    q=eye[2]/q; sxq=sx*q; syq=sy*q; }
  else {
    sxq=sx; syq=sy; }
  xyi[0]=(int)(sxq*(rot[0][0]*cr[0]+rot[0][1]*cr[1]+rot[0][2]*cr[2]+eye[0]))+sx0;
  xyi[1]=(int)(syq*(rot[1][0]*cr[0]+rot[1][1]*cr[1]+rot[1][2]*cr[2]+eye[1]))+sy0;
}

void rotate(int axis,double angle) /******************************** rotate */
{
  double sa=sin(angle), ca=cos(angle);
  double o[3][3], rot2[3][3];
  int i=(axis+1)%3,j=(i+1)%3,k=(j+1)%3,a,b;

  if (bodyframe) sa=-sa;

  o[i][i]=ca; o[i][j]=-sa; o[i][k]=0;
  o[j][i]=sa; o[j][j]= ca; o[j][k]=0;
  o[k][i]= 0; o[k][j]=  0; o[k][k]=1;

  loop (a,0,3) loop (b,0,3)
    rot2[a][b]=o[a][0]*drot[0][b]+o[a][1]*drot[1][b]+o[a][2]*drot[2][b];

  loop (a,0,3) loop (b,0,3) {
    drot[a][b]=rot2[a][b];
    if (bodyframe) rot[b][a]=drot[a][b];
    else rot[a][b]=rot2[a][b]; }

/*..... loop (a,0,3) loop (b,0,3) rot[a][b]=drot[a][b]=rot2[a][b];*/

#  ifdef SYNC
  if (fifo) {
    if (option('@')==1) {
      loop (a,0,3) loop (b,0,3) fprintf(fifo," %g",drot[a][b]);
      fprintf(fifo,"\n");
      fflush(fifo); }
    else {
      loop (a,0,3) loop (b,0,3) {
        if (1!=fscanf(fifo," %lf",&drot[a][b])) exit(0);
        rot[a][b]=drot[a][b]; } } }
#  endif /*# SYNC */
}

int reverse;

void endian(char *a) /********************************************** endian */
{
  char x;

  x=a[0]; a[0]=a[3]; a[3]=x;
  x=a[1]; a[1]=a[2]; a[2]=x;
}

int readcfg(void) /************************************************* readcfg */
/* returns 1 if new cfg read, position=pos (1st frame=1) */
{
  int i,j,aux;

  if (pos==lastpos) return 0;

  fseek(plb,0,SEEK_END);
  maxpos=(ftell(plb)-option('k')*sizeof(float))/(sizeof(fvector)*(ns+varL));
  if (pos>maxpos) pos=maxpos;
  if (pos<1) pos=1;
  lastpos=pos;

  if (fseek(plb,(long)sizeof(fvector)*(ns+varL)*(pos-1)+option('k')*sizeof(float),SEEK_SET))
    ERROR(("read plb"))
  if (varL) {
    i=fread(L,sizeof(fvector),1,plb);
    if (i!=1)
      ERROR(("read plb (frame=%d, # of frames=%d): cannot read L",pos,maxpos))
    Lh[0]=L[0]/2; Lh[1]=L[1]/2; Lh[2]=L[2]/2; }
  if (L[0]+L[1]+L[2]==0 && defaultslit) slit=incube=0;

  i=fread(cfg,sizeof(fvector),ns,plb);
  if (i!=ns)
    ERROR(("read plb (frame=%d, # of frames=%d): only %d sites read",pos,maxpos,i))
  if (reverse) {
    aux=ns*3;
    loop (i,0,aux) endian((char*)(cfg[0]+i)); /* bad programming style! */ }

#  if 0 /* old: xyz centering */
  if (option('c')>0) {
    fvector center;

    loop (j,0,3) center[j]=0;
    loop (i,0,ns) loop (j,0,3) center[j]+=cfg[i][j];
    loop (j,0,3) center[j]/=ns;
    loop (i,0,ns) loop (j,0,3) cfg[i][j]-=center[j]; }
#  else /*# 0 */
  for (j=2,aux=option('c'); j>=0; j--,aux/=10)
    if (aux%10) {
      float center=0;

      loop (i,0,ns) center+=cfg[i][j];
      center/=ns;
      loop (i,0,ns) cfg[i][j]-=center; }
#  endif /*#!0 */

  if (isshift) {
    fvector Lshift;

    loop (j,0,3)
      if (shiftinL[j]) Lshift[j]=L[j]*shift[j];
      else Lshift[j]=shift[j];

    loop (i,0,ns) loop (j,0,3) cfg[i][j]+=Lshift[j]; }

#  ifdef SHELL
  inshell();
  if (option('j')<=0)
#  endif /*# SHELL */

  if (isL) { /* periodic b.c. */
    loop (i,0,ns) loop (j,0,3) if (L[j]) {
      while (cfg[i][j]>L[j]) cfg[i][j]-=L[j];
      while (cfg[i][j]<0)    cfg[i][j]+=L[j]; }

    loop (i,0,nc) { /* bonds over periodic box removed (=replaced by 0) */
      aux=bond[i][2]&0xf0;
      bond[i][2]=aux|(aux>>4);
      loop (j,0,3) if (L[j]) if (fabs(cfg[bond[i][0]][j]-cfg[bond[i][1]][j])>Lh[j])
        bond[i][2]&=0xf0; } }

  return 1;
}

#  define OPTION_C option('c')
#  include "match.c"

#  include "showmol.c"
#  include "showmove.c"
#  define fullangle 0 /* 0:dihedral potential in (-180,180); 1: (0,360) */
#  include "../blend/dihangle.c"

int main(int narg,char **arg) /**************************************** main */
{
  int i,j,i0,j0;
  static int bondcolor,trace=0,step=0,swing=0,number=1,clickmode=0;
  double an;
  int b,ncmax;
  fvector maxr,minr;
  void *swap;
  float rad=0.01,SXY,cylsph=3;
  int first=1,mrev=0;
  int redraw=1,reread=1,fastmove,bookmark=0;
  struct collist_s *cl;
  enum mode_e newmode;
  char nr[24],*ext;
  int boxpalcolor,boxturbocolor;

#  if CHECKHEAP==-2
  AllocRange=32*2;
  AllocTrace=1;
#  endif /*# CHECKHEAP==-2 */

  initscroll(0);
  doMouse();

  /* colors */
  if (getenv("SHOWPAL")) MODE=atoi(getenv("SHOWPAL"));
  if (MODE>255) MODE=255;
  COLLEN=(MODE-1)/NOCOL;
  if (COLLEN<2) COLLEN=2;
  MODE=NOCOL*COLLEN+1;
  markcolor=COLLEN*(NOCOL-1)+1; /* last color: oraNge */
  boxpalcolor=markcolor;
  boxturbocolor=BROWN;

  /*** option analysis ***/
  loop (i,1,narg)
    if (arg[i][0]=='-') {
#  ifdef GOLD
      if ( (arg[i][1]&31) == ('|'&31) ) {
        /* option -| = -\ */
        char *cr=strchr(arg[i]+2,'r');
        char *cf=strchr(arg[i]+2,'f');

        slit=4; /* wall */
        defaultslit=0;
        incube=arg[i][2]==0 || isalpha(arg[i][2]); /* empty option '|' (now the default; -\\0 off) */
        option('|')=atoi(arg[i]+2)+incube;
        if (cr) gold=0.7*atof(cr+1); /* 70 % of vdW radius given */
        if (cf) gradscale=atof(cf+1); /* frame thickness - relative */
        if (incube || strchr(arg[i]+2,'\\') || strchr(arg[i]+2,'|')) slit=8;
        loop (j,0,NOCOL) if (strchr(arg[i]+2,colortab[j].key)) {
          boxturbocolor=colortab[j].turbocolor;
          boxpalcolor=1+COLLEN*j; } }
      else
#  endif /*# GOLD */

      if (arg[i][1]=='I')
        kbdstring=arg[i]+2;
      else if (arg[i][1]=='K')
        colortab[5].rgb[0]=colortab[5].rgb[1]=colortab[5].rgb[2]=128;
      else if (arg[i][1]=='J')
        shellkey=arg[i]+2;
      else if (arg[i][1]=='D')
        donor=arg[i]+2;
      else if (arg[i][1]=='A')
        acceptor=arg[i]+2;
      else if (arg[i][1]=='H') {
        hbcolor=LIGHTGREEN;
        hbdist=atof(arg[i]+2);
        if (hbdist==0) hbdist=2.44;
        loop (j,0,NOCOL) if (strchr(arg[i]+2,colortab[j].key))
          hbcolor=colortab[j].turbocolor;
        hbcolor*=0x11; }
      else if (arg[i][1]<='Z') {
        loop (j,0,NOCOL+1)
          if (arg[i][1]==colortab[j].key) {
            alloc(cl,sizeof(struct collist_s));
            cl->colno=j;
            cl->pattern=arg[i]+2;
            cl->next=collisthead; collisthead=cl;
            goto OK; }
        ERROR(("%s is unknown color: use one of {W,Y,R,G,B,C,M,N,O}",arg[i])) }
      else if (arg[i][1]=='r' && arg[i][2] && strchr("0123456789",arg[i][2])) {
        /* option -r%g%b% */
        char c[64];

        /*.....prt("%s",arg[i]); delay(2000);*/
        sprintf(c,"%s%s",arg[i]+2,"g59b11");
        col2gray[0]=(float)atoi(c)*0.01f;
        col2gray[1]=(float)atoi(strchr(c,'g'))*0.01f;
        col2gray[2]=(float)atoi(strchr(c,'b'))*0.01f; }
      else if (arg[i][1]=='b' && arg[i][2]=='g') {
        if (arg[i][3]) xwindowhints.background=arg[i]+3;
        else if (++i>=narg) {
          fprintf(stderr,"WARNING: misplaced -bg option\n");
          break; }
        else
          xwindowhints.background=arg[i]; }
      else if (arg[i][1]=='g') {
        if (arg[i][2]) xwindowhints.geometry=arg[i]+2;
        else if (++i>=narg) {
          xwindowhints.geometry="100x100";
          fprintf(stderr,"WARNING: misplaced -g option\n");
          break; }
        else
          xwindowhints.geometry=arg[i]; }
      else if (arg[i][1]=='l') {
        if (arg[i][2]) {
          L[0]=L[1]=L[2]=atof(arg[i]+2);
          Lh[0]=L[0]/2; Lh[1]=L[1]/2; Lh[2]=L[2]/2; }
        isL++; }
      else if (strchr("xyz",arg[i][1])) {
        isshift=arg[i][1]-'x';
        shift[isshift]=atof(arg[i]+2);
        if (strend(arg[i])[-1]=='L') shiftinL[isshift]++;
        isshift++; }
      else if (arg[i][1]=='m') {
        matchfile=strdup(arg[i]+2);
        if ( (mrev=matchfile[0]=='-') ) matchfile++; }
      else
        getoption(arg[i])

#  ifdef CHARGES
      if (arg[i][1]=='n') {
        negA=optA(arg[i]);
        loop (j,0,NOCOL)
          if (negA) if (negA[0]==colortab[j].key) { negC=j; goto OK; } }
      if (arg[i][1]=='p') {
        posA=optA(arg[i]);
        loop (j,0,NOCOL)
          if (posA) if (posA[0]==colortab[j].key) { posC=j; goto OK; } }
#  endif /*# CHARGES */
    OK:; }
    else {
      /* name or file name */
      if (!molname) molname=arg[i];
      else if (!plbfn) plbfn=arg[i];
      else ERROR(("%s: superfluous file argument",arg[i])) }

  an=(PI/8)/option('a');
  wscale100=100+option('w')*(option('w')<0);

#  ifdef SYNC
  if (option('@')>=0) {
    fifo=fopen("/tmp/show.pipe",option('@')?"a":"r");
    if (!fifo) Error("no or bad /tmp/show.pipe| (use mkfifo BEFORE both show)"); }
#  endif /*# SYNC */

#  ifdef SHELL
  distq=Sqr((double)option('j'));
#  endif /*# SHELL */

  hbdistq=Sqr(hbdist);

#  ifdef DEPTH
  cue=option('q')*0.01; icue=1-cue;
#  endif /*# DEPTH */

  if (option('u')==1)  grad=.4f,cylsph=1.f;

  if (!molname) {
    fputs("\
SHOW " VERSION ": MACSIMUS playback file viever. Call by:\n\
  show [OPTIONS] MOLNAME[.mol|.gol|.plb] [ PLBNAME.EXT ]\n\
Input files:\n\
  MOLNAME.mol: mol-file, produced by `pdb', `blend', or `molcfg'\n\
  MOLNAME.gol: optional file w. colors+atom radii by `blend', ignored if -]0\n\
  PLBNAME.EXT: MACSIMUS playback file; if missing, PLBNAME.EXT=MOLNAME.plb\n\
               It may contain an integer format (e.g., nm%04d.plb).\n\
Output files are numbered PLBNAME.0000.EXT, PLBNAME.0001.EXT, ..., where .EXT=\n\
  .ps  : PostScript: see hotkeys W C\n\
  .eps : EPS: see hotkey E\n\
  .nff : Neutral File Format (for ray): N\n\
  .pov : PovRay scene file: V\n\
  .plb : output playback: L\n\
  .zb  : z-buffer (for stereo): B\n\
  .ppm : Portable Pixel Map: P\n\
Environment:\n\
  SHOWNAME = name of the window\n\
  SHOWPAL = number of palette entries (default=249, use less if slow network)\n"
#  ifdef GUI
"  GUIPATH = path to GTK-based GUI, example (bash):\n\
    setenv GUIPATH=/home/jiri/macsimus/gui/\n"
#  endif /*# GUI */
          ,stderr);

    fputs("OPTIONS:\n"
#  ifdef SYNC
          "  -@  sync.rot. (via /tmp/show.pipe|), master: show -@1, client: show -@0 -Ik~\n"
#  endif /*# SYNC */
          "  -~# append MOLNAME.edt, -~2 rewrite MOLNAME.edt: click writes command ra ATOM\n"
          "  -~-1 -~-2 as sbove, click writes command rm ATOM; to be used by `blend -e'\n"
          "  -b1  show backbone only (as derived from PDB)  -b-1 without hetero-molecules\n"
          "  -b2  show backbone only (general backbone algorithm)\n"
          "  -cXYZ center molecule in x,y,z (-c111 = center)\n"
          "  -d#  delay between frames [0] (change by hot keys sS)\n"
          "  -gXGEOMETRY    initial X-geometry (e.g., 320x240+100+100)\n"
          "  -bgXBACKGROUND background color\n"
#  ifdef SHELL
          "  -j#  show water shell thick # A around 1st molecule, cf. hotkeys jJ\n"
          "  -J@  name of water (substring of atom ID): -Jb if via cook/molcfg [df.=HOH]\n"
#  endif /*# SHELL */
#  ifdef GOLD
          "  -|[f#]@    show box (if in the plb-file) [default], also -\\\\; -|0 no box\n"
          "             x,y,z axes are marked by colors RGB (red,green,blue)\n"
          "             @=color [Y or O]; #=box/grid thickness in A, -#=rel. to default\n"
          "  -|#[rRAD]@ show wall by #-grid (negative # = as atoms) and atom size RAD\n"
          "  -|#|@      show slit-pore"
#  endif /*# GOLD */
          "  -[#  keys [ ] move by # frames  -[-# by #% of total length [-[5=5%]\n"
          "  -]0  ignore MOLNAME.gol (guess colors+atom sizes from MOLNAME.mol)\n"
          "  -x#[L] -y#[L] -z#[L] add (x,y,z) to coordinates; suffix L=in box-units\n"
          "  -l   periodic boundary conditions wrapped (example: -l -x0.5L)\n"
          "  -h#  1st file # for PLBFILE containing int format\n"
          "  -k#  header size is # floats (use -k0 for .3db) [2]\n"
          "  -f#  free atoms shown as #-pixel cross x; #<0: also small balls = pixel [-2]\n"
          "  -m[-]MATCH[:FRAME:[FIX]]  match cfg with another config (hot keys \'\"):\n"
          "       MATCH=plb-file to match, use given FRAME [default=1]  (get FIX by blend,\n"
          "       FIX=file of sites (1/line) to match [default=all],     hotkeys @m @k\n",stderr);
    /*** Turbo C warning (stack?): must divide into two fputs's !*/
    fputs("  -o[-]# # of atoms [not]shown as balls, in modes !@#$, cf. hotkeys oO [0]\n"
#  ifdef DEPTH
          "  -q%  cue depth (far=dark, in modes !@#$) [-q50]\n"
#  endif /*# DEPTH */
          "  -r   reverse endian of PLBFILE\n"
          "  -r%g%b%  RGB-->gray conversion for PS output [-r30g59b11]\n"
          "  -s%  initial scale (relative from default), center [-s100]\n"
          "  -s-# absolute initial scale in units of 0.001\n"
          "  -I$$ initial keystroke (example: -IGi$'\\t' = start, ball mode, z=horizontal)\n"
          "  -K   carbons are black, not cyan\n"
          "  -H[dist][@] hydrogen bond (|A-D|<dist) by color @ [-H=-H2.44G]\n"
          "  -Aacceptor -Ddonor (for -H) [-AO -DH]\n"
          "  -t1  raytracer code contains x-z floor  -t-1 for 1 frame, series\n"
          "  -u   thick bars instead of dumbells     -u0  no limit for sphere/bar size\n"
          "  -w%  white bg for dump (PPM,[E]PS,NFF,POV), -w-% and make colors lighter [0]\n"
          "  -@$$ atoms/bonds with $$ in ID colored by @:\n"
          "       W=white, Y=yellow, R=red, G=green, B=blue, C=cyan, M=magenta, O=omit\n"
          "       scanned from right, e.g.: -Rwat -O will show only `wat' in red\n"
          "  -p%@ recolor atom by @ if group charge > %e   (Example: -n-80Y shows all\n"
          "  -n%@ recolor atom by @ if group charge < %e    groups < -0.8e in yellow)\n"
          "  -e#  extend charged group by 1 atom [default=-e1, turn off by -e0]\n",stderr);
    fputs("The program is controlled by hot keys and mouse: type 'h' the get online help!"
          "\n"
          ,stderr);
    exit(0); }

  /* removing extension from molname */
  j=strlen(molname);
  ext=molname+j-4;
  if (j>4 && (!strcmp(ext,".mol")||!strcmp(ext,".gol")||!strcmp(ext,".plb"))) {
    char *a;

    j-=4;
    alloczero(a,j+1);
    copy(a,molname,j);
    molname=a; }

  prt("MOLNAME=%s PLBFN=%s",molname,plbfn);

  if (!plbfn) {
    plbname=molname;
    alloczero(plbfn,j+5);
    sprintf(plbfn,"%s.plb",plbname); }
  else {
    j=strlen(plbfn);
    if (j>4 && !strcmp(plbfn+j-4,".plb")) {
      char *a;

      j-=4;
      alloczero(a,j+1);
      copy(a,plbfn,j);
      plbname=a; }
    else {
      plbname=plbfn;
      prt("PLBNAME.EXT=%s does not have standard extension .plb\n\
(extension will not be removed in derived filenames)"); } }

#  include "showbit.c"

#  ifdef GUI
  gui.exe="gshow";
  gui.name="show";
#  endif /*# GUI */

  option('g')=(int)BOND;
  xwindowhints.winname=getenv("SHOWNAME");
  if (!xwindowhints.winname) {
    if (strcmp(molname,plbname))
      xwindowhints.winname=string("show %s %s",molname,plbname);
    else
      xwindowhints.winname=string("show %s",molname); }
  xwindowhints.iconame=xwindowhints.winname;
  xwindowhints.icowidth=showbit_width;
  xwindowhints.icoheight=showbit_height;
  xwindowhints.icobits=showbit_bits;

  alloc(li,256);
  readMOL(Fn("mol"));
  if (option('b')) {
    if (abs(option('b'))==1) PDBbackbone();
    else backbone(); }

  percent=strchr(plbname,'%')!=NULL;
  if (percent) {
    iplb=option('h');
    newplb(0); }
  else
    plb=fopen(plbfn,"rb");
  prt("playback file %s",plbfn);
  if (!plb) ERROR(("no playback file"))

  del=option('d');
  reverse=option('r');

  loop (j,0,option('k')) {
    if (1!=fread(hdr+j,sizeof(float),1,plb)) ERROR(("playback file too short"))
    if (reverse) endian((char*)(hdr+j));
    if (!j && hdr[j]!=ns) {
      prt("%g sites in playback file, %d sites in mol-file: will be %s",
          hdr[0],ns,ns<hdr[0]?"repeated":"truncated");
      mol2mol((int)hdr[0]); } }
  if (hdr[1]==-3) varL=1;
  else {
    L[0]=L[1]=L[2]=hdr[1];
    prt("cube (old format) L=%g",L[0]); }

  alloc(cfg,(long)ns*sizeof(fvector));

  fseek(plb,0,SEEK_END);
  maxpos=(ftell(plb)-option('k')*sizeof(float))/(sizeof(fvector)*(ns+varL));
  if (maxpos<1) ERROR(("playback file too short"))

  loop (i,0,nc) bond[i][2]=(bond[i][2]&15)*0x111;
  readcfg();

  /* find min/max for scaling */
  loop (j,0,3)
    /* in box if it exists */
    if (L[j]>=0) minr[j]=0,maxr[j]=L[j];
    else maxr[j]=-(minr[j]=9e9);

  /*  09/2003: (PROBLEMS HERE - not for backbone)
      && site[i].r!=7 ensures that sites not shown are not used in centering */
  loop (i,0,ns) if (cfg[i][0]<99999.0
                    /*.....&& site[i].c!=BLACK*/
                    && site[i].r!=7)
    loop (j,0,3) {
      Min(minr[j],cfg[i][j])
      Max(maxr[j],cfg[i][j]) }

  readGOL();
  setgmode(BALL,0); /* needed to set up colors properly - ???, should clean...*/
  setgmode(BOND,0);

#if 0
  if (option('s')>0) {
    SXY=0;
    loop (i,0,3) {
      center[i]=(maxr[i]+minr[i])/2;
      SXY+=sqr(1.3+maxr[i]-minr[i]); }
    typicalsize=sqrt(SXY);
    SXY=option('s')*0.0173/typicalsize;
    typicalsize*=0.4; }
#endif
  if (option('s')>0) {
    typicalsize=0;
    loop (i,0,3) {
      center[i]=(maxr[i]+minr[i])/2;
      typicalsize=fmax(typicalsize,1.3+maxr[i]-minr[i]); }
    SXY=option('s')*0.009/typicalsize;
    typicalsize*=0.4; }
  else {
    SXY=option('s')*-0.001;
    typicalsize=10; }

  zmin=(minr[0]+minr[1]+minr[2]-maxr[0]-maxr[1]-maxr[2])/3; zmax=-zmin+2;
#  ifdef DEPTH
  zmind=zmin; zmaxd=zmax;
#  endif /*# DEPTH */

  bondcolor=YELLOW;
  hbonds();
  Imworking(5);

  for (;;) { /* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */

    if (redraw) {

      sx0=maxx*0.5;
      sy0=maxy*0.5;
      sx= maxy*SXY;
      sy=-maxy*SXY;
      eye[2]=zzeye*maxy;

      if (curmode<=BALL) {
        eye[2]/=fabs(sy);
/*      if (!zbuf) exit(0); ... should never happen */
        sx*=ASPECT;
        sz=ZBUFDEPTH/(0.5f+zmax-zmin);
        if (!trace) memset(zbuf,0,SCRLEN*sizeof(zbuf[0]));

#  ifdef DEPTH
        /* reassigning the cue according to the new z depth - slowly */
        sz0=(zmaxd-zmind)*0.1;
        zmind+=sz0; zmaxd-=sz0;
#  endif /*# DEPTH */
        sz0=-zmin*sz;

        if (!trace) memset(scrbuf,0,SCRLEN); /* needed??? */
        else {
          int i,j;
          int ntrace=SCRLEN*(trace*trace-1)/256;

          loop (i,0,ntrace) {
            j=random()%SCRLEN;
            scrbuf[j]=BLACK;
            zbuf[j]=0; } }

        if (dumpmode==NFF || dumpmode==POV) opendump(); }

  /*    else
          if (!xy) exit(0); ... should never happen */

      ftime(&t0);

#  ifdef GOLD
      if (curmode<=BALL && option('|')) {
        /* GOLD grid in the BALL and BAR modes; see also BOND modes */
        float d,x;
        fvector to,from;
        float g=grad,ggold=gold;
        static fvector a,b;
        int islit;

        to[0]=to[1]=to[2]=typicalsize*1.2;
        from[0]=from[1]=from[2]=-typicalsize*1.2;

        if (ggold<1) ggold=1;

        loop (islit,0,3) if (L[islit]) from[islit]=0,to[islit]=L[islit];

        if (option('|')>0) a[2]=b[2]=(!incube)*(gold-grad);
        else a[2]=0,b[2]=L[2];

        for (islit=0; islit<slit; islit+=4) {
          if (option('|')>0) {
            d=(to[0]-from[0])/option('|')*0.999999;
            grad=fmin(to[0]-from[0],to[1]-from[1]);
            grad=fmin(grad,to[2]-from[2]);
            grad*=0.05/option('|');
            if (incube) grad*=0.3;
            grad*=fabs(gradscale);
            if (gradscale>0) grad=gradscale;
            for (x=from[0]; x<=to[0]; x+=d) {
              a[0]=b[0]=x; a[1]=from[1]; b[1]=to[1];
              if (x>from[0] || islit) showbar(a,b,boxpalcolor);
              else showbar2(a,b,1+COLLEN*3,boxpalcolor,1); }
            d=(to[1]-from[1])/option('|')*0.999999;
            for (x=from[1]; x<=to[1]; x+=d) {
              a[1]=b[1]=x; a[0]=from[0]; b[0]=to[0];
              if (x>from[1] || islit)  showbar(a,b,boxpalcolor);
              else showbar2(a,b,1+COLLEN*2,boxpalcolor,1); }

            if (incube) {
              /* making cube: finish 4 z-axes */
              a[2]=0; b[2]=L[2];
              a[0]=b[0]=from[0]; if (islit) a[0]=b[0]=to[0];
              a[1]=b[1]=from[1];
              if (islit) {
                showbar(a,b,boxpalcolor);
                showsphere(a,grad,boxpalcolor); }
              else {
                showbar2(a,b,1+COLLEN*4,boxpalcolor,1);
                showsphere(a,grad,1); }
              showsphere(b,grad,boxpalcolor);
              a[1]=b[1]=to[1];
              showbar(a,b,boxpalcolor);
              showbar(a,b,boxpalcolor);
              showsphere(a,grad,boxpalcolor);
              showsphere(b,grad,boxpalcolor); } }
          else {
            for (a[0]=from[0]; a[0]<=to[0]; a[0]+=ggold) /* ggold[0] ? */
              for (a[1]=from[1]; a[1]<=to[1]; a[1]+=ggold)
                showsphere(a,gold,boxpalcolor); }
          if (option('|')>0) a[2]=b[2]=L[2]-(!incube)*(gold-grad);
          else a[2]=L[2]; }
        grad=g; }
#  endif /*# GOLD */
      /*** SHOW molecules ***/
      switch (curmode) {
        case DUMBELL: case DUMBELL2:
          loop (i,0,ns) SHELLTEST(i)
            showsphere(cfg[i],grad*cylsph,colormark(i));
        case BAR: case BAR2:
          loop (b,0,nc) {
            i=bond[b][0]; j=bond[b][1];
            if (i==j && option('f') /*>0?*/) {
              SHELLTEST(i)
              showsphere(cfg[i],site[i].r*rad,colormark(i)); }
            else if (curmode==BAR || curmode==DUMBELL) {
              SHELLTEST(i) SHELLTEST(j)
              showbar(cfg[i],cfg[j],site[i].mark&4?markcolor:turbo2pal[bond[b][2]&15]); }
            else { /* BAR2, DUMBELL2 & not single atom */
              SHELLTEST(i) SHELLTEST(j)
              if (site[i].mark&4) showbar(cfg[i],cfg[j],markcolor);
              else {
                if (b>=ncfix) showbar(cfg[i],cfg[j],turbo2pal[bond[b][2]&15]);
                else showbar2(cfg[i],cfg[j],site[i].c,site[j].c,bond[b][2]&15); } } }
          /* show first -o sites as SPHERES anyway */
          if (option('o')) {
            int from=0,to=option('o');
            if (to<0) from=-to,to=ns;
            loop (i,from,to) showsphere(cfg[i],site[i].r*rad,colormark(i)); }
          break;
        case BALL:
          loop (i,0,ns) SHELLTEST(i) showsphere(cfg[i],site[i].r*rad,colormark(i));
          loop (b,ncfix,nc) {
            i=bond[b][0]; j=bond[b][1];
            SHELLTEST(i) SHELLTEST(j)
            showbar(cfg[i],cfg[j],turbo2pal[bond[b][2]&15]); }
          break;
        case BOND: case BOND2:
          loop (i,0,ns) {
#  ifdef SHELL
            if (!(site[i].shell&4))
              xy[i][0]=-9999;
            else
#  endif /*# SHELL */
              project(xy[i],cfg[i]); }

#  ifdef GOLD
          if (option('|')) {
            /* GOLD grid bond mode
               inefficient: code of <=BALL modes almost literally repeated here */
            float d,x;
            fvector from,to;
            static fvector a,b;
            int islit;

            to[0]=to[1]=to[2]=typicalsize*1.2;
            from[0]=from[1]=from[2]=-typicalsize*1.2;

            loop (islit,0,3) if (L[islit]) from[islit]=0,to[islit]=L[islit];

            j=(abs(option('|'))+1)*slit;
            i=0;
            a[2]=b[2]=gold*(!incube);
            for (islit=0; islit<slit; islit+=4) {
              d=(to[0]-from[0])/abs(option('|'))*0.999999;
              for (x=from[0]; x<=to[0]; x+=d) {
                a[0]=b[0]=x; a[1]=from[1]; b[1]=to[1]; project(xygold[i],a); project(xygold[i+1],b);
                i+=2; }
              d=(to[1]-from[1])/abs(option('|'))*0.999999;
              for (x=from[1]; x<=to[1]; x+=d) {
                a[1]=b[1]=x; a[0]=from[0]; b[0]=to[0]; project(xygold[i],a); project(xygold[i+1],b);
                if ((i+=2)>=j) break; /* should not happen, but... */ }
              if (incube) {
                /* only option('|')=1 assumed */
                if (j!=16) Error("internal");
                a[2]=0; b[2]=L[2];
                a[0]=b[0]=from[0]; if (islit) a[0]=b[0]=to[0];
                a[1]=b[1]=from[1]; project(xygold[16+islit],a); project(xygold[17+islit],b);
                a[1]=b[1]=to[1]; project(xygold[18+islit],a); project(xygold[19+islit],b); }
              a[2]=b[2]=L[2]-gold*(!incube); } }
#  endif /*# GOLD */
        default:; }

      Imworking(1);

      if (percent) sprintf(nr,"plb=%d",iplb);
      else sprintf(nr,"%d/%d%c%d",lastpos,maxpos," >< o  ~~"[3*swing+(step>0)+2*(step<0)],abs(step));

      //      fprintf(stderr,"%s\n",nr);

      /* show now ! */
      if (curmode<=BALL) {
        { int x,y;
          setwritemode(0);
#  if XIMAGE
          loopto (y,0,maxy) loop (x,0,maxxn)
            XPutPixel(ximage,x,y,xcoltab[scrbuf[y*maxxn+x]]);
          XPutImage(display,win,gc,ximage,0,0,0,0,maxxn,maxyn);
#  else /*# XIMAGE */
          loopto (y,0,maxy) loop (x,0,maxxn) putpixel(x,y,scrbuf[y*maxxn+x]);
#  endif /*#!XIMAGE */
        }
      }

      if (curmode>=BOND) {

        if (dumpmode==BONDPS) {
          if (!dumpprepared) fprintf(dump,"showpage\n\
90 rotate 54 -550 translate\n\
0 setgray 1 setlinejoin 1 setlinewidth\n");
          opendump();
          fprintf(dump,"%% frame %d\n",pos); }

        setlinestyle(0,0,1);
        setwritemode(!trace);
        if (trace) {
          int i,j=random()%SCRLEN;
          int ntrace=SCRLEN*(trace*trace-1)/256;

          loop (i,0,ntrace) {
            j=random()%SCRLEN;
            putpixel(j/maxyn,j%maxyn,BLACK); } }

        /*** draw bonds - old ones are redrawn (with xor or if trace by BLUE) ***/

        /* draw fixed bonds (note: bond=bond0 for b<ns) */
        loop (b,0,ncfix) {
          i=bond[b][0]; j=bond[b][1];
          if ( (bigpoint=(i==j && option('f'))) ) bigpoint=abs(option('f'));
          if (curmode==BOND) {
            if (!first) myline(xy0,i,j,palcolor(trace?BLUE:bond0[b][2]&15));
            myline(xy,i,j,palcolor(bond[b][2]&15));
            if (dumpmode==BONDPS)
              fprintf(dump,"newpath %d %d moveto %d %d lineto closepath stroke\n",
                      xy[i][0],xy[i][1],xy[j][0],xy[j][1]); }
          else /* BOND2 */ {
            if (!first) {
              if (trace) myline2(xy0,i,j,palcolor(BLUE));
              else { if (bond0[b][2]&15) myline2(xy0,i,j,0); } }
            if (bond[b][2]&15) myline2(xy,i,j,0); } }

        /* draw hydrogen bonds (and other variable bondings) */
        /* drawing and xor-erasing is done at once to avoid flickering */
        ncmax=max(nc,nc0);
        loop (b,ncfix,ncmax) {
          if (b<nc0) {
            i0=bond0[b][0]; j0=bond0[b][1];
            if (!first) myline(xy0,i0,j0,palcolor(trace?BLUE:bond0[b][2]&15)); }
          if (b<nc) {
            i=bond[b][0]; j=bond[b][1];
            myline(xy,i,j,palcolor(bond[b][2]&15));
            if (dumpmode==BONDPS)
              fprintf(dump,"newpath %d %d moveto %d %d lineto closepath stroke\n",
                      xy[i][0],xy[i][1],xy[j][0],xy[j][1]); } }

        setcolor(MODE-1); /* ORANGE */
        loop (i,0,ns) if (site[i].mark&4) {
          if (!first) circle(xy0[i][0],xy0[i][1],2);
          circle(xy[i][0],xy[i][1],2); }

#  ifdef GOLD
        if (option('|')) {
          j=(abs(option('|'))+1)*slit+8*incube;
          bigpoint=0;
          for (i=0; i<j; i+=4) {
            if (!first) {
              b=palcolor(trace?BLUE:boxturbocolor);
              myline(xygold0,i,  i+1,b);
              myline(xygold0,i+2,i+3,b); }
            myline(xygold,i,  i+1,palcolor(boxturbocolor));
            myline(xygold,i+2,i+3,palcolor(boxturbocolor)); }

          swap=xygold0; xygold0=xygold; xygold=swap; }
#  endif /*# GOLD */
        swap=xy0; xy0=xy; xy=swap;
        if (hbdist || isL) {
          if (bondeqbond0) {
            bondeqbond0=0;
            /* hydrogen bonds: make a physical copy */
            allocarray(bond0,nbond);
            copy(bond0,bond,nbond*sizeof(bond[0]));
            nbond0=nbond; }
          if (nbond0!=nbond)
            /* bond has been enlarged */
            nbond0=enlarge(&bond0,nbond0,nbond);
          if (isL) copyarray(bond0,bond,nc);
          else copyarray(bond0+ncfix,bond+ncfix,nc-ncfix);
          nc0=nc; }
        first=0; }

      if (curmode<BOND) if (slicez) {
        char sl[12];

        sprintf(sl,"%.3f",(slicez-sz0)/sz+center[2]);
        setcolor(palcolor(BLACK));
        outtextxy(2,maxy-8,sl);
        setcolor(palcolor(WHITE));
        outtextxy(3,maxy-8,sl);
        setcolor(palcolor(bondcolor)); }

      setcolor(MODE-1); /* ORANGE */
      setwritemode(0);
      setfillstyle(0,0); /* = BLACK in both modes */
      bar(0,maxy-9,72,maxy);
      if (movesel) outtextxy(1,maxy-8,"SELECTION");
      setcolor(palcolor(bondcolor));
      setwritemode(curmode==BALL?0:1);
      XFlush(display);

      if (number) {
        static int last;

        setcolor(MODE-1); /* ORANGE */
        setwritemode(0);
        setfillstyle(0,0); /* = BLACK in both modes */
        j=strlen(nr)*8;
        bar(maxx-last-2,maxy-9,maxx,maxy);
        outtextxy(maxx-j-1,maxy-8,nr);
        last=j;
        setcolor(palcolor(bondcolor));
        setwritemode(curmode==BALL?0:1);
        XFlush(display); }

      if (del) delay(del);

      if (dumpmode==PS || dumpmode==COLORPS || dumpmode==EPS) {
        unsigned u;

        if (!dumpprepared) {
          if (dumpmode==EPS)
            fprintf(dump,"showpage\n"); /* merging problematic - should be banned */
          else
            fprintf(dump,"showpage\n\
90 rotate 54 -550 translate %.2f 480 scale\n",
                    480.0/ASPECT/maxyn*maxxn); }

        opendump();
        if (curmode>BALL) ERROR(("internal"))

        fprintf(dump,"\
%% TEST\n\
%d %d 8 [ 1 0 0 -1 0 %d ]\n\
{ currentfile DS readhexstring pop } %simage",
                maxxn,maxyn,maxyn,
                dumpmode==PS?"":"false 3 color");

        if (dumpmode==PS)
          loop (u,0,SCRLEN)
            fprintf(dump,"%c%02x",u%20?' ':'\n',psgray[scrbuf[u]]);
        else { /* COLORPS */
          int k;
          unsigned u;

          if (option('w')) loop (k,0,3) pal[0][k]=255; /* white background */
          loop (u,0,SCRLEN) {
            fputc(u%10?' ':'\n',dump);
            loop (k,0,3)
              fprintf(dump,"%02x",
                      255-(255-pal[scrbuf[u]][k])*wscale100/100); }
          if (option('w')) loop (k,0,3) pal[0][k]=0; /* back black background */
        }
      } /* PS + COLORPS */

      if (dumpmode==PPM) {
        int k;
        unsigned u;
        char rgb[3];

        opendump();
        fprintf(dump,"P6\n%d %d\n255\n", maxxn,maxyn);

        if (option('w')) loop (k,0,3) pal[0][k]=255; /* white background */
        loop (u,0,SCRLEN) {
          loop (k,0,3)
            rgb[k]=255-(255-pal[scrbuf[u]][k])*wscale100/100;
          fwrite(rgb,1,3,dump); }
        if (option('w')) loop (k,0,3) pal[0][k]=0; /* back black background */
      } /* PPM */

      if (dumpmode==ZBUF) {
        unsigned char *zzz=(unsigned char *)zbuf;
        int i;

        loop (i,0,SCRLEN) zzz[i]=zbuf[i]>>8;
        opendump();
        fwrite(zbuf,SCRLEN,1,dump); }

/*  if (step==0) while (!mykbhit()); */

      if (dumpmode) {
        if (dumpstat==START) dumpstat=CONT;
        if (dumpstat==ONE || dumpstat==SERIES) closedump(0); }

    } /* redraw */

    redraw=0; reread=0;

    showMouseCursor();

    if (option('[')<=0) fastmove=(long)maxpos*abs(option('['))/100;
    else fastmove=option('[');
    if (fastmove<=0) fastmove=1;

    /* every key (once) / cumulate key (repeat) loop */
    do /*EVERY*/

      if (mykbhit(1)) switch (redraw++,key=readkey()) {

        /* mouse: drag left button */
        case LEFTDRAG:
          if (movesel) {
            if (mousedx) rotateselection(1,mousedx*mouserot);
            if (mousedy) rotateselection(0,mousedy*mouserot); }
          else {
            if (mousedx) rotate(1,mousedx*mouserot);
            if (mousedy) rotate(0,mousedy*mouserot); }
          break;

        /* mouse: drag mid button */
        case MIDDRAG:
          if (movesel)
            moveselection((double)mousedx/sx,(double)mousedy/sy);
          else {
            eye[0]+=(double)mousedx/sx;
            eye[1]+=(double)mousedy/sy; }
          break;

        /* mouse: drag right button */
        case RIGHTDRAG:
          if (mousedx) {
            if (movesel)
              rotateselection(2,mousedx*mouserot);
            else {
              SXY*=exp(-(double)mousedy/maxyn);
              rotate(2,mousedx*mouserot); } }
          break;

          //        case 'M':
        case 'u'&31:
          setwritemode(1);
          setcolor(MODE-1);
          loop (i,0,ns) if (site[i].mark&4) {
            site[i].mark-=4;
            circle(xy0[i][0],xy0[i][1],2); }
          setwritemode(0);
          break;

        case RIGHTCLICK:
        case MIDCLICK:
        /* single click (no move) */
        case LEFTCLICK:
          if (curmode>=BOND) {
            int4 ii,jj,rr;
            int OK,rrmax=((unsigned char*)"\22\12\66\377")[clickmode];

            for (rr=0,OK=0; rr<rrmax && !OK; rr++)
              loop (i,0,ns) {
                ii=xy0[i][0]-dosmouse.x;
                jj=xy0[i][1]-dosmouse.y;
                if (ii*ii+jj*jj<=rr) {
                  char line[128];
                  FILE *edt=NULL;
                  int j,jj;
                  static int lastlen=0,llasti=0,lllasti=0,newedt=1;
                  float lrr,rr,cf;

                  if (option('~')) edt=fopen(Fn("edt"),option('~')==1 || !newedt?"at":"wt");
                  if (edt && newedt) fprintf(edt,"! %s\n",Fn("edt"));
                  newedt=0;

#  ifdef CHARGE
                  sprintf(line,"%d: %s %s %f",i,site[i].id,site[i].type,site[i].charge);
#  else /*# CHARGE */
                  sprintf(line,"%d: %s %s",i,site[i].id,site[i].type);
#  endif /*#!CHARGE */
                  setfillstyle(0,BLACK);
                  setwritemode(0);

                  /* bond length */
                  lrr=rr=cf=0;
                  loop (j,0,3) {
                    float x=cfg[i][j]-cfg[lasti][j];
                    float y=cfg[llasti][j]-cfg[lasti][j];
                    cf+=y*x;
                    rr+=x*x;
                    lrr+=y*y; }
                  sprintf(strend(line)," %d-%d=%.4f",i,lasti,sqrt(rr));

                  /* bond angle */
                  lrr*=rr;
                  if (lrr)
                    sprintf(strend(line)," %d-%d-%d=%.4f",
                            i,lasti,llasti,(180/PI)*acos(cf/sqrt(lrr)));

                  /* dihedral angle */
                  if (lllasti!=llasti)
                    sprintf(strend(line)," %d-%d-%d-%d=%.4f",
                            i,lasti,llasti,lllasti,
                            dihedral(cfg[i],cfg[lasti],cfg[llasti],cfg[lllasti]));

                  j=strlen(line);
                  if (j<lastlen) jj=lastlen; else jj=j;
                  lastlen=j;
                  jj*=8;
                  bar(0,0,max(jj,30),17);
                  if (clickmode==0) {
                    prt("%s",line);
                    prt("[%8.5f %8.5f %8.5f ]",cfg[i][0],cfg[i][1],cfg[i][2]); }
                  setcolor(MODE-1);
                  if (clickmode==0) outtextxy(0,0,line);
                  if (edt) {
                    char *tok=strtok(line," \t");
                    tok=strtok(NULL," \t");
                    fprintf(edt,option('~')>0?"ra %s\n":"rm %s\n",tok);
                    fclose(edt); }
                  sprintf(line,"%8.5f %8.5f %8.5f",cfg[i][0],cfg[i][1],cfg[i][2]);
                  if (clickmode==0) outtextxy(0,9,line);
                  lllasti=llasti; llasti=lasti; lasti=i;
                  OK+=!clickmode;

                  setwritemode(!trace);
                  setcolor(MODE-1);
                  if (key==MIDCLICK)
                    floodmark(i);
                  else if (key==LEFTCLICK) {
                     if (!(site[i].mark&4)) {
                       site[i].mark|=4;
                       circle(xy0[i][0],xy0[i][1],2); } }
                  else {
                     if ((site[i].mark&4)) {
                       site[i].mark-=4;
                       circle(xy0[i][0],xy0[i][1],2); } }
                  setwritemode(0);

                  if (OK) break; } } }
          break;

        case 'w':
          swing=(swing+1)%3;
          if (!swing) step=0;
          if (swing==2 && step<0) step=abs(step);
          break;

        case 'o':
          option('o')-=option('o')>-ns; break;

        case 'O':
          option('o')+=option('o')<=ns-1; break;

        case 'F'&31:
          bodyframe=!bodyframe;
          {
            int a,b;

            loop (a,0,3) loop (b,0,3) rot[a][b]=drot[a][b]=a==b;
          }
          break;

        case 'I': {
          int i;

          setwritemode(!trace);
          setcolor(MODE-1);
          loop (i,0,ns) {
            site[i].mark^=4;
            if (curmode>=BOND) circle(xy0[i][0],xy0[i][1],2); }
          setwritemode(0);
          break; }

        case 'I'&31: {
          int a,b;

          if (drot[0][0]+drot[1][1]+drot[2][2]==3)
            loop (a,0,3) loop (b,0,3) rot[a][b]=drot[a][b]=a==(b+1)%3;
          else if (drot[1][0]+drot[2][1]+drot[0][2]==3)
            loop (a,0,3) loop (b,0,3) rot[a][b]=drot[a][b]=a==(b+2)%3;
          else
            loop (a,0,3) loop (b,0,3) rot[a][b]=drot[a][b]=a==b;
          }
          break;

        reinit:
        case 'i':
          fseek(plb,sizeof(float)*option('k'),0);
          pos=0; step=1;
        break;

#  ifdef SHELL
        case 'J':
          distq*=1.44;
        case 'j':
          distq/=1.2; if (distq==0) distq=9;
          lastpos=-1; /* forces reread even if pos not changed */
          reread=1;
          break;
#  endif /*# SHELL */
        case 'K':
          clickmode=(clickmode+1)%4;
          if (clickmode) fprintf(stderr,"clickmode=%d: all atoms within %s radius marked\n",
                                clickmode,"small\0\0medium\0large"+clickmode*7-7);
          else fprintf(stderr,"clickmode=0: one best matching atom marked on click\n");

          break;
        case 'k':
          kbdmode=!kbdmode;
          fprintf(stderr,"%s key mode\n",kbdmode?"every":"cumulate");
          //          if (kbdmode) sound(2000); delay(50); nosound();
          redraw=0;
          break;

        case 'e':
          closedump(1);
          break;

        case 'W':
          dumpmode=PS;
          if (curmode==BOND) dumpmode=BONDPS;
          else goto testball;
          goto startdump;

        case 'C':
          dumpmode=COLORPS;
          goto testball;
        case 'E':
          dumpmode=EPS;
          goto testball;
        case 'L':
          dumpmode=PLB;
          goto testball;
        case 'A':
          dumpmode=ATM;
          goto testball;
        case 'P':
          dumpmode=PPM;
          goto testball;
        case 'B':
          dumpmode=ZBUF;
          goto testball;
        case 'V':
          dumpmode=POV;
          goto testball;
        case 'N':
          dumpmode=NFF;
        testball:
          if (curmode>=BOND) {
            dumpmode=NONE;
            goto badkey; }
        startdump:
          if (dump) {
            ERROR(("dump opened - closing"))
            closedump(1);
            goto badkey; }
          fprintf(stderr,
                  "dumping %s: select in graphic window (o)ne file, (s)eries%s\n",
                  dumpext[dumpmode],dumpmode==PPM || dumpmode==ZBUF?"":", (m)erged file");
          switch (readkey()) {
            case '1': case 'o': case 'O': dumpstat=ONE; break;
            case '9': case 's': case 'S': dumpstat=SERIES; break;
            case '0': case 'm': case 'M':
              dumpstat=START;
              if (dumpmode!=PPM && dumpmode!=ZBUF) break;
            default: dumpmode=NONE; goto badkey; }

          preparedump(dumpmode==PLB && movesel);
          redraw=1; /* unnecessarily in most cases, but fool proof */
          break;

        case 'r':
          if (curmode==BALL) {
            rad/=1.0821439f;
            Max(rad,0.001f) }
          if (curmode>=BAR && curmode<=DUMBELL2) {
            grad/=1.0821439f;
            Max(grad,0.01f) }
          break;
        case 'R':
          if (curmode==BALL) {
            rad*=1.05f;
            if (option('u')) Min(rad,0.03f) }
          if (curmode>=BAR && curmode<=DUMBELL2) {
            grad*=1.05f;
            if (option('u')) Min(grad,2.f) }
          break;

        case 'd':
          rad=0.01f,grad=.1f,cylsph=3.f; break;
        case 'D':
          rad=0.01f,grad=.4f,cylsph=1.f; break;
        case 'U':
          cylsph*=1.05; break;
        case 'u':
          cylsph/=1.0821439f; if (option('u')) Max(cylsph,1.f); break;

#  ifdef SLICES
        case '(':
          slicez-=ZBUFDEPTH/233; break;
        case ')':
          slicez+=ZBUFDEPTH/144; break;
        case '<':
          slicez-=ZBUFDEPTH/16; break;
        case '>':
          slicez+=ZBUFDEPTH/16; break;
        case '_':
          if (slicez) slicez=0;
          else slicez=ZBUFDEPTH/2;
          break;
        case 'l':
          if (slicecolor) slicecolor=0;
          else slicecolor=1;
          break;
#  endif /*# SLICES */

        case 3: exit(0); /* ctrl-c */

        case 'Q':
          goto TheEnd;
        case 'q':
//        case MIDCLICK: /* mid mouse */
        case 27: /* ESC */
          sound(1000); delay(50); nosound();
          while (mykbhit(1)) readkey();
          if (strchr("\205\33qQ",readkey())) goto TheEnd;
          break;

        case 'n':
          number=!number;
        case ' ':
          first=1;
          if (curmode>=BOND) clearviewport();
          break;

        case 'f':
          step=!step; redraw=step; break;
        case 'F':
          step*=2; break;

        case X_REDRAW_ME:
          newmode=curmode; curmode=UNDEF;
          goto setnewmode;
        case '!': newmode=BAR; goto setnewmode;
        case '@': newmode=BAR2; goto setnewmode;
        case '#': newmode=DUMBELL; goto setnewmode;
        case '$': newmode=DUMBELL2; goto setnewmode;
        case '%': newmode=BALL; goto setnewmode;
        case '^': newmode=BOND; goto setnewmode;
        case '&': newmode=BOND2; goto setnewmode;
        case 'g':
          newmode=(enum mode_e)(1+((int)curmode%(int)BOND2));
          goto setnewmode;
        case 'G':
          newmode=(enum mode_e)(1+(((int)(BOND2)-2+(int)curmode)%(int)BOND2));
        setnewmode:
          setgmode(newmode,1);
          first=1;
          if (curmode>=BOND) clearviewport();
          break;

        case 's'&31:
          dumponeplb(0);
          break;

        case 'r'&31:
          dumponeplb(1);
          break;

        case 's':
          if (abs(step==1)) {
            del+=del/2+8;
            if (del>2000) del=2000; /* max. 2 s delay */ }
          else step=(step+sign(step))/2;
          goto showdel;
        case 'S':
          if (del) del -= (del+2)/3;
          else step=(step*3+sign(step))/2;
        showdel:
          fprintf(stderr,"delay = %d ms, step=%d\n",del,step);
          break;

        case 't': trace=!trace; break;
        case 'T': trace+=2; break;

        case WHEELFORWARD:
        case '+': SXY*=1.05f; break;
        case WHEELBACKWARD:
        case '-': SXY/=1.0821439f; break;
        case '*': an*=2; if (an>2) an=(2*PI)/option('a'); redraw=0; break;
        case '/': an/=(1+(an>1e-4)); redraw=0; break;
        case 'x':
        case 'y':
        case 'z':
          if (movesel) rotateselection(key-'x',an);
          else rotate(key-'x',an);
          break;
        case 'X':
        case 'Y':
        case 'Z':
          if (movesel) rotateselection(key-'X',-an);
          else rotate(key-'X',-an);
          break;

        case '\'':
          match(mrev,cfg,ns,1e-4); break;
        case '\"':
          match(mrev,cfg,ns,1e-6); break;

        case 'm': movesel=!movesel; break;

  //      case WHEELFORWARD:
        case 200: /*H ^   0xc8 */
          if (movesel) moveselection(0,-8/sy);
          else eye[1]-=8/sy;
          break;
  //      case WHEELBACKWARD:
        case 208: /*P v   0xd0 */
          if (movesel) moveselection(0,7/sy);
          else eye[1]+=7/sy;
          break;
        case 205: /*M ->  0xcd */
          if (movesel) moveselection(8/sx,0);
          else eye[0]+=8/sx;
          break;
        case 203: /*K <-  0xcb */
          if (movesel) moveselection(-7/sx,0);
          else eye[0]-=7/sx;
          break;

        case 1: /* ctrl-A */
        case 199: /*G Home  */
          if (central) zzeye*=0.9;
          break;
        case 5: /* ctrl-E */
        case 207: /*O End   */
          if (central) zzeye*=1.186;
          break;

        case ',':
          pos=0; reread=1; /* reread=1 sets step=0 ! */
          break;
        case '.':
          fseek(plb,0,2);
          maxpos=(ftell(plb)-option('k')*sizeof(float))/(sizeof(fvector)*(ns+varL));
          pos=maxpos; reread=1;
          break;
        case 128+'4': { /* F4 */
          char line[64];
          printf("frame to show=");
          gets(line);
          pos=atoi(line); reread=1; step=0; }
          break;
        case '{': pos-=fastmove; reread=1; break;
        case '}': pos+=fastmove; reread=1; break;
        case 201: /* PgUp */
        case '[':
          if (percent) { newplb(-1); goto reinit; }
          pos--; reread=1;
          break;
        case 209: /* PgDn */
        case ']':
          if (percent) { newplb(1);  goto reinit; }
          pos++; reread=1;
          break;

        case 'b': step=-step; break;

        case ':': bookmark=pos; break;
        case ';': { int i=pos; pos=bookmark; bookmark=i; } reread=1; break;

        case 'c': eye[0]=eye[1]=0; zzeye=4; break;

        case '|':
        case '\\': option('|')=-option('|'); break;

        case '=':
          central=!central;
          fprintf(stderr,"%s projection\n",central?"central":"parallel");
          break;
#  ifdef SYNC
        case '~':
          /* start follow mode - for show -@0 only */
          if (option('@')==0) follow=kbdmode=!follow;
          break;
#  endif /*# SYNC */

        case 'h':
        case '?':
        case 'H': {
          enum mode_e m=curmode;
          setgmode(BOND,0);
          setwritemode(0);
          first=1;
          clearviewport();
          dathelp=(getmaxy()-26)/37;
          athelp=4;
  H("mouse drag", "Left=rotate   Middle=move  Right=z-rot/rescale  Wheel=rescale");
  H("mouse click","Left=info (if -~ write atom to .edt)  Mid=quit(2x)  Right=redraw");
  athelp+=8;
  H("SPACE TAB ^F",  "redraw  Init view/slab/rot  toggle body/coord Frame");
  H("g G  @ # $ % ^ &",  "      change graphic mode  set graphics mode");
  H("x X y Y z Z  / *",  "      rotate around axes  change rotation angle");
  H("CURSORS c","move in x and y directions  reCenter");
  H("=",      "central/parallel projection toggle");
  H("Home End","move eye from/to screen (centr.proj.)");
  H("+ -",    "rescale");
  H("s S",    "Slower/faster playback");
  H("r R  u U"  ,  "*Resize ball or bar  change ball/bar ratio");
  H("d D",    "*default ball/bar size (dumbell)  thick bars (no Dumbell)");
  H("o O",    "*increase/decrease # of atoms always shown as balls (cf. -o)");
  H("i",      "restart playback");
  H("0..9 F",   "timestep (0=pause)  2*faster");
  H("f t T n",  "Freeze/go  Trace  fade away Trace  show/hide frame Number");
  H("b w",    "Backward/forward  auto sWing mode");
  H(", . { }",    "goto to beg/end of file  go by 5% of file (or as set by -[)");
  H("[ ] PgUp PgDn","      go by 1 frame or file (if format in PLBNAME)");
  H(": ;","bookmark position / exchg bookmark<->pos");
  athelp+=5;
  H("A",      "*dump ATM file (simple: atom derived from TYPE)");
  H("N V",    "*dump NFF file  dump POV file");
  H("B",      "*dump z-Bufer");
  H("E C W",  "*dump EPS/Color PS/gray PS (*, for PS also bond mode ^)");
  H("L",      "*dump new pLayback (ball mode only), cf. ^s");
  H("P",      "*dump PPM file*");
  H("o s m",  "after keys BNOCLPA: (o)ne frame, (s)eries, (m)erged series");
  H("e",      "end series of dumped frames");
  athelp+=5;
  H("\' \"",  "match (\"=more accurate) with -mPLBFILE:FRAME");
  H("m M ^u", "toggle move+rot marked atoms / unset (M=^U)");
  H("^S ^R",   "save frame (if marked w. mol,gol) / save rotated");
#  ifdef SHELL
  H("J j",    "HOH shell width +/- (from next frame)");
#  endif /*# SHELL */
#  ifdef GOLD
  H("| \\",   "toggle wall style (see -\\)");
#  endif /*# GOLD */
#  ifdef SLICES
  H("_ l",    "*cut by z-plane in half/off  toggle coLor of cutting plane");
  H("< >  ( )","*move cutting plane in z-dir  ()=fine move");
#  endif /*# SLICES */
  H("k K",      "toggle Key mode: every key/cumulate moves if slow / click best/all");
  H("`",      "repeat command prefix ( `12] = go by 12 frames forward)");
  athelp+=5;
  H("ESC q Q","Quit or break, q ESC need once more");
  athelp+=5;
  H("press any key","      *=applies to bar and ball modes only");

          if (strchr("\33qQ",getch())) {
            char xxx[16];
            while (mykbhit(1)) readkey();
            prt("quit ? (y/n)");
            scanf("%s",xxx);
            if (toupper(xxx[0])=='Y') goto TheEnd; }
          setgmode(m,1);
          break; }

        default:;
          if (key>='0' && key<='9') {
            step = step<0 ? '0'-key : key-'0'; break; }

        badkey:
          sound(800); delay(100); nosound(); }

      while (!kbdmode && mykbhit(0) && (xchar<0200 || xchar>0202)); /*EVERY*/

    hideMouseCursor();

    if (step || reread) {
      if (reread) step=0;
      if (step) if (swing) {
        if (swing==2)
          if ( (pos<=1 && step<0) || (pos>=maxpos && step>0)) step=-step;
        if (swing==1) {
          if (step<0) step=abs(step);
          if (pos>=maxpos) pos=0; } }
      pos+=step;
      Max(pos,1)
      if (pos>=maxpos) {
        fseek(plb,0,2);
        maxpos=(ftell(plb)-option('k')*sizeof(float))/(sizeof(fvector)*(ns+varL)); }
      Min(pos,maxpos)
      redraw |= readcfg();
      hbonds(); }

    } /* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */

 TheEnd:;
  fclose(plb);
  closedump(1);
/*.....if (curmode!=BALL) ?DOS*/
  closegraph();

  prt("%d fixed bonds, %d hydrogen bonds",ncfix,nc-ncfix);
  prt("maxr: %10.6f %10.6f %10.6f",maxr[0],maxr[1],maxr[2]);
  prt("minr: %10.6f %10.6f %10.6f",minr[0],minr[1],minr[2]);
  prt("size: %10.6f %10.6f %10.6f",
      maxr[0]-minr[0],
      maxr[1]-minr[1],
      maxr[2]-minr[2]);

  return 0;
}
