#include "ground.h"
#include "vector.h" /* simglob.h not needed */
#include "sitesite.h"
#ifdef COOK
#  include "units.h"
#  define PROMPT
#else
#  define PROMPT "! "
#endif

void combruleinfo(int comb_rule) /**************************** combruleinfo */
{
  if (comb_rule==0) prt(PROMPT "The Busing combining rule");
  else ERROR(("comb_rule=1 expected"))
}

void initcombrule(siteparm_t *sp,int comb_rule) /************** initcombrule */
/* unit conversion: note that parm[0] is C */
{
  /* sp->alpha unused */
#ifdef COOK
  sp->EvdW*=(kcal/Eunit);
  /* sp->R unchanged */
  sp->parm[0]*=sqrt(kcal/Eunit);
  sp->parm[1]*=sqrt(kcal/Eunit);
#endif
  sp->comb_rule=comb_rule;
}

void combrule(pairparm_t *pp,siteparm_t *lj0,siteparm_t *lj1,char *info)
{
  /* C_ij=C_i C_j */
  pp->parm[0]=lj0->parm[0]*lj1->parm[0];
#ifdef REP12
  pp->parm[1]=lj0->parm[1]*lj1->parm[1];
#endif
  pp->sig = lj0->RvdW+lj1->RvdW;
  if (lj0->EvdW<0 || lj1->EvdW<0) pp->eps=0;
  else pp->eps = lj0->EvdW+lj1->EvdW;
#ifdef REP12
  if (info) prt("%s: eps=%g sig=%g C=%g D=%g",info,pp->eps,pp->sig,pp->parm[0],pp->parm[1]);
#else
  if (info) prt("%s: eps=%g sig=%g C=%g",info,pp->eps,pp->sig,pp->parm[0]);
#endif
}

/*   real eps,RR,rhorho,f_rhorho,C,C6,D,D12; */
void initssaux(pairaux_t *a,pairparm_t *pp)
{
  a->eps=pp->eps; 
  a->RR=pp->sig;
  a->rhorho=a->eps/BUSING_f;
  a->f_rhorho=BUSING_f/a->rhorho;
  a->C=pp->parm[0]; 
  a->C6=pp->parm[0]*6; 
  a->D=pp->parm[1]; 
  a->D12=pp->parm[1]*12;
}
