/*
"gold" (ideal metal surface), charge reflection
changes made, but not checked for a long time!

#define GOLD required

WARNING: must use such version of NearestImage[0] which leaves xxyy =
(r[i][0]-r[j][0])^2 + (r[i][1]-r[j][2])^2 [with proper b.c.] as
by-product.

this module depends on the following #defines:
   WORM, CUT, TWODIM, POLAR, PARALLEL, STARS

NOTE: initcombrule() and combrule() are in sitesite.c

Do not change the header of setss !!!  */

#include "ground.h"
#define SDS
#include "alloc.h"
#include "simglob.h"

#include "interpot.h"

#ifdef COULOMB
#include "elst.h"
#else
#define ermacrodcl /* empty */
#undef ermacro
#endif

#include "intermac.h"
#include "simdef.h"
#include "units.h"

#ifdef COOK
/* to move ??? -- and also LJQQ14* ? */
sitesite_t **sstab,**sstab14;
real factor14=0.5,factor14_1=-0.5;
#endif /*# COOK */

/* shared memory PARALLEL support */
#if PARALLEL==3
#define GLOB ,pll_global_t *glob
#define ENVIR glob->Envir
#define ENEL glob->Enel
#else  /*# PARALLEL==3 */
#define GLOB
#define ENVIR En.vir
#define ENEL En.el
#endif /*# PARALLEL==3 */

#ifdef MARK
#include "mark.h"
#else /*# MARK */
#define MARK_PATCH /*empty*/
#endif /*# MARK */

#ifdef STARS
#error no STARS
no STARS
#endif /*# STARS */

#ifdef POLAR
#error no POLAR
no POLAR
#endif

#ifndef GOLD
#error GOLD expected
GOLD expected
#endif

/*
WARNING: SS_NOMEASURE_rep, SS_MEASURE_rep not supported!

elementary site-site interactions: Lennard-Jones + r-space Ewald
NOTES:
  LJ cutoff must not be greater than the r-space Ewald cutoff
  virial is defined as  r*force = -r*u'(r)
  only non-electrostatic part of energy is returned by the functions, the
    r-space part of the electrostatic energy is summed to En.el
  virial of electrostatic forces is equal to the electrostatic energy and
     will be added to the total virial with the k-space part included
  only LJM and LJQQM needed with the link-cell method
*/

#ifdef SS_MEASURE_rep
#error SS_MEASURE_rep not supported in nonpolar version
"SS_MEASURE_rep" not supported in nonpolar version
#endif

double LJM(sitesite_t *ss,vector r1,vector r2,vector f1,vector f2 GLOB)
/* LJ site-site interaction, measurements incl.                     **** LJM */
{
  double U=0,rr,f,x,y,z,xxyy;
  real fdr;
  rdf_t *ssrdf;
  vector dr;

  NearestImage(0,box.cq) {
    if ( (ssrdf=ss->rdf) ) {
      int i=(int)(sqrt(rr)*ssrdf->grid);
      if (i<ssrdf->nhist) (ssrdf->hist[i])++; }
#ifdef NIBC
    SS_MEASURE
    ENVIR+=rr*f;
    ADDFORCES(f1,f2,f*dr)
#else /*# NIBC */
    if (rr < ss->C2q) {
      if (rr < ss->C1q)
        SS_MEASURE
      else {
        x=rr-ss->C2q; U=x*x*ss->A; f=ss->A4*x; }
      ENVIR+=rr*f;
      ADDFORCES(f1,f2,f*dr) }
#endif /*# NIBC */
    }

  MARK_PATCH
  return U;
} /* LJM */

void   QQM(sitesite_t *ss,vector r1,vector r2,vector f1,vector f2,double qq GLOB)
/* real-space charge-charge interactions, measurements incl.         **** QQM */
{
  double rr,f,xxyy;
  real fdr;
  rdf_t *ssrdf;
  ermacrodcl
  vector dr;

  NearestImage(,box.cq) {
    if ( (ssrdf=ss->rdf) ) {
      int i=(int)(sqrt(rr)*ssrdf->grid);
      if (i<ssrdf->nhist) (ssrdf->hist[i])++; }

#ifdef COULOMB
    ENEL+=erud(rr)*qq; f=byerd*qq;
#else /*# COULOMB */
    ENEL+=f=qq/sqrt(rr); f/=rr;
#endif /*# COULOMB */
    ADDFORCES(f1,f2,f*dr)

    Reflect {
#ifdef COULOMB
      ENEL+=erud(rr)*qq; f=byerd*qq;
#else /*# COULOMB */
      ENEL+=f=qq/sqrt(rr); f/=rr;
#endif /*# COULOMB */
      ADDFORCES(f1,f2,f*dr) } }

  MARK_PATCH
} /* QQM */

void rdfM(sitesite_t *ss,vector r1,vector r2) /********************** rdfM */
/* measuring rdf of sites not having q-q nor LJ (e.g. some water models) */
{
  double rr,xxyy;
  rdf_t *ssrdf;
  vector dr;

  NearestImage(,box.cq) {
    if ( (ssrdf=ss->rdf) ) {
      int i=(int)(sqrt(rr)*ssrdf->grid);

      if (i<ssrdf->nhist) (ssrdf->hist[i])++; } }
} /* rdfM */

double LJQQM(sitesite_t *ss,vector r1,vector r2,vector f1,vector f2,double qq GLOB)
/* LJ + real-space charge-charge interactions, measurements incl. **** LJQQM */
{
  double U=0,rr,f,x,y,z,xxyy;
  real fdr;
  rdf_t *ssrdf;
  ermacrodcl
  vector dr;

  NearestImage(0,box.cq) {
    f=0;
    if ( (ssrdf=ss->rdf) ) {
      int i=(int)(sqrt(rr)*ssrdf->grid);
      if (i<ssrdf->nhist) (ssrdf->hist[i])++; }
#ifdef NIBC
    SS_MEASURE
    ENVIR+=rr*f;
#else /*# NIBC */
    if (rr < ss->C2q) {
      if (rr < ss->C1q)
        SS_MEASURE
      else {
        x=rr-ss->C2q; U=x*x*ss->A; f=ss->A4*x; }
      ENVIR+=rr*f; }
#endif /*# NIBC */

#ifdef COULOMB
    ENEL+=erud(rr)*qq; f+=byerd*qq;
#else /*# COULOMB */
    ENEL+=x=qq/sqrt(rr); f+=x/rr;
#endif /*# COULOMB */
    ADDFORCES(f1,f2,f*dr)

    Reflect {

#ifdef COULOMB
      ENEL+=erud(rr)*qq; f=byerd*qq;
#else /*# COULOMB */
      ENEL+=f=qq/sqrt(rr); f/=rr;
#endif /*# COULOMB */
      ADDFORCES2(f1,f2,f*dr) } }

  MARK_PATCH
  return U;
} /* LJQQM */

#ifndef LINKCELL

#ifdef COOK
/* to move ??? */

double LJQQ14M(sitesite_t *ss,vector r1,vector r2,vector f1,vector f2,double qq GLOB)
                                                                   /* LJQQ14M */
/* as above with factor14 - requires special treatment */
{
  double U=0,rr,f,x,y,z,sr,xxyy;
  real fdr;
  rdf_t *ssrdf;
  ermacrodcl
  vector dr;

  NearestImage(0,box.cq) {
    f=0;
    sr=sqrt(rr);
    if ( (ssrdf=ss->rdf) ) {
      int i=(int)(sr*ssrdf->grid);
      if (i<ssrdf->nhist) (ssrdf->hist[i])++; }
#ifdef NIBC
    SS_MEASURE
    ENVIR+=rr*f;
#else /*# NIBC */
    if (rr < ss->C2q) {
      if (rr < ss->C1q)
        SS_MEASURE
      else {
        x=rr-ss->C2q; U=x*x*ss->A; f=ss->A4*x; }
      ENVIR+=rr*f; }
#endif /*# NIBC */

#ifdef COULOMB
    ENEL+=(erud(rr)+(y=factor14_1/sr))*qq; f+=(byerd+y/rr)*qq;
#else /*# COULOMB */
    ENEL+=x=factor14*qq/sr; f+=x/rr;
#endif /*# COULOMB */
/* prt("r=%9.5f C2=%9.5f qq=%10.3f f=%10.5f",sr,sqrt(ss->C2q),qq,f); */
    ADDFORCES(f1,f2,f*dr)

    Reflect {

#ifdef COULOMB
      ENEL+=erud(rr)*qq; f=byerd*qq;
#else /*# COULOMB */
      ENEL+=f=qq/sqrt(rr); f/=rr;
#endif /*# COULOMB */
      ADDFORCES2(f1,f2,f*dr) } }

  MARK_PATCH
  return U;
} /* LJQQ14M */

void LJQQ14(sitesite_t *ss,vector r1,vector r2,vector f1,vector f2,double qq)
                                                                   /* LJQQM */
/* as above with factor14 - requires special treatment */
{
  double rr,f,x,y,xxyy;
  real fdr;
#ifdef ermacro
  ertab_p er_p; /* byerd not needed */
#endif /*# ermacro */
  vector dr;

  NearestImage(,box.cq) {

#ifdef COULOMB
    f=(erd(rr)+factor14_1/(rr*sqrt(rr)))*qq;
#else /*# COULOMB */
    f=factor14*qq/(rr*sqrt(rr));
#endif /*# COULOMB */

#ifdef NIBC
    SS_NOMEASURE(+=)
#else /*# NIBC */
    if (rr < ss->C2q) {
      if (rr < ss->C1q)
        SS_NOMEASURE(+=)
      else {
        x=rr-ss->C2q; f+=ss->A4*x; } }
#endif /*# NIBC */
    ADDFORCES(f1,f2,f*dr)

    Reflect {
#ifdef COULOMB
      f=erd(rr)*qq;
#else /*# COULOMB */
      f=qq/(rr*sqrt(rr));
#endif /*# COULOMB */
      ADDFORCES2(f1,f2,f*dr) } }
} /* LJQQ14 */

#ifdef COULOMB

#if COULOMB<=-1
#error EWALD not supported with GOLD
EWALD not supported with GOLD
#endif

void goldQQ(vector f,double z, double qq) /*************************** goldQQ */
/* note the call and signs: z=distance of charges, qq=q^2 */
{
  ermacrodcl

  double zz=z*z;

  if (zz<cq)
    if (measure) {
      ENEL-=erud(zz)*qq/2; f[2]-=byerd*qq*z; }
    else
      f[2]-=erd(zz)*qq*z;
}

double XQQM(vector r1,vector r2,vector f1,vector f2,double qq GLOB)  /* XQQM */
/* corrections to 1-2 and 1-3 interactions because of Ewald */
{
  double U=0,rr,f,x,y,xxyy;
  real fdr;
  /*rdf_t *ssrdf;*/
  ermacrodcl
  vector dr;

/*..... double EEE=ENEL;*/

  NearestImage(0,box.cq) {

#if COULOMB>=0 /* now no Ewald so that never active... */
    x=sqrt(rr);
/* ?! do not calculate rdf */
    ENEL+=(erud(rr)-(y=1/x))*qq; f=(byerd-y/rr)*qq;
/*.....prt(">>>> %g %g",erud(rr),1/x);*/
    ADDFORCES(f1,f2,f*dr)
#endif

    Reflect {
      ENEL+=erud(rr)*qq; f=byerd*qq;
      ADDFORCES2(f1,f2,f*dr) } }

  MARK_PATCH
  return U;
} /* XQQM */

void XQQ(vector r1,vector r2,vector f1,vector f2,double qq) /********** XQQ */
/* corrections to 1-2 and 1-3 interactions because of Ewald */
/* parameter ss never used ! */
{
  double rr,f,xxyy;
  real fdr;
#ifdef ermacro
  ertab_p er_p; /* byerd not needed */
#endif /*# ermacro */
  vector dr;

  NearestImage(,box.cq) {

#if COULOMB>=0 /* now no Ewald so that never active... */
    f=(erd(rr)-sqrt(rr)/Sqr(rr))*qq;
    ADDFORCES(f1,f2,f*dr)
#endif

    Reflect {
      f=erd(rr)*qq;
      ADDFORCES2(f1,f2,f*dr) } }

  return;
} /* XQQ */

#else /*# COULOMB */

double XQQM(vector r1,vector r2,vector f1,vector f2,double qq GLOB)  /* XQQM */
/* corrections to 1-2 and 1-3 interactions because of reflection */
{
  double U=0,rr,f,xxyy;
  real fdr;
/*rdf_t *ssrdf;*/
  ermacrodcl
  vector dr;

/*..... double EEE=ENEL;*/

  NearestImage(0,box.cq) {
  Reflect {
    ENEL+=f=qq/sqrt(rr); f/=rr;
    ADDFORCES2(f1,f2,f*dr)  } }

  MARK_PATCH
  return U;
} /* XQQM */

void XQQ(vector r1,vector r2,vector f1,vector f2,double qq) /********** XQQ */
/* corrections to 1-2 and 1-3 interactions because of Ewald */
/* parameter ss never used ! */
{
  double rr,f,xxyy;
  real fdr;
#ifdef ermacro
  ertab_p er_p; /* byerd not needed */
#endif /*# ermacro */
  vector dr;

  NearestImage(,box.cq) {
  Reflect {
    f=qq/sqrt(rr); f/=rr;
    ADDFORCES2(f1,f2,f*dr) } }

  return;
} /* XQQ */

#endif /* COULOMB */ /*# COULOMB */

#endif /* COOK */ /*# COOK */

void LJQQ(sitesite_t *ss,vector r1,vector r2,vector f1,vector f2,double qq)
                                                                 /**** LJQQ */
/* LJ + real-space charge-charge interactions, no measurements */
{
  double rr,f,x,y,xxyy;
  real fdr;
#ifdef ermacro
  ertab_p er_p; /* byerd not needed */
#endif /*# ermacro */
  vector dr;

  NearestImage(,box.cq) {
#ifdef COULOMB
    f=erd(rr)*qq;
#else /*# COULOMB */
    f=qq/(rr*sqrt(rr));
#endif /*# COULOMB */
#ifdef NIBC
    SS_NOMEASURE(+=)
#else /*# NIBC */
    if (rr < ss->C2q) {
      if (rr < ss->C1q)
        SS_NOMEASURE(+=)
      else {
        x=rr-ss->C2q; f+=ss->A4*x; } }
#endif /*# NIBC */
    ADDFORCES(f1,f2,f*dr)

    Reflect {
#ifdef COULOMB
      f=erd(rr)*qq;
#else /*# COULOMB */
      f=qq/(rr*sqrt(rr));
#endif /*# COULOMB */
      ADDFORCES2(f1,f2,f*dr) } }

  return;
} /* LJQQ */

void   QQ      (vector r1,vector r2,vector f1,vector f2,double qq) /**** QQ */
/* added 10/96 */
{
  double rr,f,xxyy;
  real fdr;
#ifdef ermacro
  ertab_p er_p; /* byerd not needed */
#endif /*# ermacro */
  vector dr;

  NearestImage(,box.cq) {
#ifdef COULOMB
    f=erd(rr)*qq;
#else /*# COULOMB */
    f=qq/(rr*sqrt(rr));
#endif /*# COULOMB */
    ADDFORCES(f1,f2,f*dr)

    Reflect {
#ifdef COULOMB
      f=erd(rr)*qq;
#else /*# COULOMB */
      f=qq/(rr*sqrt(rr));
#endif /*# COULOMB */
      ADDFORCES2(f1,f2,f*dr) } }

  return;
}

void LJ(sitesite_t *ss,vector r1,vector r2,vector f1,vector f2) /******* LJ */
/* LJ site-site interaction, no measurements */
{
  double rr,f,x,y,xxyy,cq=ss->C2q; /* to hide global cq */
  real fdr;
  vector dr;

  NearestImage(,box.cq) {
#ifdef NIBC
    SS_NOMEASURE(=)
#else /*# NIBC */
    if (rr < ss->C1q)
      SS_NOMEASURE(=)
    else {
      x=rr-cq; f=ss->A4*x; }
#endif /*# NIBC */
    ADDFORCES(f1,f2,f*dr) }

  return;
} /* LJ */

#ifdef DEBUGx
double LJQQtest(sitesite_t *ss,double qq,int noqq) /*************** LJQQtest */
/* for testing consistency of molecule-molecule potentials */
{
  if (fabs(ss->qq-qq)>1e-12*Sqr(electron) Error("ss->qq");
  if (noqq) if (qq!=0) Error("qq!=0 for NSS");
  return ss->corr;
}
#endif /*# DEBUGx */

#endif /*# LINKCELL */

