    /* external forces initialization and info */
    /* piece of code directly #included to main.c */


    /* harmonic central and similar (slab-keeping) forces */
#ifdef FREEBC
    put2(center.K,center.r0)
#else /*# FREEBC */
    {
      int k;

      center.on=0;

      loop (k,0,DIM) {
        if (center.K[k]!=0) center.on |= 2;
        center.K2[k]=2*center.K[k];
        if (center.r0[k]!=0 && center.K[k]==0)
          WARNING(("center.r0[%d]=%g but center.K[k]=0 does not make sense\n\
*** (note that center.r0 was renamed to center.z0 from version 2.2g)",
                   k,center.r0[k])) }
      if (center.on&2) {
        if (SQR(center.r0))
          prt("atom-based force K=(%g %g %g) harmonic from r0=(%g %g %g)",
                                   VARG(center.K),             VARG(center.r0));
        else
          prt("atom-based harmonic force K=(%g %g %g) specified",
                                            VARG(center.K)); }

#ifdef SLAB
#if SLAB & 2
      cleave.Ksigmah=cleave.K*cleave.sigma/2;
      if (!cleave.sigma) {
        cleave.n=0;
        prt("NOTE: cleave.n:=0 because cleave.sigma=0"); }

      if (cleave.n) {
        if (cleave.n<0 || cleave.n>2) {
          ERROR(("cleave.n=%d not in {0,1,2}",cleave.n))
          cleave.n=2; }

        center.on|=4;
        underline("cleaving walls");
        prt("cleave.sigma=%g A  cleave.K=%g K/A  cleave.n=%d  cleave.init=%d",
            cleave.sigma,cleave.K,cleave.n,cleave.init);

        if (cleave.init&1) 
          prt("cleaving wall position(s) will be copied from data");

        if (cleave.init&2) {
          if (cleave.n==2) {
            /* barostat in both cleaved compartments */
            rescale |= RESCALE_CLEAVE;
            prt("In case of NPT in z-direction, the cleaving walls will be\n  %s", cleave.init&2?
                "moving according to pressures in compartments":
                "uniformly scaled with z-box"); } }
        else
          prt("only one cleaving wall, bit 2^1 of cleave.init ignored"); }
#endif

      loop (k,0,CENTERSLAB) {
        slab.nn[k]=slab.n[k];
        if (k) slab.nn[k]+=slab.nn[k-1];
        center.on |= slab.Kz[k]!=0;
        slab.Kz2[k]=2*slab.Kz[k];
        slab.dz[k]=slab.z1[k]-slab.z0[k]; }

      if (center.on&1)
        loop (k,0,CENTERSLAB) if (slab.nn[k] && slab.Kz[k])
          if (slab.z1[k]) {
            prt_("slab step K=%g centered at z=L/2%+g, from z0=+-%g to z1=+-%g\n  for n in [%d,%d)",
                slab.Kz[k],slab.z[k],slab.z0[k],slab.z1[k],
                k==0?0:slab.nn[k-1],slab.nn[k]);
            slab.Kz2[k]=slab.Kz[k]/2*Sqr(slab.dz[k]);
            prt_("  step height=%g K  width=%g A",slab.Kz2[k],slab.dz[k]);
            if (thermostat) prt_("  Boltzmann factor=%g",exp(-slab.Kz2[k]/T));
            _n }
          else
            prt("z-force K=%g slabed at z=L/2%+g, from z0=+-%g for n in [%d,%d)",
                slab.Kz[k],slab.z[k],slab.z0[k],
                k==0?0:slab.nn[k-1],slab.nn[k]);
#endif
    }
#endif /*# FREEBC */

    if (center.cmn<0) center.cmn=0;

    if (center.cmn==0)
      if (center.cmK[0]!=0 || center.cmK[1]!=0 || center.cmK[2]!=0)
        prt("Nonzero center.cmK specified with center.cmn=0 ==>\n\
  center.cmn=%d (=No.N=all molecules) assigned",center.cmn=No.N);

    center.cmmass=0;
    if (center.cmn) {
      int n,i;

      loop (n,FROM,center.cmn) {
        molecule_t *mn=molec+n;
        siteinfo_t *si=spec[mn->sp]->si;

        loop (i,0,mn->ns)
        center.cmmass+=si[i].mass; }

      prt("Whole-configuration harmonic force K*(r_CM-r0)^2 to center-of-mass specified\n\
  for %d molecules of total mass %g (prog.units):",center.cmn,center.cmmass);
      loop (i,0,DIM) if (center.cmK[i]!=0) {
        double tau=sqrt(center.cmmass/(2*center.cmK[i]));

        prt("K%c = %g  ==> tau = %g ps (oscillation period=%g ps)",i+'x',
            center.cmK[i],tau,2*PI*tau); } }

#ifndef FREEBC
    if (center.cmn || center.on)
      prt("WARNING: the above forces violate periodic b.c.\n");
#endif

    /* electric field */

    /* conversion of V/m to internal prog. units */
    /*  NB: (lengthunit*chargeunit/energyunit)=1./352259391.) */
    VVO(Eext.E,=Eelst,*(lengthunit*chargeunit/energyunit))
#ifdef POLAR
    Eext.Eepspol=scf.E*(lengthunit*chargeunit/energyunit);
#endif
    Eext.isE=SQR(Eext.E)>0;
    if (Eext.E[0]!=0 && Eext.E[1]==0 && Eext.E[2]==0) Eext.isE=-3;
    if (Eext.E[1]!=0 && Eext.E[0]==0 && Eext.E[2]==0) Eext.isE=-2;
    if (Eext.E[2]!=0 && Eext.E[1]==0 && Eext.E[0]==0) Eext.isE=-1;
    if (Eext.isE) prt("WARNING: electrostatic field Eelst[] has been specified\n\
* energy in ionic system may not be conserved");
    if (Eext.isE && lag.cond==0) prt("\
* lag.cond=0 so that the current density is not measured and conductivity\n\
  cannot be calculated\n\
* program unit of elst field (used in .cp) = %g V/m",1/(lengthunit*chargeunit/energyunit));
#ifdef COULOMB
    if (Eext.isE<0) prt("M%c will be monitored instead of |M|",Eext.isE+3+'x');
#endif
