  /* support of strings like init="cont" in getdata */
  static struct keys_s initkey[]={
    {"continue",0}, {"cont",0},
    {"append",1},
    {"start",2},
    {"random",3},
    /*    {"rawrandom",4},*/
    {"slab",4},
    {"crystal",5}, {"lattice",5},
    {"asc",10},
    {"convert",999},
    {"plb",-1},
    {NULL,0}};
  static struct keys_s yesno[]={
    {"no",0}, {"false",0},
    {"yes",1},{"true",1},
    {"forever",-1}, /* for MC */
    {"debug",-1}, /* for quit: deprecated */
    {"paste",-2}, /* for quit: deprecated */
    {"shell",-4}, /* for quit: deprecated */
    {NULL,0}};
  static struct keys_s keykey[]={
    {"run",0},
    {"sort+x",1},
    {"sort+y",2},
    {"sort+z",3},
    {"sort-x",-1},
    {"sort-y",-2},
    {"sort-z",-3},
    {"cp",4},
    {"show",5},
    {"rdf",6},
    {"cn",7},
    {"shell",8},
    {"quit",9},{"exit",9},
    {NULL,0}};
  static struct keys_s pinskey[]={
    {"auto",0},
    {"sc",1},
    {"bcc",2},
    {"fcc",3},
    {NULL,0}};
  static struct keys_s thermostatkey[]={
    {"none",0},
    {"Berendsen",T_BERENDSEN},{"friction",T_BERENDSEN}, /* the same */
    {"Nose",T_NOSE},{"Nose-Hoover",T_NOSE},
    {"Andersen",T_ANDERSEN},
    {"Maxwell",T_MAXWELL},
    {"AndersenCM",T_ANDERSEN_CM},
    {"MaxwellCM",T_MAXWELL_CM},
    {"Langevin",T_LANGEVIN},
    {"LangevinCM",T_LANGEVIN_CM},
    {"BerendsenCM",T_TR},
    {"BerendsenIN",T_IN},
    {"frictions",T_FRICTIONS},
    {"NPT",T_NPT},
    {NULL,0}};
  static struct keys_s sortkey[]={
    {"none",0},
    {"x",1}, {"-x",-1},
    {"y",2}, {"-y",-2},
    {"z",3}, {"-z",-3},
    {NULL,0}};
  static struct keys_s loadtrkey[]={
    {"none",0},
    {"xy",1},
    {"yz",2},
    {"xz",3},{"zx",3},
    {"zyx",4},
    {"xyz",5},
    {NULL,0}};
  static struct keys_s loadzerokey[]={
    {"none",0},
    {"x",1},
    {"y",2},
    {"z",4},
    {"xy",3},
    {"xz",5},
    {"yz",6},
    {"xyz",7},
    {NULL,0}};
  static struct keys_s rescalekey[]={
    {"x",RESCALE_X},           {"xCM",RESCALE_X|RESCALE_CM},
    {"y",RESCALE_Y},           {"yCM",RESCALE_Y|RESCALE_CM},
    {"xy",RESCALE_X|RESCALE_Y},{"xyCM",RESCALE_X|RESCALE_Y|RESCALE_CM},
    {"z",RESCALE_Z},           {"zCM",RESCALE_Z|RESCALE_CM},
    {"xz",RESCALE_X|RESCALE_Z},{"xzCM",RESCALE_X|RESCALE_Z|RESCALE_CM},
    {"yz",RESCALE_Y|RESCALE_Z},{"yzCM",RESCALE_Y|RESCALE_Z|RESCALE_CM},
    {"xyz",RESCALE_XYZ},       {"xyzCM",RESCALE_XYZ|RESCALE_CM},
    {"X",RESCALE_X|RESCALE_PT},{"XCM",RESCALE_X|RESCALE_PT|RESCALE_CM},
    {"Y",RESCALE_Y|RESCALE_PT},{"YCM",RESCALE_Y|RESCALE_PT|RESCALE_CM},
    {"XY",RESCALE_X|RESCALE_Y|RESCALE_PT},{"XYCM",RESCALE_X|RESCALE_Y|RESCALE_PT|RESCALE_CM},
    {"Z",RESCALE_Z|RESCALE_PT},{"ZCM",RESCALE_Z|RESCALE_PT|RESCALE_CM},
    {"XZ",RESCALE_X|RESCALE_Z|RESCALE_PT},{"XZCM",RESCALE_X|RESCALE_Z|RESCALE_PT|RESCALE_CM},
    {"YZ",RESCALE_Y|RESCALE_Z|RESCALE_PT},{"YZCM",RESCALE_Y|RESCALE_Z|RESCALE_PT|RESCALE_CM},
    {"XYZ",RESCALE_XYZ|RESCALE_PT},       {"XYZCM",RESCALE_XYZ|RESCALE_PT|RESCALE_CM},
    {"XX",RESCALE_X|RESCALE_Y|RESCALE_PT|RESCALE_XisY},{"XXCM",RESCALE_X|RESCALE_Y|RESCALE_PT|RESCALE_XisY|RESCALE_CM},
    {"XXZ",RESCALE_XYZ|RESCALE_PT|RESCALE_XisY},{"XXZCM",RESCALE_XYZ|RESCALE_PT|RESCALE_XisY|RESCALE_CM},
    {"XXX",RESCALE_XYZ|RESCALE_PT|RESCALE_XisYisZ},{"XXXCM",RESCALE_XYZ|RESCALE_PT|RESCALE_XisYisZ|RESCALE_CM},
    {NULL,0}};

  if (narg<2) {
    fprintf(stderr,"%s\nCall by:\n\
  %s [OPTIONS] [SYSNAME] SIMNAME [PLBNAME.plb] [OPTIONS]\n",INFO,arg[0]);
    fputs("\
Input files (missing SYSNAME:=SIMNAME, missing PLBNAME.plb:=SIMNAME.plb):\n\
  SYSNAME.ble  force field, generated by blend\n\
  SIMNAME.def  defaults; if no SIMNAME.def, SYSNAME.def is tried\n\
  SIMNAME.get  input data (if -s then stdin)\n\
  SIMNAME.cpi  variables recorded in convergence profiles\n\
  PLBNAME.plb  input configuration(for init<0)\n\
OPTIONS:\n"
#if CHECKHEAP==-2
"  +#  (because CHECKHEAP==-2): range (in B) to check array overflow\n"
#endif
#ifdef POLAR
"  -a% scale polarizabilities [default=100%]\n"
#endif /*# POLAR */
"  -b# interactive (-s): set beep level  batch: SIMNAME.stp=^C (SIGINT+save) [-2]\n\
  -c# 1=corr. constraints/Gear by conjgrad, report: 2=before 4=mid 8=after [9]\n\
  -d# check pair distances: 1=once per job 2=per cycle 3=per step [0=never]\n\
  -e# record max # items in the SIMNAME.cp [-1=all]\n"
#ifndef FREEBC
  "  -f# diffusivity and structure factor from stored cfgs: init,init+#,..,no [0]\n"
#endif /*# FREEBC */
"  -g# input=SIMNAME.G#; -f -g# output=SIMNAME.S# [0]"
#ifdef CLUSTERS
", no cluster analysis"
#endif /*# CLUSTERS */
"\n  -h4 refine tetrahedral angles [0]\n\
  -i# ^C (kill -SIGINT) is: -1=kill 0=ask 1=next data 2=finish [smart]\n\
  -j# #>0: fix 1st # molecules, #<0: init: insert 1st |#| molecules w/o rot [0]\n\
  -k# keep atoms (listed in SIMNAME.fix) by force # K/A^2 [off]\n\
  -lGFAVC ASCII dump (Grad,Forces,Accel,Veloc,Cfg); 1:full prec., >1: dec.dig.\n\
  -m# {3-6} Gear + Lagrangian constrained dynamics [default=-m2=Verlet+SHAKE]\n\
  -n  write SIMNAME.vlb (velocity playback) [0]\n\
  -o- ignore loc-file (the same as -o0) [1]\n\
  -pKPC predictor lengths and orders: [229] (9=derived from -m)\n\
    K=ASPC or similar polar predictor length\n\
    P=Polar method, 0:Car-Parrinello, 1:no prediction, 2:ASPC, 3:higher order\n\
    C=Verlet: velocity predictor length, Gear: constraint predictor order (-m#)\n\
  -q% init charge scaling (in %), #<0: make cfg neutral [100%]\n\
  -r# record cfgs to #-th derivative (by dt.cfg) [1]\n\
  -s# interactive mode (#kB scroll buffer) [0=batch]\n\
  -t  detailed time measurements [0]\n\
  -u# force const. limit for vibrating bonds in kcal/mol/A^2 [0=all fixed]\n\
  -v# verbosity: 0=min or sum of 1,2,4,.. [3]\n\
  -w# write cfg: 0=never 1=after data set; 2=wait if not enough disk space [1]\n\
  -x  waters: 1=opt.code rigid  2=keep LJ H-H,O-H for TIP3P  4=doublecheck [5]\n\
  -y# playback # molecules only, -y-# don't call molcfg, [MAXINT=whole cfg]\n\
  -z# random number seed [0=use time]\n"
#ifdef POLAR
"  -^QOO POLAR: Q=shell=Drude charge (signed in e), OO=scf.omega (2 digits %)\n"
#endif /*# POLAR */
#ifdef LINKCELL
"  -@# LINKCELL: record cell occupancies (to # sites/cell)\n"
#endif /*# LINKCELL */
#if PARALLEL
"  -\\# PARALLEL: -\\# # of threads; 0 use NSLOTS (df.) <0 linked-cell: No.cell[0]\n"
#endif /*# PARALLEL */
         ,stderr);
    exit(0); }
