#ifdef LINKCELL
put3(box.over14,box.max14,box.max14v)
    box.max14v=0;
#endif

#  ifdef XSECTION
    put(xs.maxsize)
#  endif /*# XSECTION */

    underline("statistics");
    if (option('v')&2) StaPrintAll(NULL);
    if (option('v')&4) StaPrintAll("");
    else prt("HINT: use `staprt %s' for detailed time-series analysis",simils.simname);
    prt("NOTE: program unit of dipole moment = %.9g Debye = %.9g Cm",Debye,chargeunit*lengthunit);
    prt("V = %g m3 (last value)",box.V*1e-30);
    _n

#  ifdef WIDOM
#    include "widomres.c"
#  endif /*# WIDOM */

#  ifdef DIHHIST
    printdihhist();
#  endif /*# DIHHIST */

  if (tau.P) {
    double dV=StaStdErr("V");
    double V=StaMean("V");

    prt("rho = mass/<V> = %g %g kg/m3",rhounit*No.free_mass/V,rhounit*No.free_mass/Sqr(V)*dV); }

#  ifndef REDUNITS
    prt("<Epot>/molecule   = %12.2f J/mol = %11.5f kcal/mol = %g K",
        StaMean("Epot [*")/No.N*SIE,
        StaMean("Epot [*")/No.N/kcal*SIE,
        StaMean("Epot [*")/No.N/Eunit*SIE);
    prt("<Eintra>/molecule = %12.2f J/mol = %11.5f kcal/mol = %g K",
        StaMean("Ein [*")/No.N*SIE,
        StaMean("Ein [*")/No.N/kcal*SIE,
        StaMean("Ein [*")/No.N/Eunit*SIE);
#  endif /*# REDUNITS */

#  if 0 /* mean quadratic dipolemoments */
    {
      int n;
      double D;
      char s[16];

      loop (n,0,nspec) if (spec[n]->N) {
        sprintf(s,"dipmom[%d]^2",n);
        if ( (D=StaMean(s)) ) {
          D=sqrt(D);
          prt("sqrt(%s) = %f = %.4f D",s,D,D*Debye); } } }
#  endif /*# 1 */

#  if (PRESSURETENSOR&PT_ANY) == PT_ANY
    { /*
         this actually duplicates Pvirerr, but is more fool-proof
         because is based on the final (only uncorrected) pressure tensor
      */
      double x=StaMean("P(Ptens) [Pa]")-StaMean("P [Pa]");

      prt("\n%sressure accuracy: tr(<Ptens>)/3+corr-<P>=%g Pa\n"
"EXPLANATION: The standard virial pressure P is calculated under the assumption\n\
  that the electrostatic energy = electrostatic virial while the pressure\n\
  tensor components Ptens are calculated directly from forces; both pressures\n\
  include standard (nonelectrostatic) cutoff correction %g Pa\n"
#    if COULOMB<0
"  The difference thus assesses the Ewald summation accuracy.\n"
#    else /*# COULOMB<0 */
"  The Ptens-based value is probably more accurate.\n"
"  Consider using rescale|=64 (rescale=\"XXX\" or \"XXXCM\") with the barostat.\n"
#    endif /*#!COULOMB<0 */
"  Both values may differ also while fixing some atoms (e.g., via option -j).\n"
          ,fabs(x)>el.Perr?"WARNING: Low p":"P",x,constrd.Pcorr);
      if (fabs(x)>el.Perr*10) WARNING(("Too low virial pressure vs. tensor accuracy (%g Pa)",x))
    }
#  endif /*# (PRESSURETENSOR&PT_ANY) == PT_ANY */

#  if PRESSURETENSOR&PT_MOM
    {
      char x;
      underline("kurtosis and normalized 6-th central moment of v_CM");
      header("DIR  kurtosis 6-th moment ");
      loop (x,'x','x'+DIM) {
        double E1=StaMean(string("PKin.%c%c [Pa]",x,x))/No.N;
        double E2=StaMean(string("PKin2.%c%c [Pa^2]",x,x))/No.N;
        double E3=StaMean(string("PKin3.%c%c [Pa^3]",x,x))/No.N;

        prt(" %c  %9.6f  %9.6f",x,E2/Sqr(E1)-3,E3/Cub(E1)-15*E2/Sqr(E1)+30); }
      header("");
    }
#  endif /*# PRESSURETENSOR&PT_MOM */
#  ifdef COULOMB
    {
      int k;
      double V;

      if (tau.P) V=StaMean("V");
      else V=box.V;

      if (tau.sat!=0) {
        double x;
        char *E;

        /* saturation: write back (possibly) changed Eelst in V/m */
        VVO(Eelst,=Eext.E,/(lengthunit*chargeunit/energyunit))
        underline("saturation autoset");
        prt("final values after a sweep:\n\
  el.epsinf = %g\n\
  Eelst = [ %g %g %g ] V/m",el.epsinf,VARG(Eelst));
        prt("NB: to restart simulation from this POINT, use in the data:");
        if (Eext.isE)
          prt("  Eelst[%d]=%g",3+Eext.isE,Eelst[3+Eext.isE]);
        else
          prt("  el.epsinf=%g",el.epsinf);
        prt("averaged values with standard errors:");
        if (Eext.isE) {
          E=string("E%c [V/m]",'x'+3+Eext.isE);
          x=StaMean(E);
          prt("  <%s> = %g %g",E,x,StaStdErr(E));
          if (tau.sat<0) {
            if (3+Eext.isE<0 || 3+Eext.isE>=DIM) ERROR(("Eext.isE=%g out of range",Eext.isE))
            Eelst[3+Eext.isE]=x; } }
        else {
          double dx=StaStdErr("1/(2*epsinf+1)");

          x=StaMean("1/(2*epsinf+1)");
          E="epsinf";
          prt("  <1/(2*epsinf+1)> =  %g %g",x,dx);
          prt("  el.epsinf = %g  67\%: [%g %g]",
              (1/x-1)/2,(1/(x+dx)-1)/2,(1/(x-dx)-1)/2);
          if (tau.sat<0) el.epsinf=(1/x-1)/2; }
        if (tau.sat<0) {
          init=1;
          tau.sat=0;
          prt("\n\
====== You specified AUTOMATIC START by tau.sat<0. Therefore: ======\n\
* %s was assigned to the above AVERAGED value\n\
* init=1 (init=\"append\") was assigned to be used for the next sweep\n\
         (you may override init at next sweep start)\n\
* tau.sat=0 was assigned\n\
NB: to restart simulation from this AVERAGE, use in the data:",E);
          if (Eext.isE)
            prt("  Eelst[%d]=%g",3+Eext.isE,x);
          else
            prt("  el.epsinf=%g",el.epsinf); }
      } /* tau.sat!=0 */

      /*** dielectric constant ***/
      prtdielconst(V,Q!=NULL); /* new: also if elst. field */

      prt("\nEXTERNAL ELECTRIC FIELD = (%g %g %g) V/m", VARG(Eelst));
      if (Eext.isE)
        prt("%d ions detected, so I will calculate %s",No.ion,No.ion?"conductivity from current":"dielectric constant from dipole moment");

      loop (k,0,DIM) if (Eelst[k]) {
        char xyz=k+'x';

        if (No.ion) {
          char *name=string("J%c [A/m2]",xyz);
          double J=StaMean(name),dJ;

          if (StaError) continue;
          dJ=StaStdErr(name);
          prt("conductivity_%c = %g %g  (mean stderr)",
              xyz,J/Eelst[k],dJ/Eelst[k]); }
        else {
          char *name=string("M%c",xyz);
          double M=StaMean(name),dM;
          double eps[5],deps;
          int j;

          if (StaError) {
            name=string("M[%d]",k);
            M=StaMean(name); }
          if (StaError) continue;
          deps=M/Eext.sumM;
          prt("saturation <M%c>/M_tot = %g (M_tot=%g p.u.)",xyz,deps,Eext.sumM);
          if (fabs(deps)>0.1) prt("WARNING: The dipole moment of the cell is %.3f of the saturated one.\n\
*** The dielectric constant may be affected by nonlinear response.\n\
*** Consider decreasing the field and/or el.epsinf.",deps);

          dM=StaStdErr(name);
          M*=4.4266218e+09/(V*Eelst[k]);
          dM*=4.4266218e+09/(V*Eelst[k]);
          prt("chi_%c = %7.4f %7.4f",xyz,M,dM);
          loopto (j,-2,2) eps[j+2]=1+1/(1/(M+j*dM)-1/(el.epsinf*2+1));
          deps=Sqr((eps[2]-1)/M)*dM;
          prt("epsilon_%c = %7.4f %7.4f mean stderr",xyz,eps[2],deps);
          prt("68%% range: [%7.4f %7.4f]  96%% range: [%7.4f %7.4f]",
              eps[1],eps[3],eps[0],eps[2]); } }

      if (lag.cond) {
        underline("EMD conductivity hints");
        prt("(applies only in directions where Eelst_x,y,z=0)\n\
* calculate the time autocovariances of el. current density by commands:\n\
    staprt -t2 -nJx* %s\n\
    staprt -t2 -nJy* %s\n\
    staprt -t2 -nJz* %s\n\
* check that the data have sufficiently fine grid (otherwise decrease noint)\n\
* check that the data have sufficiently long lag (otherwise increase lag.cond)\n\
* calculate their running integrals by commands:\n\
    runint -e -m2 < %s.Jx.cov > %s.Jx.cov\n\
    runint -e -m2 < %s.Jy.cov > %s.Jy.cov\n\
    runint -e -m2 < %s.Jz.cov > %s.Jz.cov\n\
* plot these curves and determine the limiting averaged value:\n\
    plot %s.J?.run\n\
* the conductivity is this value multiplied by V/kT=%g",
            simils.simname,simils.simname,simils.simname,
            simils.simname,simils.simname,simils.simname, simils.simname,simils.simname,simils.simname,
            simils.simname,
            V*Cub(lengthunit)/energyunit/StaMean("Tkin"));
      }
    }
#  endif /*# COULOMB */

#  if PRESSURETENSOR&PT_OFF
    if (lag.visc) {
      double V; /* unnecessarily repeated! */

      if (tau.P) V=StaMean("V");
      else V=box.V;

      underline("EMD viscosity hints");
      prt("(applies to xy only if the shear is also set)\n\
* calculate the time autocovariances of the off-diagonal components of the\n\
  pressure tensor (in Pa^2):\n\
    staprt -t2 -nPtxy* %s\n\
    staprt -t2 -nPtyz* %s\n\
    staprt -t2 -nPtzx* %s\n\
* check that the data have sufficiently fine grid (otherwise decrease noint)\n\
  and long enough lag (otherwise increase lag.visc):\n\
    plot %s.Pt??.cov\n\
* calculate their running integrals by commands:\n\
    runint -e -m2 < %s.Ptxy.cov > %s.Ptxy.run\n\
    runint -e -m2 < %s.Ptyz.cov > %s.Ptyz.run\n\
    runint -e -m2 < %s.Ptzx.cov > %s.Ptzx.run\n\
* plot these curves and determine the limiting averaged value:\n\
    plot %s.Pt??.run\n\
* the viscosity in Pa.s is this value multiplied by V/kT=%g",
          simils.simname,simils.simname,simils.simname,
          simils.simname,
          simils.simname,simils.simname,simils.simname,
          simils.simname,simils.simname,simils.simname,
          simils.simname,
          V*Cub(lengthunit)/energyunit/StaMean("Tkin")); }
#  endif /*# PRESSURETENSOR&PT_OFF */

#  ifdef SHEAR
    /*** shear viscosity ***/
    prtviscosity();
#  endif /*# SHEAR */

    LRPrint(' '); _n

#  ifdef ANCHOR
    if (anchor.f) fclose(anchor.f); anchor.f=NULL;
#  endif /*# ANCHOR */

    /*** print pseudographs of rdf's ***/
    if (option('v')&1024) rdfgraph();

    sortmolecules(sort);
    sort=0;

    if (option('w')>1)
      waitfordiskspace(No.s
#  ifdef POLAR
                           *2
#  endif /*# POLAR */
                             /7+2*option('l')+no*NCP/200+256
#  ifdef SLAB
                                                             +128
#  endif /*# SLAB */
                                                                  );

    /*** save cfg, rdf and close cp files ***/
    if (option('w')) {
      if (tau.R) RvdW=sitedef[tau.i].LJ[0].RvdW;
      savecfg(-1,(int4)stoptime,&RvdW); }

    writeasc(); /* according to option -l */

#  ifdef DIHHIST
    if (dihcp) fclose(dihcp);
#  endif /*# DIHHIST */

    if (icyc || option('w')==1) {
#  ifdef DIHHIST
      savedih(dih.grid);
#  endif /*# DIHHIST */
#  ifdef HARMONICS
      saveharmonics();
#  endif /*# HARMONICS */
#  ifdef SLAB
      /* density profiles and surface tension */
      savedpr(slab.grid);
      printdpr(slab.mode,dV,constrd.PdVname);
#    if SLAB & 2
      if (cleave.n>0)
        prt("cleave.z0=%.12f (specified)  cleave.z[0]=%.12f (final)",cleave.z0,cleave.z[0]);
      if (cleave.n>1)
        prt("cleave.z1=%.12f (specified)  cleave.z[1]=%.12f (final)",cleave.z1,cleave.z[1]);
#    endif /*# SLAB & 2 */
#  endif /*# SLAB */
#  if PARALLEL==1
      parallelizerdf(0);
#  endif /*# PARALLEL==1 */
      saverdf(rdf.grid); }

    if (icyc) {
      backup("sta");
      StaKeySave(Fn("sta"),stoptime);
      if (option('y')) {
        if (dt.plb==0) writeplayback();
        closeplayback();
        plbopened=0; }
      saveCP(icyc,stoptime); }

#  ifdef POLAR
#    include "polarres.c"
#  endif /*# POLAR */

    if (nm.dr) {
      if (nm.method&1) normalmodesc(); /* with constraints */
      else normalmodes(); /* flexible */ }

    /* release the heap */
    StaFree();
    release(mark);
#  ifdef WIDOM
    widomrdf(-1);
#  endif /*# WIDOM */

    if (No.c) {
      int sp;

      loop (sp,0,nspec)
        if (constrit[sp].nit[COR_LAST])
          prt("spec=%d: omegac=%f (%s) last niter/molec=%f\n(cf. \"constrit%d spec%d\")",
            sp,constrit[sp].omegac,
            omegac<0?"optimized":"fixed",
            (double)constrit[sp].nit[COR_LAST]/spec[sp]->N,sp,0); }

    prt("sweep finished: L=(%.9f %.9f %.9f) V=%.11g",
                            VARG(box.L),      box.L[0]*box.L[1]*box.L[2]);

    fflush(out);

    if (En.kin) put3(En.bonded,En.kin,En.bonded/En.kin)

    if (T) if (En.bonded>En.kin*10) {
      static int pass=0;
      if (!pass)
        WARNING(("Bonded energy is %g times greater than kinetic energy\n\
(more warnings will be suppressed)",En.bonded/En.kin))
      pass=1; }
