/* rescaling stuff for main.c, periodic b.c., also saturation */

#ifdef FREEBC
      if (tau.rho || tau.P || dV) ERROR(("tau.rho, tau.P, dV not supported with FREEBC"))
#else /*# FREEBC */

      /* rescale to reach given density or L */
      if (tau.rho) {
        if (rhorescale(rescale,tau.rho,L,halftcyc)) {
          if (rhoreached) prt("^^^^^^^^^^^^^^^^ the reference box (density) has been reached ^^^^^^^^^^^^^^^^");
          rhoreached=0; } }

      /* friction-like (Berendsen) barostat or adjusting molecule size */

//prt("tr(P)=%g Pvir=%g",SUM(En.Ptens),En.P-En.corr/(box.V*box.V)*Punit);
//prt("tr(Pvir)=%g",SUM(En.Pvir));
//prt("tr(Pkin)=%g Ekin=%g",SUM(En.Pkin)*box.V/Punit*1.5,En.kin);

      if (rescale & RESCALE_PT) {
        if (thermostat<T_NPT && tau.P!=0) {
#  if (PRESSURETENSOR&PT_ANY) == PT_ANY
          int ii;
          double beta_T=box.V/(No.f*En.T); /* compressibility */

          if (bulkmodulus) beta_T=Punit/3/bulkmodulus;

          if (dV)
            ERROR(("implementation limitation:\n\
*** pressure tensor components calculated by virtual volume (area, shape)\n\
*** change (with dV set) cannot be used for shape change (rescale & %d)",RESCALE_PT))

          loop (ii,0,DIM)
            Pscale[ii]=scaling(tau.P,noint,
                               h*beta_T*(P-En.Ptens[ii]-((corr&2)==2)*En.corr/Sqr(box.V)*Punit)/Punit,
                               maxscale);
/*  Pscale=exp((tau.P+tau.R<0?noint:-1)*h*box.V/No.f/En.T/(tau.P+tau.R)*(P/Punit-locP)); */

          if (rescale & RESCALE_XisY) Pscale[0]=Pscale[1]=sqrt(Pscale[0]*Pscale[1]);
          if (rescale & RESCALE_XisYisZ) Pscale[0]=Pscale[1]=Pscale[2]=cubrt(Pscale[0]*Pscale[1]*Pscale[2]);

#    if defined(SLAB) && SLAB & 2
          if (rescale & RESCALE_CLEAVE)
            cleavescaling(Pscale,tau.P,noint,
                          h*beta_T*(En.fcleave[1]-En.fcleave[0])/(box.L[0]*box.L[1]),
                          maxscale);
#    endif /*# defined(SLAB) && SLAB & 2 */

          if (tau.P<0) /* rescale now (otherwise every step) */
            rescalecfg(cfg[0],rescale|RESCALE_L,Pscale[0],Pscale[1],Pscale[2]);
#  else /*# (PRESSURETENSOR&PT_ANY) == PT_ANY */
          ERROR(("rescale & RESCALE_PT (%d) was specified but this version\n\
*** of cook was not compiled with needed #define PRESSURETENSOR 3 (or more)",RESCALE_PT))
#  endif /*#!(PRESSURETENSOR&PT_ANY) == PT_ANY */
        } }
      else { /* !(rescale & RESCALE_PT): virial-based rescaling */
        if (thermostat<T_NPT && (tau.P!=0 || tau.R!=0)) {
          double Ploc;
          double tauloc=tau.P;
          /* tau.P<0: rescaled every cycle
             tau.P>0: rescaled every step (keeps scaling factor through whole cycle)
             note: P and Pvir are in Pa */
          double beta_T=box.V/(No.f*En.T); /* compressibility */

          if (bulkmodulus) beta_T=Punit/(3*bulkmodulus);

          if (tau.R) tauloc=tau.R;
          if (corr&2) {
            /* with cutoff correction */
            if (dV) Ploc=En.PdV; else Ploc=En.P; }
          else {
            /* without cutoff correction (if these are determined) */
            if (dV) Ploc=En.PdVnc; else Ploc=En.Pnc; }

          Pscale[0]=Pscale[1]=Pscale[2]=scaling(tauloc,noint,h*beta_T*(P-Ploc)/Punit,maxscale);
          if (rescale & RESCALE_CLEAVE) ERROR(("cleaving rescaling incompatible with virial-based pressure"))

          if (tau.P<0) /* rescale now (otherwise every step) */
            rescalecfg(cfg[0],rescale|RESCALE_L,Pscale[0],Pscale[1],Pscale[2]);
          if (tau.R<0) {
            /* adjusting an R-like parameter */
            sitedef[tau.i].LJ[0].RvdW/=Pscale[0];
            setss(&sstab[tau.i][tau.i],tau.i,tau.i,LJcutoff,0); } } }

#  ifdef COULOMB
/*** saturation control ***/
      if (tau.sat!=0) {
        double sat,q;

        if (!Q) ERROR(("internal: Q (Ewald charge structure) not allocated"))

        if (Eext.isE<0) {
          /* adjust external electrostatic field to saturation */
          sat=Q->M[Eext.isE+3]/el.sumM;
          q=exp((1-sat/el.sat)*No.dt/fabs(tau.sat));
          Min(q,1.01) Max(q,0.99)
          Eext.E[Eext.isE+3]*=q;
          //          fprintf(stderr,"%c: sat=%7.4f E=%.5e q=%7.4f\n",'x'+Eext.isE+3,sat,Eext.E[Eext.isE+3]/(lengthunit*chargeunit/energyunit),q);
          StaAdd(string("E%c [V/m]",'x'+Eext.isE+3),
                 Eext.E[Eext.isE+3]/(lengthunit*chargeunit/energyunit)); }
        else if (Eext.isE>0)
          ERROR(("elst field perpendicular to one of axes required with tau.sat,el.sat"))
        else {
          /* adjust el.xinf=1/(2*el.epsinf+1) to saturation */
          sat=sqrt(SQR(Q->M))/el.sumM;
          q=log(sat/el.sat)*No.dt/fabs(tau.sat);
          Min(q,0.01) Max(q,-0.01)
          el.xinf=1/(2*el.epsinf+1)+q; /* el.epsinf is the primary stored quantity */
          el.epsinf=0.5/el.xinf-0.5;
          //    fprintf(stderr,"sat=%7.4f el.epsinf=%8.4f q=%9.6f\n",sat,el.epsinf,q);
          StaAdd("1/(2*epsinf+1)",el.xinf); }
      }

#  endif /*# COULOMB */

#endif /*#!FREEBC */
