/* restricted: no constraints, no dependants, no frame dump... */
void normalmodes(void) /**************************************** normalmodes */
{
  int N=No.s*3,n,i,j,nit;
  double **A,**R=NULL,*rp,*mq,*fp,*fm;
  double rr,x,sumlnf;
  sort_t *sort;
  FILE *nmv;
  ToIntPtr CFG,FP,FM,M;
#ifdef POLAR
  int nitm;
  double summaxerr=0,summaxerrq=0,*p0,*pp;
#endif

#if defined(COULOMB) && COULOMB<0
  if ((el.rshift&2)==0) WARNING(("nm: el.rshift=3 recommended with normal mode calculations"))
#endif

  if (nm.dr<0) WARNING(("normalmodes: nm.dr<0 no longer selects constraint models\n\
*** consider nm.method=1 or 3"))
  if (No.c) ERROR(("normalmodes: No.c=%d: constraints not implemented\n\
*** try nm.method=1 or 3",No.c))
  if (No.depend[0]) ERROR(("normalmodes: No.depend=%d: dependants not implemented\n\
*** try nm.method=1 or 3",No.depend))

#define D(X) ((double*)(X[0]))
  if (FROM) ERROR(("normalmodes and FROM=%d: not implemented"))
  fprintf(stderr,"nm: started at %s",myctime(mytime()));

  underline("fundamental frequencies");
  prt("normal mode analysis: %dx%d matrix of d2U/drdr, dr=%g",N,N,nm.dr);

  ralloc2Darrayzero(A,N,N); /* this is the mark for release */
  sdsralloc(CFG,cfg[0]->size);
  sdscopy(CFG,cfg[0]);
  //  sdsralloczero(F,cfg[0]->size);
  sdsralloczero(FM,cfg[0]->size);
  sdsralloczero(FP,cfg[0]->size);
  sdsralloczero(M,cfg[0]->size);
  rp=D(rof(molec,CFG->rp));
  mq=D(rof(molec,M->rp));
  //  f=D(rof(molec,F->rp));
  fp=D(rof(molec,FP->rp));
  fm=D(rof(molec,FM->rp));
  //  loop (i,0,N) rallocarrayzero(A[i],N);

#ifdef POLAR
  p0=D(polarrof(molec,cfg[0]->rp));        
  pp=D(polarrof(molec,CFG->rp));        
#endif

  if (nm.modes) ralloc2Darrayzero(R,N,N);

  j=0;
  loop (n,0,No.N) {
    molecule_t *mn=molec+n;
    siteinfo_t *si=spec[mn->sp]->si;
    int ns=mn->ns;

    loop (i,0,ns) {
      x=sqrt(si[i].mass);
      mq[j++]=x;
      mq[j++]=x;
      mq[j++]=x; } }

  if (j!=No.s*3) ERROR(("internal: j!=No.s*3"))

  measure=1;

  /* forces at minimum, Drude at minimum:
     - FP thrown out
     - polar part of cfg[0] used in the predictor 
     - not needed for nonpolar  */
#ifdef POLAR
  nit=scforces(FP,cfg[0]);
  summaxerr+=scf.maxerr; summaxerrq+=Sqr(scf.maxerr);
  put2(En.pot,nit)
#endif

  nit=0;
  /* calculate matrix A = expansion of the potential at minimum */
  loop (i,0,N) {
    rr=rp[i];

    rp[i]=rr+nm.dr;
#ifdef POLAR
    /* original dipoles */
    loop (j,0,No.s*3) pp[j]=p0[j];
    nitm+=scforces(FP,CFG);
    summaxerr+=scf.maxerr; summaxerrq+=Sqr(scf.maxerr);
#else
    zeroEn();
    forces(FP,CFG);
#endif

    rp[i]=rr-nm.dr;
#ifdef POLAR
    /* predictor */
    loop (j,0,No.s*3) pp[j]=2*p0[j]-pp[j];
    nit+=scforces(FM,CFG);
    summaxerr+=scf.maxerr; summaxerrq+=Sqr(scf.maxerr);
#else
    zeroEn();
    forces(FM,CFG);
#endif

    rp[i]=rr;

    loop (j,0,N) {
      /* NB: symmetrization (of numerical errors) here */
      x=(fp[j]-fm[j])/(nm.dr*mq[i]*mq[j]);
      A[i][j]-=x;
      A[j][i]-=x; } 

    if (i && (i%100==0)) fprintf(stderr,"nm: A[%d] of %d finished at %s",i,N,myctime(mytime()));
  }

  /* ... A is four times the correct (1/2)d2U/dxdy/sqrt(mi mj) */
  fprintf(stderr,"nm: A finished at %s",myctime(mytime()));

#ifdef POLAR
    prt("SCF iteration summary, scf.epsx=%g:\n\
averaged # of iterations for r=r-dr: %g  for r=r+dr(predicted): %g\n\
<maxerr> = %g  stdev(maxerr) = %g",
        scf.epsx,(double)nitm/N,(double)nit/N,
        summaxerr/(2*N+1),
        sqrt((summaxerrq/(2*N+1)-Sqr(summaxerr/(2*N+1)))*(2*N+1)/(2*N)));
    if (scf.epsx==0) prt("\
Hint: scf.epsx=2*<maxerr>  or so may be more efficient than scf.epsx=0,\n\
      yet accurate enough");
#endif

  sig=0;
  rr=Jacobi(N,A,R,nm.eps);
  /* ... and now:
     A=diag(omega_i^2),
     R[i][j]/sqrt(mj) = i-th normal mode eigenvector */
  prt("Jacobi diagonalization error = %g",rr);
  fprintf(stderr,"nm: Jacobi finished at %s",myctime(mytime()));

  rallocarray(sort,N);
  loop (i,0,N) {
    sort[i].l=A[i][i];
    sort[i].i=i; }
  qsort(sort,N,sizeof(struct sort_s),sortnmf);

  nmv=fopen(Fn("nmf"),"wt");

  fprintf(nmv,"\
# normal mode frequencies\n\
# matrix n=%d   d2U/drdr=-df/dr, dr=2*%g   Jacobi diag.err.=%g\n\
#  i        [THz]          [1/cm]\n",N,nm.dr,rr);
  rr=1e24/Sqr(4*PI); /* 1e24 = energyunit/lengthunit^2/massunit */
  sumlnf=0;
  j=0;
  loop (i,0,N) {
    x=sort[i].l*rr;
    if (x<0) x=-sqrt(-x); else x=sqrt(x);
    if (i>=nm.zero) sumlnf+=log(x); 
    else if (fabs(x)>1e10) j++;
    fprintf(nmv,"%4d %15.8f %15.8f%s\n",
            i,x*1e-12,x/29979245800,i<nm.zero?" excluded from Tnu":"");
  }

  if (j) WARNING(("%d modes should be zero (because dr.zero=%d), but frequencies > 0.01 THz\n\
*** check the frequences in %s\n\
*** make sure a potential minimum has been reached (T=0, thermostat, tau.T)\n\
*** check nm.dr, nm.eps\n\
*** check accuracy of Ewald (el.epsr, el.grid) and SCF (scf.epsx)",j,nm.zero,lastFn))

  fclose(nmv);

  /* h/k=4.79923734e-11 Ks */
  j=No.s*3-nm.zero;
  prt("nm.zero=%d frequences omitted, %d nonzero fundamental frequencies:\n\
sum ln(nu/s^-1) = %.9g\n\
geometric average of vibrational temperatures Tnu = %.10g K\n",
      nm.zero,j,sumlnf,4.79923734e-11*exp(sumlnf/j));

  /* write vibrations */
  if (R) {
    int from=0,to=N,k,indx,ix,j,i;
    FILE *plb;
    float r[3];
    double m,a,ampl;
    char *sys=string("rm %s.nm[0-9][0-9][0-9][0-9].plb",simils.simname);

    /* remove old vibration plb's */
    prt("%s: retc=%d",sys,system(sys));

    if (nm.modes>0) to=nm.modes;
    else from=N+nm.modes;
    Max(from,0)
    Min(to,N)
    if (from<to) {
      prt("normal modes: writing frames from %d to %d (incl)",from,to-1);
      loop (j,from,to) {
        indx=sort[j].i;
        plb=fopen(Fn(string("nm%04d.plb",j)),"wb");
        if (!plb) { ERROR(("cannot open %s",lastFn)) break; }
        ampl=nm.ampl;
        /* normal modes:
           ampl = max amplitude of moves over all atoms */
        if (ampl<0) ampl=-ampl*sqrt(No.s);
        m=a=0;
        loop (i,0,N) {
          R[indx][i]/=mq[i];
          a+=Sqr(R[indx][i]);
          if (i%3==2) { Max(m,a) a=0; } }
        m=nm.ampl/sqrt(m);
        r[0]=No.s; 
        r[1]=-3;
        fwrite(r,4,2,plb);
        loop (ix,0,abs(nm.frames)) {
          double x=ix/(double)(abs(nm.frames)-1);

          if (nm.frames>0) x=m*cos(x*PI);
          else x=m*(1-2*x);

#ifdef FREEBC
          VO(r,=0)
#else
          VV(r,=box.L)
#endif
          fwrite(r,4,3,plb);
          loop (i,0,No.s) {
            loop (k,0,3) r[k]=CFG->rp[i][k]+R[indx][i*3+k]*x;
            fwrite(r,4,3,plb); } }
        fclose(plb); } 
    prt("normal modes: %s.nm%04d.plb--%s.nm%04d.plb written",simils.simname,from,simils.simname,to-1); 
    prt("recommended command to show normal modes:\n\
  show -h6 -g500x400 -d30 %s %s.nm%%04d.plb -I\\$wwir",simils.simname,simils.simname);
    }
  } /* **R */

  release(A);
  fprintf(stderr,"nm: finished at %s",myctime(mytime()));
}
