/* cc -O2 -o atomdist atomdist.c -lm
 */
#include "../gen/include.h"

typedef float vector[3];
#define VVV(A,B,C) { A[0] B[0] C[0]; A[1] B[1] C[1]; A[2] B[2] C[2]; }
#define SQR(A) (A[0]*A[0]+A[1]*A[1]+A[2]*A[2])

int main(int narg,char **arg)
{
  int i,j,i1,i2,ns=-1,n=0,k;
  FILE *f;
  float h[2];
  vector r,r1,r2;
  vector *cfg=NULL;

  double dr[3];
  double rr,sumrr=0,L=0;

  if (narg<4) {
    fprintf(stderr,"atom-atom distances from playback files\n\
call by:\n\
  %s FILE INDEX1 INDEX2 [NS|0]\n\
where FILE is the playback file (with extension .plb, .p00, ...)\n\
INDEX1 and INDEX2 are atom indices (see the mol-file)\n\
INDEX1<0 : calculates the minimum distance from INDEX2\n\
INDEX1<0, INDEX2<0 : calculates the minimum distance (all pairs)\n\
NS is the number of sites to be provided if FILE is a 3db file (w/o header)\n\
NS=0 causes box size L in the playback file to be ignored (free b.c.)\n",
            arg[0]);
    exit(0); }

  i1=atoi(arg[2]);
  i2=atoi(arg[3]);
  if (i1<0 && i2>0) {
    i2=atoi(arg[2]);
    i1=atoi(arg[3]); }

  if (narg>4) ns=atoi(arg[4]);
  if (ns==0) L=-1;

  f=fopen(arg[1],"rb");
  if (!f) { Error("file not found"); exit(-1); }

  if (ns<=0) {
    if (1!=fread(h,sizeof(h),1,f)) { Error("no header"); exit(-2); }
    ns=(int)h[0];
    if (L==0) L=h[1]; }

  if (i2<0 || i2<0) {
    allocarray(cfg,ns);
    for (;;) {
      double minrr=9e9;

      if (ns!=fread(cfg,sizeof(r),ns,f)) goto end;

      if (i2<0 && i2<0) {
        loop (i,0,ns)
          loop (j,0,i) {
            VVV(dr,=cfg[i],-cfg[j])
            if (L>0)
              loop (k,0,3) {
                while (dr[k]<-L/2) dr[k]+=L;
                while (dr[k]>L/2) dr[k]-=L; }
            rr=SQR(dr);
            Min(minrr,rr) }
        printf("%9.6f\n",sqrt(minrr));
        sumrr+=minrr; n++; }
      else {
        loop (i,0,ns) {
          VVV(dr,=cfg[i1],-cfg[i])
          if (L>0)
            loop (k,0,3) {
              while (dr[k]<-L/2) dr[k]+=L;
	      while (dr[k]>L/2) dr[k]-=L; }
	  rr=SQR(dr);
	  Min(minrr,rr) }
        printf("%9.6f\n",sqrt(minrr));
        sumrr+=minrr; n++; }
    } }
  else 
    for (;;) {
      loop (i,0,ns) {
        if (1!=fread(r,sizeof(r),1,f)) goto end;
        if (i==i1) copy(r1,r,sizeof(r));
        if (i==i2) copy(r2,r,sizeof(r)); }
      VVV(dr,=r1,-r2)
      if (L>0)
        loop (k,0,3) {
        while (dr[k]<-L/2) dr[k]+=L;
        while (dr[k]>L/2) dr[k]-=L; }
      rr=SQR(dr);
      printf("%9.6f\n",sqrt(rr));
      sumrr+=rr; n++; }

 end:
  fprintf(stderr,"%d cfgs  <rr>=%g  sqrt(<rr>)=%g  L=%g\n",
          n,sumrr/n,sqrt(sumrr/n),L);
}
