/* cc -O2 -o cutprt cutprt.c

  7/2011: table test: " cycles started at " required before
          WARNING 2 lines only if not ***
  8/2007: table test changed to at least 64 - or =
          moved to util/
*/
#include "../gen/include.h"

void cr(char *l)
/* converts CR [LF] into LF */
{
  char *c=strchr(l,13);
 
  if (c) {
    *c++='\n';
    if (*c=='\n') *c=0; }
}

#define LINE 1024

int main(int narg,char **arg)
{
  int i,j,filter,started,ended;
  FILE *in,*out;
  char last[LINE]="?\n",line[LINE],fn[256],l0[80],l1[80];
  struct ll_s {
    struct ll_s *next;
    char *l; 
  } *head=NULL,*l,**la,*lnext;
  char *tmp="cutprt$.tmp";

  if (narg<2) {
    fprintf(stderr,"Shortens prt-files leaving first header and final statistics. Call by:\n\
   cutprt [-]FILE.prt [[-]FILE.prt ...]\n\
FILE.prt:  rewrites file, old one renamed to FILE.%s, time stamp copied\n\
-FILE.prt: output to stdout"
#ifdef DOS
   ,"prx"
#else
   "\n","prt~"
#endif
      );
    exit(0); }

  loop (i,1,narg) {
    filter=arg[i][0]=='-';
    fprintf(stderr,"opening %s (%s)\n",
	    arg[i]+filter,filter?"to stdout":"backup and replace");

    if (!filter) {
      strcpy(fn,arg[i]+filter);
#ifdef DOS
      fn[strlen(fn)-1]='x';
#else
      strcat(fn,"~");
#endif
      out=fopen(tmp,"wt");
      if (!out) Error("cannot open tmp file"); }
    else
      out=stdout;

    in=fopen(arg[i]+filter,"rt");
    if (!in) Error(arg[i]+filter);

    /* copying everything until START if the FIRST main table */
    started=0;
    for (;;) {
      if (!fgets(line,LINE,in)) Error("main table not found");
      cr(line);
      fputs(line,out);
      if (strstr(line," cycles started at ") || strstr(line," cycle started at ")) started++;
      if (started && !memcmp(line,"----------------------------------------------------------------",64)) break; 
    }

    /* several first lines of the FIRST main table */
    ended=0;
    loop (j,0,3) {
      if (!fgets(line,LINE,in)) Error("no end of main table");
      cr(line);
      if (!memcmp(line,"================================================================",64)) ended=1;
      if (strstr(line,"WARNING")) j--;
      if (strstr(line,"WARNING:")) j--;
      if (!memcmp(line,"*** WARNING in ",15)) j-=4;
      fputs(line,out); 
    }

    alloczero(head,sizeof(*head));
    la=&head; l=head;

    for (;;) {
      int prtit=0; /* printed lines after WARNING etc. */
      char *nl;
      
      memset(l0,0,80);
      memset(l1,0,80);

      if (!ended) {
        if (!fgets(line,LINE,in)) goto end;
        cr(line); }

      if (ended || !memcmp(line,"================================================================",64)) {
        /* possible END of the LAST main table */
	strcpy(last,l->l);
	for (l=head; l; l=lnext) {
	  if (strstr(l->l,"ERROR")) prtit=5; /* should not happen, but.. */
	  if (strstr(l->l,"WARNING")) {
	    prtit=2;
            if (strstr(l->l,"WARNING:")) prtit=3;
	    if (!memcmp(l->l,"*** WARNING in ",15)) prtit=5; }
	  if (prtit) {
	    if (prtit==5) {
	      if (*l1) fprintf(out,"...\n%s\n",l1);
	      if (*l0) fprintf(out,"%s\n",l0); }
	    fputs(l->l,out); 
	    if (prtit>2) fputs(l->l,stderr); 
	    prtit--; }
	  if (strlen(l0)>79) Error("internal");
	  strcpy(l1,l0);
	  if (!l->l) Error("internal");
	  memcpy(l0,l->l,79);
	  if (nl=strchr(l0,'\n')) *nl=0;

	  free(l->l); lnext=l->next; free(l); }
	la=&head; }
      ended=0;

      alloczero(*la,sizeof(struct ll_s));
      if (!((*la)->l=strdup(line))) Error("no heap");
      l=*la;
      la=&((*la)->next); }

  end:
    fclose(in);
    fputs("...\n",out);
    fputs(last,out);
    for (l=head; l; l=l->next) fputs(l->l,out);

    if (!filter) {
      fclose(out);

      if (!remove(fn)) fprintf(stderr,"%s removed\n",fn);
      fprintf(stderr,"renaming %s to %s\n",arg[i],fn);
      if (rename(arg[i],fn)) Error("could not rename");
      fprintf(stderr,"renaming temporary %s to %s\n",tmp,arg[i]);
      if (rename(tmp,arg[i])) Error("could not rename temporary file\n"); 
      fprintf(stderr,"copying time stamp\n");
      if (system(string("touch -r \"%s\" \"%s\"",fn,arg[i]))) 
        fprintf(stderr,"%s: cannot copy time stamp\n",arg[i]); } }

  return 0;
}
